package ru.microem.reader.usb_bluetooth_test.ui.sam;

import android.content.Context;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.EditText;
import android.widget.TextView;

import java.text.SimpleDateFormat;
import java.util.Date;

import androidx.annotation.Nullable;
import androidx.annotation.NonNull;
import androidx.fragment.app.Fragment;
import androidx.lifecycle.Observer;
import androidx.lifecycle.ViewModelProviders;
import ru.microem.reader.usb_bluetooth_test.MainActivity;
import ru.microem.reader.usb_bluetooth_test.R;
import ru.microem.readerlibrary.UemReader;

public class SamFragment extends Fragment {

    private SamViewModel samViewModel;

    private View mRoot = null;

    public View onCreateView(@NonNull LayoutInflater inflater,
                             ViewGroup container, Bundle savedInstanceState) {
        samViewModel =
                ViewModelProviders.of(this).get(SamViewModel.class);
        View root = inflater.inflate(R.layout.fragment_sam, container, false);
        final TextView textView = root.findViewById(R.id.text_sam);
        samViewModel.getText().observe(this, new Observer<String>() {
            @Override
            public void onChanged(@Nullable String s) {
                textView.setText(s);
            }
        });

        mRoot = root;

        ((MainActivity)getActivity()).mSamFragment = this;

        SharedPreferences sharedPref = getActivity().getPreferences(Context.MODE_PRIVATE);
        ((EditText)root.findViewById(R.id.sam_holder)).setText(sharedPref.getString("sam_holder", ""));
        ((EditText)root.findViewById(R.id.sam_send_apdu)).setText(sharedPref.getString("sam_send_apdu", "80 60 00 00 00"));
        ((EditText)root.findViewById(R.id.sam_received_apdu)).setText(sharedPref.getString("sam_received_apdu", ""));
        ((EditText)root.findViewById(R.id.sam_key_number)).setText(sharedPref.getString("sam_key_number", "0"));
        ((EditText)root.findViewById(R.id.sam_key_version)).setText(sharedPref.getString("sam_key_version", "0"));
        ((EditText)root.findViewById(R.id.sam_key)).setText(sharedPref.getString("sam_key", "00000000000000000000000000000000"));
        ((TextView)root.findViewById(R.id.sam_log)).setText(sharedPref.getString("sam_log", ""));

        return root;
    }

    public void onPause() {
        SharedPreferences sharedPref = getActivity().getPreferences(Context.MODE_PRIVATE);
        sharedPref.edit().putString("sam_holder", ((EditText)mRoot.findViewById(R.id.sam_holder)).getText().toString()).apply();
        sharedPref.edit().putString("sam_send_apdu", ((EditText)mRoot.findViewById(R.id.sam_send_apdu)).getText().toString()).apply();
        sharedPref.edit().putString("sam_received_apdu", ((EditText)mRoot.findViewById(R.id.sam_received_apdu)).getText().toString()).apply();
        sharedPref.edit().putString("sam_key_number", ((EditText)mRoot.findViewById(R.id.sam_key_number)).getText().toString()).apply();
        sharedPref.edit().putString("sam_key_version", ((EditText)mRoot.findViewById(R.id.sam_key_version)).getText().toString()).apply();
        sharedPref.edit().putString("sam_key", ((EditText)mRoot.findViewById(R.id.sam_key)).getText().toString()).apply();
        sharedPref.edit().putString("sam_log", ((TextView)mRoot.findViewById(R.id.sam_log)).getText().toString()).apply();

        super.onPause();
    }

    public void onSamCommands(View view) {
        EditText holder = mRoot.findViewById(R.id.sam_holder);
        TextView log = mRoot.findViewById(R.id.sam_log);
        EditText send = mRoot.findViewById(R.id.sam_send_apdu);
        EditText rec = mRoot.findViewById(R.id.sam_received_apdu);
        EditText keyNumber = mRoot.findViewById(R.id.sam_key_number);
        EditText keyVersion = mRoot.findViewById(R.id.sam_key_version);
        EditText key = mRoot.findViewById(R.id.sam_key);

        switch(view.getId()) {
            case R.id.sam_get_holder:
                int nHolder = ((MainActivity) getActivity()).mUemR.SAM.getCurrentHolder();
                /*log.getEditableText().insert(0, String.format("Get Current Holder: %s, Status: 0x%02x\n",
                        ((MainActivity) getActivity()).mUemR.getLastError(),
                        ((MainActivity) getActivity()).mUemR.getLastErrorCode()
                ));*/
                //log.setText((new SimpleDateFormat("yyyy.MM.dd G 'at' HH:mm:ss z\n")).format(new Date()) + log.getText());

                /*log.setText(String.format("Get Current Holder: %s, Status: 0x%02x\n",
                        ((MainActivity) getActivity()).mUemR.getLastError(),
                        ((MainActivity) getActivity()).mUemR.getLastErrorCode()
                ) + log.getText());
                log.setText((new SimpleDateFormat("yyyy.MM.dd HH:mm:ss\n")).format(new Date()) + log.getText());*/
                ((MainActivity) getActivity()).appendLog(log, "Get Current Holder", String.format("%s, Status: 0x%02x",
                        ((MainActivity) getActivity()).mUemR.getLastError(),
                        ((MainActivity) getActivity()).mUemR.getLastErrorCode()
                ));
                /*log.append(String.format("Get Current Holder: %s, Status: 0x%02x\n",
                        ((MainActivity) getActivity()).mUemR.getLastError(),
                        ((MainActivity) getActivity()).mUemR.getLastErrorCode()
                ));*/
                if (((MainActivity) getActivity()).mUemR.getLastError().equals(UemReader.UEM_STATUS_SUCCESS)) {
                    holder.setText(String.valueOf(nHolder));
                }
                //Toast.makeText(getActivity().getApplicationContext(), String.valueOf(((MainActivity) getActivity()).mUemR.SAM.currentHolder), Toast.LENGTH_SHORT).show();
                break;
            case R.id.sam_set_holder:
                byte[] atr = ((MainActivity) getActivity()).mUemR.SAM.setCurrentHolder(Integer.parseInt(holder.getText().toString()));
                /*log.append(String.format("Set Current Holder: %s, Status: 0x%02x\n",
                        ((MainActivity) getActivity()).mUemR.getLastError(),
                        ((MainActivity) getActivity()).mUemR.getLastErrorCode()
                ));*/
                ((MainActivity) getActivity()).appendLog(log, "Set Current Holder", String.format("%s, Status: 0x%02x",
                        ((MainActivity) getActivity()).mUemR.getLastError(),
                        ((MainActivity) getActivity()).mUemR.getLastErrorCode()
                ), ((MainActivity) getActivity()).mUemR.getLastError().equals(UemReader.UEM_STATUS_SUCCESS)?String.format("ATR: %s",
                        UemReader.Helper.byteArrayToHexString(atr)):null
                );
                //Toast.makeText(getActivity().getApplicationContext(), String.valueOf(((MainActivity) getActivity()).mUemR.SAM.currentHolder), Toast.LENGTH_SHORT).show();
                break;
            case R.id.sam_cold_reset:
                ((MainActivity) getActivity()).mUemR.SAM.resetCold();
                ((MainActivity) getActivity()).appendLog(log, "Cold Reset", String.format("%s, Status: 0x%02x",
                        ((MainActivity) getActivity()).mUemR.getLastError(),
                        ((MainActivity) getActivity()).mUemR.getLastErrorCode()
                ));
                break;
            case R.id.sam_kill_auth_card:
                ((MainActivity) getActivity()).mUemR.SAM.killCardAuthentication();
                ((MainActivity) getActivity()).appendLog(log, "Kill Card Authentication", String.format("%s, Status: 0x%02x",
                        ((MainActivity) getActivity()).mUemR.getLastError(),
                        ((MainActivity) getActivity()).mUemR.getLastErrorCode()
                ));
                break;
            case R.id.sam_transmit_apdu:
                //Toast.makeText(getActivity().getApplicationContext(), String.valueOf(UemReader.Helper.hexStringToByteArray(send.getText().toString()).length), Toast.LENGTH_SHORT).show();
                byte[] res = ((MainActivity) getActivity()).mUemR.SAM.transceiveAPDU(UemReader.Helper.hexStringToByteArray(send.getText().toString()));
                ((MainActivity) getActivity()).appendLog(log, "Transmit APDU", String.format("%s, Status: 0x%02x, SW1=0x%02x SW2=0x%02x",
                        ((MainActivity) getActivity()).mUemR.getLastError(),
                        ((MainActivity) getActivity()).mUemR.getLastErrorCode(),
                        ((MainActivity) getActivity()).mUemR.SAM.SW[0],
                        ((MainActivity) getActivity()).mUemR.SAM.SW[1]
                        ), ((MainActivity) getActivity()).mUemR.getLastError().equals(UemReader.UEM_STATUS_SUCCESS)?String.format("Response: %s",
                        UemReader.Helper.byteArrayToHexString(res)):null
                );
                if (res != null) {
                    rec.setText(UemReader.Helper.byteArrayToHexString(res));
                }
                break;
            case R.id.sam_authenticate_host:
                ((MainActivity) getActivity()).mUemR.SAM.authenticateHost(0, 0, 4,
                        Integer.decode(keyNumber.getText().toString()).byteValue(),
                        Integer.decode(keyVersion.getText().toString()).byteValue(),
                        UemReader.Helper.hexStringToByteArray(key.getText().toString())
                );
                ((MainActivity) getActivity()).appendLog(log, "Authenticate Host", String.format("%s, Status: 0x%02x, SW1=0x%02x SW2=0x%02x",
                        ((MainActivity) getActivity()).mUemR.getLastError(),
                        ((MainActivity) getActivity()).mUemR.getLastErrorCode(),
                        ((MainActivity) getActivity()).mUemR.SAM.SW[0],
                        ((MainActivity) getActivity()).mUemR.SAM.SW[1]
                ));
                break;
            default:
        }
    }
}