/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*-  */
/*
 * interface.cc
 * Copyright (C) 2021 MicroEM JSC <support@microem.ru>
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name ``MicroEM JSC'' nor the name of any other
 *    contributor may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 * 
 * CLESCAR IS PROVIDED BY MicroEM JSC ``AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL MicroEM JSC OR ANY OTHER CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "interface.h"

extern PVOID m_pReader;

bool m_isOpened = false;

Gtk::Button* btn_interface_open;

void on_btnOpenInterface_clicked()
{
    LONG Status;
    DWORD PortIndex = 0;
	
    //std::cout << "Hello World" << std::endl;

	if (!m_isOpened)
	{
		Status = CLSCRF_OpenUSB( m_pReader, PortIndex, 0 );

		if( Status == 0 )
		{
			Status = CLSCRF_Sound( m_pReader, 1 );
		    printf("Interface USB(%d) is opened successfully\n", PortIndex);
			//btn_interface_open->set_use_markup(true);
			btn_interface_open->set_label("Close Interface");
			m_isOpened = true;
		}
		else
		{
		    printf("Interface USB(%d) is not opened\n", PortIndex);
		}
	}
	else
	{
		Status = CLSCRF_Close( m_pReader );

		if( Status == 0 )
		{
        	printf("Interface is closed successfully\n");
			btn_interface_open->set_label("Open Interface");
			m_isOpened = false;
		}
    	else
        	printf("Interface is not closed\n");
	}
}