
//===========================================================================
//                CONTACTLESS CARD READER's FUNCTION LIBRARY
//===========================================================================

// Clscrfl.h : main header file for the CLSCRFL DLL

//     -    
//  
//===========================================================================
//      
//---------------------------------------------------------------------------
//   
//   
//   RS-
//   USB-
//  ,   
//   
//    
//    
//      
//===========================================================================
//       
//---------------------------------------------------------------------------
//    
//   -
//   -
//    -
//     -
//     
//       
//    
//   
//        COM-
//===========================================================================
//         14443-A
//---------------------------------------------------------------------------
//    14443-   IDLE
//    14443-   HALT
//    14443-   HALT
//===========================================================================
//         14443-B
//---------------------------------------------------------------------------
//    14443-   IDLE
//    14443-
//    14443-   HALT
//    14443-   HALT
//===========================================================================
//         15693
//---------------------------------------------------------------------------
//     15693
//    15693   QUIET
//===========================================================================
//         Mifare Standard
//---------------------------------------------------------------------------
//   
//    
//     EEPROM 
//      EEPROM
//   
//   
//   
//   
//   
//===========================================================================
//         Mifare Ultralight
//---------------------------------------------------------------------------
//   
//   
//===========================================================================
//          15693
//---------------------------------------------------------------------------
//   
//   


//===========================================================================
//        
//---------------------------------------------------------------------------
//     
//      
//===========================================================================
//          RS485
//---------------------------------------------------------------------------
//    
//    
//    
//    
//===========================================================================

//      :
//          0 -  
// 0x80100001 -   ,     
//                 CLSCRF_GetLastInternalError



#if !defined(AFX_CLSCRFL_H__CE290562_87D9_41F4_A1CD_3B80EFEBA737__INCLUDED_)
#define AFX_CLSCRFL_H__CE290562_87D9_41F4_A1CD_3B80EFEBA737__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#ifdef CLSCRFL_EXPORTS
#define CLSCRFL_API __declspec(dllexport)
#else
#define CLSCRFL_API __declspec(dllimport)
#endif

#include "types_def.h"
#include "SCardErr.h"

#ifndef _LPCBYTE_DEFINED
#define _LPCBYTE_DEFINED
typedef const BYTE *LPCBYTE;
#endif

#define STRING_VERSION      "0.3"

//#define ADDRESS_RS_485      1

//                                  0    1    2    3    4    5    6    7
static DWORD cDecodeBufSize [] = {  16,  24,  32,  40,  48,  64,  96, 128, 
//                                  8    9   10   11   12   13   14   15
                                   256, 256, 256, 256, 256, 256, 256, 256 };

const unsigned char cPCD_FSDI = 5;        // PCD FIFO Size = 64

const DWORD cPCD_BufSize = cDecodeBufSize[cPCD_FSDI];

//
//
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//===========================================================================
//                                  
//===========================================================================
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//   
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_Create( IN OUT LPVOID* ppReader );
//
//  -
//
// ppReader -  ,       
//            -       
//              
//
//  :  0   -  
//                        -   
//
//     1     
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//   
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_Destroy( IN LPVOID* ppReader );
//
//  -
//
// ppReader -  ,     
//            - (.  CLSCRF_Create )
//
//  :  0   -  
//                        -   
//
//     1     
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//   
//---------------------------------------------------------------------------

CLSCRFL_API LONG __stdcall 
            CLSCRF_Open( IN LPVOID pReader,
                         IN DWORD  dwPortNumber = 0,
                         IN DWORD  dwBaudrate = 9600,
                         IN DWORD  dwLogFile = 0 );
//
//  ,      
//  .    
//    CLSCRF_OpenRS  CLSCRF_OpenUSB
//
//  
//
// pReader      -    - (. 
//                CLSCRF_Create )
// dwPortNumber -  : 0 -  USB
//                                  1 -   COM1
//                                  2 -   COM2
//                                  3 -   COM3  ..
// dwBaudrate   -    COM-
// dwLogFile    -     : 1 -  
//                                                0 -   
//
//  :  0   -  
//                        -   
//
//     1      
//         COM-
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//   RS-
//---------------------------------------------------------------------------

CLSCRFL_API LONG __stdcall 
            CLSCRF_OpenRS( IN LPVOID pReader,
                           IN DWORD  dwIndex = 0,
                           IN DWORD  dwBaudrate = 9600,
                           IN DWORD  dwLogFile = 0 );
//
//  COM- ( RS232  RS485)
//
// pReader    -    - (. 
//              CLSCRF_Create )
// dwIndex    -  COM-  0 ( 0 - COM1, 1 - COM2  ..)
// dwBaudrate -    COM-
// dwLogFile  -     : 1 -  
//                                              0 -   
//
//  :  0   -  
//                        -   
//
//     1      
//         COM-
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//   USB-
//---------------------------------------------------------------------------

CLSCRFL_API LONG __stdcall 
            CLSCRF_OpenUSB( IN LPVOID pReader,
                            IN DWORD  dwIndex = 0,
                            IN DWORD  dwLogFile = 0 );
//
//  USB-
//
// pReader   -    - (. 
//             CLSCRF_Create )
// dwIndex   -  USB-     0
// dwLogFile -     : 1 -  
//                                             0 -   
//
//  :  0   -  
//                        -   
//
//     1      
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//  ,   
//---------------------------------------------------------------------------
//
CLSCRFL_API bool __stdcall 
            CLSCRF_IsOpened( IN LPVOID pReader );
//
//   
//
// pReader -   - (.  CLSCRF_Create )
//
//  :  0   -  
//                         1   -  
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//   
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_Close( IN LPVOID pReader );
//
//  
//
// pReader -    - (.  
//           CLSCRF_Create )
//
//  :  0   -  
//                        -   
//
//     1    
//         COM-
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//    
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_GetIOTimeout( IN     LPVOID  pReader,
                                    OUT LPDWORD pdwTimeout );
//
//       
//
// pReader    -   - (.  CLSCRF_Create )
// pdwTimeout -    DWORD,    
//                 
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//    
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_SetIOTimeout( IN LPVOID pReader,
                                 IN DWORD  dwTimeout );
//
//        :
//    -      
//    -    
//    -      
//    -    
//     ,  1000 
//          
//
// pReader   -   - (.  CLSCRF_Create )
// dwTimeout -    .     0,
//                  (1000 )
//                0   50 
//                86400000 
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//      
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_GetLastInternalError( IN     LPVOID pReader,
                                            OUT LPBYTE pbError );
//
//         0x80100001,
//       
//        
//       0xff -   
//
// pReader  -   - (.  CLSCRF_Create )
// pbError  -    unsigned char,    
//                
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//===========================================================================
//                                     
//===========================================================================
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//    
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_GetState( IN     LPVOID  pReader,
                                OUT LPDWORD pdwState );
//
//   
//
// pReader  -   - (.  CLSCRF_Create )
// pdwState -     DWORD,     
//              :
//
//   31-16 - 
//    15    - - 
//    14    -   
//   13-9  - 
//    8     -     
//   7-5   - 
//    4     -  ISO/IEC 14443-B
//   3-2   -   (     )
//               00 - 106 
//               01 - 212 
//               10 - 424 
//               11 - 848 
//   1-0   -   (     )
//               00 - 106 
//               01 - 212 
//               10 - 424 
//               11 - 848 
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//   -
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_Mfrc_On( IN LPVOID pReader );
//
//  -
//
// pReader -   - (.  CLSCRF_Create )
//
//  :  0   -  
//                        -   
//
// .   -   
//   200 mA.
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//   -
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_Mfrc_Off( IN LPVOID pReader );
//
//  -
//
// pReader -   - (.  CLSCRF_Create )
//
//  :  0   -  
//                        -   
//
// .   -  
// ,      ,    .
//  ,       
//   -  25 mA.
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//    -
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_Get_Mfrc_Version( IN     LPVOID pReader,
                                        OUT LPBYTE pbMfrcVersion );
//
//    ( .. ) -
//
// pReader       -   - (.  CLSCRF_Create )
// pbMfrcVersion -    unsigned char,    
//                  6   ,  
//                 4  -   -
//                 1   -  -
//                 1   -   
// :
//      Mfrc530   30 88 FE 03 04 01
//      Mfrc531   30 CC FF 0F 04 01
//      Mfrc632   30 FF FF 0F 04 01
//      04,   01
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//     -
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_Get_Mfrc_Serial_Number( IN     LPVOID pReader,
                                              OUT LPBYTE pbMfrcSN );
//
//   ()  -
//
// pReader  -   - (.  CLSCRF_Create )
// pbMfrcSN -    unsigned char,    
//             4   
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//     
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_Mfrc_Rf_Off_On( IN LPVOID pReader,
                                   IN USHORT usDelay );
//
//      () 
//       
//
// pReader -   - (.  CLSCRF_Create )
// usDelay -   [],     . 
//               0,    
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//       
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_Mfrc_Set_Rf_Mode( IN LPVOID pReader,
                                     IN BYTE   bRfMode );
//
//        
//        
//
// pReader -   - (.  CLSCRF_Create )
// bRfMode -    :
//     7-4 - 0000 -  ISO/IEC 14443-A
//               0001 -  ISO/IEC 14443-B
//               0100 -  ISO/IEC 15693
//     3-2 -   (     )
//               00 - 106 
//               01 - 212 
//               10 - 424 
//               11 - 848 
//     1-0 -   (     )
//               00 - 106 
//               01 - 212 
//               10 - 424 
//               11 - 848 
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//    
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_Sound( IN LPVOID pReader,
                          IN BYTE   nBeepCount );
//
//   
//
// pReader    -   - (.  CLSCRF_Create )
// nBeepCount -     100   
//                 .   0,  
//                   
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//   
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_Led( IN LPVOID pReader,
                        IN BYTE   bBlinkColor,
                        IN BYTE   bBlinkCount,
                        IN BYTE   bPostColor );
//
//   ,      
//   - 2 
//
// pReader     -   - (.  CLSCRF_Create )
// bBlinkColor -   :
//                0   -  
//                1   -  
//                2   -  
//                3   -  -
// bBlinkCount -   ( 0 -  )
// bPostColor  -   :
//                0   - 
//                1   -  
//                2   -  
//                3   -  -
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//        COM-
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_UART_Baudrate( IN LPVOID pReader,
                                  IN DWORD  dwBaudrate );
//
//       COM-
//
// pReader    -   - (.  CLSCRF_Create )
// dwBaudrate -     COM-;  :
//                  9600
//                 14400
//                 19200
//                 38400
//                 57600
//                115200
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//===========================================================================
//                                        A
//===========================================================================
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//    14443-   IDLE
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_Activate_Idle_A( IN     LPVOID  pReader,
                                       OUT LPBYTE  pbATQ,
                                       OUT LPBYTE  pbSAK,
                                       OUT LPBYTE  pbUID,
                                    IN OUT LPDWORD pdwUIDLength );
//
//   14443-   IDLE (. ISO/IEC 14443-3 .6.3)
//
// pReader -   - (.  CLSCRF_Create )
// pbATQ   -    (2 ),     ATQ 
// pbSAK   -    (1 ),     SAK 
// pbUID   -      10 ,   
//               (UID)
// pdwUIDLength -     DWORD,   
//                     pbUID,   
//                     
//                 ,    pbUID
//                (  - 4, 7  10)
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//    14443-   HALT
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_Halt_A( IN LPVOID pReader );
//
//   14443-   HALT (. ISO/IEC 14443-3 .6.3)
//
// pReader -   - (.  CLSCRF_Create )
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//    14443-   HALT
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_Activate_Wakeup_A( IN     LPVOID  pReader,
                                      IN     LPBYTE  pbUID,
                                      IN     DWORD   UIDLength,
                                         OUT LPBYTE  pbATQ,
                                         OUT LPBYTE  pbSAK );

//   14443-   HALT (. ISO/IEC 14443-3 .6.3)
//
// pReader -   - (.  CLSCRF_Create )
// pbUID   -      10 ,     
//                  (UID)
// UIDLength -    ,  
//               pbUID
// pbATQ -    (2 ),     ATQ 
// pbSAK -    (1 ),     SAK 
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//===========================================================================
//                                        B
//===========================================================================
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//    14443-   IDLE
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_Activate_Idle_B( IN     LPVOID  pReader,
                                    IN     BYTE    bAfi,
                                    IN     BYTE    bSni,
                                       OUT LPDWORD pdwPUPI,
                                       OUT LPDWORD pdwAppData,
                                       OUT LPDWORD pdwProtInfo,
                                    IN OUT LPDWORD pdwCardCount );
//
//   14443-   IDLE (. ISO/IEC 14443-3 .7.7)
//
// pReader -   - (.  CLSCRF_Create )
// bAfi    -   
// bSni    -     ( 0  4),   
//                2 ^ bSni
// pdwPUPI -     DWORD  16,   
//               ,
//            4       
// pdwAppData -     DWORD  16,   
//                    ,
//               4       
// pdwProtInfo -     DWORD  16,   
//                    ,
//                3         
//                0  23
// pdwCardCount -     DWORD,   
//                     pdwPUPI, 
//                pdwAppData  pdwProtInfo,      
//                   ( 0  16)
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//    14443-
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_Attrib_B( IN     LPVOID  pReader,
                             IN     LPBYTE  pbPUPI,
                             IN     BYTE    bParam1,
                             IN     BYTE    bParam2,
                             IN     BYTE    bParam3,
                             IN     BYTE    bParam4,
                             IN OUT LPBYTE  pbHigherLayerBuf,
                             IN     DWORD   dwHLBufSize,
                             IN OUT LPDWORD pdwHLInfLength,
                                OUT LPBYTE  pbMbliCid );
//
//   14443- (. ISO/IEC 14443-3 .7.10)    
//   CID      T = CL 
// (. ISO/IEC 14443-4)
//
// pReader -   - (.  CLSCRF_Create )
// pdwPUPI -     DWORD  16,   
//               ,
//            4       
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//    14443-   HALT
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_Halt_B( IN LPVOID pReader,
                           IN LPBYTE pbPUPI );
//
//   14443-   HALT (. ISO/IEC 14443-3 .7.12)
//
// pReader -   - (.  CLSCRF_Create )
// pbPUPI  -    (4 ),   
//              
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//    14443-   HALT
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_Activate_Wakeup_B( IN     LPVOID  pReader,
                                      IN     BYTE    bAfi,
                                      IN     BYTE    bSni,
                                         OUT LPDWORD pdwPUPI,    //16*4 bytes
                                         OUT LPDWORD pdwAppData, //16*4 bytes
                                         OUT LPDWORD pdwProtInfo,//16*4 bytes
                                      IN OUT LPDWORD pdwCardCount );
//
//   14443-   HALT (. ISO/IEC 14443-3 .7.7)
//
// pReader -   - (.  CLSCRF_Create )
// bAfi    -   
// bSni    -     ( 0  4),   
//                2 ^ bSni
// pdwPUPI -     DWORD  16,   
//               ,
//            4       
// pdwAppData -     DWORD  16,   
//                    ,
//               4       
// pdwProtInfo -     DWORD  16,   
//                    ,
//                3         
//                0  23
// pdwCardCount -     DWORD,   
//                     pdwPUPI, 
//                pdwAppData  pdwProtInfo,      
//                   ( 0  16)
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//===========================================================================
//                                1 5 6 9 3
//===========================================================================
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//     15693
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_Inventory_15693( IN     LPVOID  pReader,
                                    IN     BYTE    bFlags,
                                    IN     BYTE    bInventory,
                                    IN     BYTE    bAfi,
                                    IN     BYTE    bMaskLen,
                                    IN     LPCBYTE pbMaskVal, 
                                       OUT LPBYTE  pbRecvBuffer, 
                                    IN OUT LPDWORD pdwRecvLength );
//
//     ISO/IEC 15693
// (. ISO/IEC 15693-3 .10.3.1)
//
// pReader       -   - (.  CLSCRF_Create )
// bFlags        -   (. ISO/IEC 15693-3 .7.3.1)
// bInventory    -   Inventory (  0x01)
// bAfi          -   
// bMaskLen      -   
// pbMaskVal     -  ,  
// pbRecvBuffer  -     
// pdwRecvLength -     DWORD,   
//                      pbRecvBuffer, 
//                        
//                    1  16  
//
//            pbRecvBuffer 
//        :
//
//      RetCode -             - 1 
//      Count   -  ,       - 1 
//  Count   0,      
// (. ISO/IEC 15693 .10.3.1):
//      Flags                                               - 1 
//      DSFID                                               - 1 
//      UID                                                 - 8 
//  RetCode   0,    
//      CRC16                                               - 2 
//
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//    15693   Quiet
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_Stay_Quiet_15693( IN LPVOID pReader,
                                     IN BYTE   bFlags,
                                     IN BYTE   bStayQuiet,
                                     IN LPBYTE pbUID );
//
//     Quiet (. ISO/IEC 15693-3 .10.3.2)
//
// pReader    -   - (.  CLSCRF_Create )
// bFlags     -   (. ISO/IEC 15693-3 .7.3.1)
// bStayQuiet -   Stay Quiet (  0x02)
// pbUID      -    (8 ),   
//                
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//    15693   Selected
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_Select_15693( IN     LPVOID pReader,
                                 IN     BYTE   bFlags,
                                 IN     BYTE   bSelect,
                                 IN     LPBYTE pbUID,
                                    OUT LPBYTE pbFlags,
                                    OUT LPBYTE pbErrorCode );
//
//     Selected (. ISO/IEC 15693-3 .10.4.6)
//
// pReader     -   - (.  CLSCRF_Create )
// bFlags      -   (. ISO/IEC 15693-3 .7.3.1)
// bSelect     -   Select (  0x25)
// pbUID       -    (8 ),   
//                 
// pbFlags     -     BYTE,   
//                  (. ISO/IEC 15693-3 .7.4.1)
// pbErrorCode -     BYTE,   
//                  (. ISO/IEC 15693-3 .7.4.2)
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//    15693   Ready
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_ResetToReady_15693( IN     LPVOID pReader,
                                       IN     BYTE   bFlags,
                                       IN     BYTE   bResetToReady,
                                       IN     LPBYTE pbUID,
                                          OUT LPBYTE pbFlags,
                                          OUT LPBYTE pbErrorCode );
//
//     Ready (. ISO/IEC 15693-3 .10.4.7)
//
// pReader       -   - (.  CLSCRF_Create )
// bFlags        -   (. ISO/IEC 15693-3 .7.3.1)
//                 (   Select_flag)
// bResetToReady -   Reset to ready (  0x26)
// pbUID         -    (8 ),   
//                   ,    NULL 
//                   Select_flag ()
// pbFlags       -     BYTE,   
//                    (. ISO/IEC 15693-3 .7.4.1)
// pbErrorCode   -     BYTE,   
//                    (. ISO/IEC 15693-3 .7.4.2)
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//===========================================================================
//                         M I F A R E   S T A N D A R D
//===========================================================================
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//   
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_MifareStandard_HostCodeKey( IN     LPVOID pReader,
                                               IN     LPBYTE pbUncoded,
                                                  OUT LPBYTE pbCoded );
//
//   Mifare Standard
//
// pReader   -   - (.  CLSCRF_Create )
// pbUncoded -  (6 )  () 
// pbCoded   -  (12 )  
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//    
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_MifareStandard_AuthKey( IN LPVOID pReader,
                                           IN BYTE   bAuthMode,
                                           IN LPBYTE pbUID,
                                           IN DWORD  dwSector,
                                           IN LPBYTE pbCodedKey );
//
//      
//
// pReader    -   - (.  CLSCRF_Create )
// bAuthMode  -  : 0x60 - Key A
//                         0x61 - Key B
// pbUID      -  (4 ),    
// dwSector   -   
// pbCodedKey -  (12 )  
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//     EEPROM 
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_MifareStandard_WriteKeyToE2( IN LPVOID pReader,
                                                IN BYTE   bKeyType,
                                                IN DWORD  dwSector,
                                                IN LPBYTE pbUncoded );
//
//         EEPROM 
//
// pReader   -   - (.  CLSCRF_Create )
// bKeyType  -  : 0x60 - Key A
//                        0x61 - Key B
// dwSector  -  ,    
// pbUncoded -  (6 )  
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//      EEPROM
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_MifareStandard_AuthE2( IN LPVOID pReader,
                                          IN BYTE   bAuthMode,
                                          IN LPBYTE pbUID,
                                          IN DWORD  dwSector );
//
//    ,   EEPROM 
//
// pReader    -   - (.  CLSCRF_Create )
// bAuthMode  -  : 0x60 - Key A
//                         0x61 - Key B
// pbUID      -  (4 ),    
// dwSector   -   
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//   
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_MifareStandard_Read( IN     LPVOID pReader,
                                        IN     DWORD  dwSector,
                                        IN     DWORD  dwBlock,
                                           OUT LPBYTE pbRecvBuffer );
//
//  16       
//
// pReader      -   - (.  CLSCRF_Create )
// dwSector     -  ,   
// dwBlock      -   
// pbRecvBuffer -  (  16 )   
//
//  :  0   -  
//                        -   
//
//         
//       0, ,   Mifare 1K 
//   -    0  3
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//   
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_MifareStandard_Write( IN LPVOID pReader,
                                         IN DWORD  dwSector,
                                         IN DWORD  dwBlock,
                                         IN LPBYTE pbSendBuffer );
//
//  16       
//
// pReader      -   - (.  CLSCRF_Create )
// dwSector     -  ,   
// dwBlock      -   
// pbSendBuffer -  (  16 )   
//
//  :  0   -  
//                        -   
//
//         
//       0, ,   Mifare 1K 
//   -    0  3
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//   
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_MifareStandard_Decrement( IN LPVOID pReader,
                                             IN DWORD  dwSector,
                                             IN DWORD  dwSourceBlock,
                                             IN DWORD  dwValue,
                                             IN DWORD  dwTargetBlock );
//
//     Value
//
// pReader       -   - (.  CLSCRF_Create )
// dwSector      -  ,   
// dwSourceBlock -   
// dwValue       - ,    
// dwTargetBlock -  -,    dwSourceBlock
//
//  :  0   -  
//                        -   
//
//         
//       0, ,   Mifare 1K 
//   -    0  3
//  dwSourceBlock  dwTargetBlock    dwSector
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//   
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_MifareStandard_Increment( IN LPVOID pReader,
                                             IN DWORD  dwSector,
                                             IN DWORD  dwSourceBlock,
                                             IN DWORD  dwValue,
                                             IN DWORD  dwTargetBlock );
//
//     Value
//
// pReader       -   - (.  CLSCRF_Create )
// dwSector      -  ,   
// dwSourceBlock -   
// dwValue       - ,    
// dwTargetBlock -  -,    dwSourceBlock
//
//  :  0   -  
//                        -   
//
//         
//       0, ,   Mifare 1K 
//   -    0  3
//  dwSourceBlock  dwTargetBlock    dwSector
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//   
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_MifareStandard_Restore( IN LPVOID pReader,
                                           IN DWORD  dwSector,
                                           IN DWORD  dwSourceBlock,
                                           IN DWORD  dwTargetBlock );
//
//       Value     
//
// pReader       -   - (.  CLSCRF_Create )
// dwSector      -  ,   
// dwSourceBlock -   
// dwTargetBlock -  -
//
//  :  0   -  
//                        -   
//
//         
//       0, ,   Mifare 1K 
//   -    0  3
//  dwSourceBlock  dwTargetBlock    dwSector
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//===========================================================================
//                        M I F A R E   U L T R A L I G H T
//===========================================================================
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//   
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_MifareUltralight_Read( IN     LPVOID pReader,
                                          IN     BYTE   bPage,
                                             OUT LPBYTE pbRecvBuffer );
//
//  4    
//
// pReader      -   - (.  CLSCRF_Create )
// bPage        -   
// pbRecvBuffer -  (  4 )   
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//   
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_MifareUltralight_Write( IN LPVOID pReader,
                                           IN BYTE   bPage,
                                           IN LPBYTE pbSendBuffer );
//
//  4    
//
// pReader      -   - (.  CLSCRF_Create )
// bPage        -   
// pbSendBuffer -  (  4 )   
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//===========================================================================
//                               1 5 6 9 3
//===========================================================================
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//   
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_ReadSingleBlock_15693( IN     LPVOID pReader,
                                          IN     BYTE   bFlags,
                                          IN     BYTE   bReadSingleBlock,
                                          IN     LPBYTE pbUID,
                                          IN     BYTE   bBlockNumber,
                                             OUT LPBYTE pbFlags,
                                             OUT LPBYTE pbBlockSecurityStatus,
                                             OUT LPBYTE pbData,
                                             OUT LPBYTE pbErrorCode );
//
//  4     (. ISO/IEC 15693-3 .10.4.1)
//
// pReader      -   - (.  CLSCRF_Create )
// bFlags       -   (. ISO/IEC 15693-3 .7.3.1)
// bReadSingleBlock -   Read Single Block (  0x20)
// pbUID        -    (8 ),   
//                  
// bBlockNumber -    ( 0)
// pbFlags      -     BYTE,   
//                   (. ISO/IEC 15693-3 .7.4.1)
// pbBlockSecurityStatus -     BYTE,   
//                              
// pbData       -    (  4 )   
// pbErrorCode  -     BYTE,   
//                   (. ISO/IEC 15693-3 .7.4.2)
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//   
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_WriteSingleBlock_15693( IN     LPVOID pReader,
                                           IN     BYTE   bFlags,
                                           IN     BYTE   bWriteSingleBlock,
                                           IN     LPBYTE pbUID,
                                           IN     BYTE   bBlockNumber,
                                           IN     LPBYTE pbData,
                                              OUT LPBYTE pbFlags,
                                              OUT LPBYTE pbErrorCode );
//
//  4     (. ISO/IEC 15693-3 .10.4.2)
//
// pReader      -   - (.  CLSCRF_Create )
// bFlags       -   (. ISO/IEC 15693-3 .7.3.1)
// bWriteSingleBlock -   Write Single Block (  0x21)
// pbUID        -    (8 ),   
//                  
// bBlockNumber -    ( 0)
// pbData       -    (  4 )  
// pbFlags      -     BYTE,   
//                   (. ISO/IEC 15693-3 .7.4.1)
// pbErrorCode  -     BYTE,   
//                   (. ISO/IEC 15693-3 .7.4.2)
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//   
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_LockBlock_15693( IN     LPVOID pReader,
                                    IN     BYTE   bFlags,
                                    IN     BYTE   bLockBlock,
                                    IN     LPBYTE pbUID,
                                    IN     BYTE   bBlockNumber,
                                       OUT LPBYTE pbFlags,
                                       OUT LPBYTE pbErrorCode );
//
//      (. ISO/IEC 15693-3 .10.4.3)
//
// pReader      -   - (.  CLSCRF_Create )
// bFlags       -   (. ISO/IEC 15693-3 .7.3.1)
// bLockBlock   -   Lock Block (  0x22)
// pbUID        -    (8 ),   
//                  
// bBlockNumber -    ( 0)
// pbFlags      -     BYTE,   
//                   (. ISO/IEC 15693-3 .7.4.1)
// pbErrorCode  -     BYTE,   
//                   (. ISO/IEC 15693-3 .7.4.2)
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//    
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_ReadMultipleBlocks_15693( IN     LPVOID pReader,
                                             IN     BYTE   bFlags,
                                             IN     BYTE   bReadMultipleBlock,
                                             IN     LPBYTE pbUID,
                                             IN     BYTE   bFirstBlockNumber,
                                             IN OUT LPBYTE pbNumberOfBlocks,
                                                OUT LPBYTE pbFlags,
                                                OUT LPBYTE pbBlockSecurityStatus,
                                                OUT LPBYTE pbData,
                                                OUT LPBYTE pbErrorCode );
//
//    (. ISO/IEC 15693-3 .10.4.4)
//
// pReader      -   - (.  CLSCRF_Create )
// bFlags       -   (. ISO/IEC 15693-3 .7.3.1)
// bReadMultipleBlock -   Read Multiple Block (  0x23)
// pbUID        -    (8 ),   
//                  
// bFirstBlockNumber -     ( 0)
// pbNumberOfBlocks -     BYTE,   
//                        ( 0)  
//                    ,       
//                    (  0)   
// pbFlags      -     BYTE,   
//                   (. ISO/IEC 15693-3 .7.4.1)
// pbBlockSecurityStatus -    ( 256 )  BYTE,  
//                               
//                            (    
//                         Option_flag)
// pbData       -    ( 8192 )   
//                ( 4    )
// pbErrorCode  -     BYTE,   
//                   (. ISO/IEC 15693-3 .7.4.2)
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//   AFI
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_WriteAFI_15693( IN     LPVOID pReader,
                                   IN     BYTE   bFlags,
                                   IN     BYTE   bWriteAFI,
                                   IN     LPBYTE pbUID,
                                   IN     BYTE   bAFI,
                                      OUT LPBYTE pbFlags,
                                      OUT LPBYTE pbErrorCode );
//
//  1  AFI (. ISO/IEC 15693-3 .10.4.8)
//
// pReader      -   - (.  CLSCRF_Create )
// bFlags       -   (. ISO/IEC 15693-3 .7.3.1)
// bWriteAFI    -   Write AFI (  0x27)
// pbUID        -    (8 ),   
//                  
// bAFI         -   AFI
// pbFlags      -     BYTE,   
//                   (. ISO/IEC 15693-3 .7.4.1)
// pbErrorCode  -     BYTE,   
//                   (. ISO/IEC 15693-3 .7.4.2)
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//   AFI
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_LockAFI_15693( IN     LPVOID pReader,
                                  IN     BYTE   bFlags,
                                  IN     BYTE   bLockAFI,
                                  IN     LPBYTE pbUID,
                                     OUT LPBYTE pbFlags,
                                     OUT LPBYTE pbErrorCode );
//
//  AFI   (. ISO/IEC 15693-3 .10.4.9)
//
// pReader      -   - (.  CLSCRF_Create )
// bFlags       -   (. ISO/IEC 15693-3 .7.3.1)
// bLockAFI     -   Lock AFI (  0x28)
// pbUID        -    (8 ),   
//                  
// pbFlags      -     BYTE,   
//                   (. ISO/IEC 15693-3 .7.4.1)
// pbErrorCode  -     BYTE,   
//                   (. ISO/IEC 15693-3 .7.4.2)
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//   DSFID
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_WriteDSFID_15693( IN     LPVOID pReader,
                                     IN     BYTE   bFlags,
                                     IN     BYTE   bWriteDSFID,
                                     IN     LPBYTE pbUID,
                                     IN     BYTE   bDSFID,
                                        OUT LPBYTE pbFlags,
                                        OUT LPBYTE pbErrorCode );
//
//  1  DSFID (. ISO/IEC 15693-3 .10.4.10)
//
// pReader      -   - (.  CLSCRF_Create )
// bFlags       -   (. ISO/IEC 15693-3 .7.3.1)
// bWriteDSFID  -   Write DSFID (  0x29)
// pbUID        -    (8 ),   
//                  
// bDSFID       -   DSFID
// pbFlags      -     BYTE,   
//                   (. ISO/IEC 15693-3 .7.4.1)
// pbErrorCode  -     BYTE,   
//                   (. ISO/IEC 15693-3 .7.4.2)
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//   DSFID
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_LockDSFID_15693( IN     LPVOID pReader,
                                    IN     BYTE   bFlags,
                                    IN     BYTE   bLockDSFID,
                                    IN     LPBYTE pbUID,
                                       OUT LPBYTE pbFlags,
                                       OUT LPBYTE pbErrorCode );
//
//  DSFID   (. ISO/IEC 15693-3 .10.4.11)
//
// pReader      -   - (.  CLSCRF_Create )
// bFlags       -   (. ISO/IEC 15693-3 .7.3.1)
// bLockDSFID   -   Lock DSFID (  0x2a)
// pbUID        -    (8 ),   
//                  
// pbFlags      -     BYTE,   
//                   (. ISO/IEC 15693-3 .7.4.1)
// pbErrorCode  -     BYTE,   
//                   (. ISO/IEC 15693-3 .7.4.2)
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//    
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_GetSystemInfo_15693( IN     LPVOID pReader,
                                        IN     BYTE   bFlags,
                                        IN     BYTE   bGetSystemInfo,
                                        IN OUT LPBYTE pbUID,
                                           OUT LPBYTE pbFlags,
                                           OUT LPBYTE pbInfoFlags,
                                           OUT LPBYTE pbDSFID,
                                           OUT LPBYTE pbAFI,
                                           OUT LPWORD pbMemorySize,
                                           OUT LPBYTE pbICReference,
                                           OUT LPBYTE pbErrorCode );
//
//     (. ISO/IEC 15693-3 .10.4.12)
//
// pReader        -   - (.  CLSCRF_Create )
// bFlags         -   (. ISO/IEC 15693-3 .7.3.1)
// bGetSystemInfo -   Get System Information (  0x2b)
// pbUID          -    (8 ),   
//                       , 
//                        , 
//                      
// pbFlags        -     BYTE,   
//                     (. ISO/IEC 15693-3 .7.4.1)
// pbInfoFlags    -     BYTE,   
//                     
// pbDSFID        -     BYTE,   
//                    DSFID
// pbAFI          -     BYTE,   
//                    AFI
// pbMemorySize   -     WORD,   
//                   
// pbICReference  -     BYTE,   
//                   
// pbErrorCode    -     BYTE,   
//                     (. ISO/IEC 15693-3 .7.4.2)
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//        
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_GetMultipleBSS_15693( IN     LPVOID pReader,
                                         IN     BYTE   bFlags,
                                         IN     BYTE   bGetMultipleBSS,
                                         IN     LPBYTE pbUID,
                                         IN     BYTE   bFirstBlockNumber,
                                         IN OUT LPBYTE pbNumberOfBlocks,
                                            OUT LPBYTE pbFlags,
                                            OUT LPBYTE pbBlockSecurityStatus,
                                            OUT LPBYTE pbErrorCode );
//
//        (block security status)
// (. ISO/IEC 15693-3 .10.4.13)
//
// pReader      -   - (.  CLSCRF_Create )
// bFlags       -   (. ISO/IEC 15693-3 .7.3.1)
// bGetMultipleBSS -   Get Multiple Block Security Status
//                   (  0x2c)
// pbUID        -    (8 ),   
//                  
// bFirstBlockNumber -     ( 0)
// pbNumberOfBlocks -     BYTE,   
//                        ( 0)  
//                         ,
//                          
//                    (  0)   
// pbFlags      -     BYTE,   
//                   (. ISO/IEC 15693-3 .7.4.1)
// pbBlockSecurityStatus -    ( 256 )  BYTE,  
//                               
//                           
// pbErrorCode  -     BYTE,   
//                   (. ISO/IEC 15693-3 .7.4.2)
//
//  :  0   -  
//                        -   
//



//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//   EAS
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_SetEAS_15693( IN     LPVOID pReader,
                                 IN     BYTE   bFlags,
                                 IN     BYTE   bSetEAS,
                                 IN     BYTE   bICMfgCode,
                                 IN     LPBYTE pbUID,
                                    OUT LPBYTE pbFlags,
                                    OUT LPBYTE pbErrorCode );
//
//  EAS  1
//
// pReader      -   - (.  CLSCRF_Create )
// bFlags       -   (. ISO/IEC 15693-3 .7.3.1)
// bSetEAS      -   Set EAS (  0xa2)
// bICMfgCode   -    
// pbUID        -    (8 ),   
//                  
// pbFlags      -     BYTE,   
//                   (. ISO/IEC 15693-3 .7.4.1)
// pbErrorCode  -     BYTE,   
//                   (. ISO/IEC 15693-3 .7.4.2)
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//   EAS
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_ResetEAS_15693( IN     LPVOID pReader,
                                   IN     BYTE   bFlags,
                                   IN     BYTE   bResetEAS,
                                   IN     BYTE   bICMfgCode,
                                   IN     LPBYTE pbUID,
                                      OUT LPBYTE pbFlags,
                                      OUT LPBYTE pbErrorCode );
//
//  EAS  0
//
// pReader      -   - (.  CLSCRF_Create )
// bFlags       -   (. ISO/IEC 15693-3 .7.3.1)
// bResetEAS    -   Reset EAS (  0xa3)
// bICMfgCode   -    
// pbUID        -    (8 ),   
//                  
// pbFlags      -     BYTE,   
//                   (. ISO/IEC 15693-3 .7.4.1)
// pbErrorCode  -     BYTE,   
//                   (. ISO/IEC 15693-3 .7.4.2)
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//   EAS
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_LockEAS_15693( IN     LPVOID pReader,
                                  IN     BYTE   bFlags,
                                  IN     BYTE   bLockEAS,
                                  IN     BYTE   bICMfgCode,
                                  IN     LPBYTE pbUID,
                                     OUT LPBYTE pbFlags,
                                     OUT LPBYTE pbErrorCode );
//
//  EAS  
//
// pReader      -   - (.  CLSCRF_Create )
// bFlags       -   (. ISO/IEC 15693-3 .7.3.1)
// bLockEAS     -   Lock EAS (  0xa4)
// bICMfgCode   -    
// pbUID        -    (8 ),   
//                  
// pbFlags      -     BYTE,   
//                   (. ISO/IEC 15693-3 .7.4.1)
// pbErrorCode  -     BYTE,   
//                   (. ISO/IEC 15693-3 .7.4.2)
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//   EAS
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_EASAlarm_15693( IN     LPVOID pReader,
                                   IN     BYTE   bFlags,
                                   IN     BYTE   bEASAlarm,
                                   IN     BYTE   bICMfgCode,
                                   IN     LPBYTE pbUID,
                                      OUT LPBYTE pbFlags,
                                      OUT LPBYTE pbEASData,
                                      OUT LPBYTE pbErrorCode );
//
//  EAS-,   EAS   1
//
// pReader      -   - (.  CLSCRF_Create )
// bFlags       -   (. ISO/IEC 15693-3 .7.3.1)
// bEASAlarm    -   EAS Alarm (  0xa5)
// pbUID        -    (8 ),   
//                  
// bICMfgCode   -    
// pbFlags      -     BYTE,   
//                   (. ISO/IEC 15693-3 .7.4.1)
// pbEASData    -    (32 )   
//                EAS-
// pbErrorCode  -     BYTE,   
//                   (. ISO/IEC 15693-3 .7.4.2)
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//===========================================================================
//                                       
//===========================================================================
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//     
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_DirectIO_Reader( IN     LPVOID  pReader,
                                    IN     LPCBYTE pbSendBuffer, 
                                    IN     DWORD   dwSendLength, 
                                       OUT LPBYTE  pbRecvBuffer, 
                                    IN OUT LPDWORD pdwRecvLength );
//
//        
//
// pReader       -   - (.  CLSCRF_Create )
// pbSendBuffer  -  ,  
// dwSendLength  -   
// pbRecvBuffer  -     
// pdwRecvLength -     DWORD,   
//                      pbRecvBuffer, 
//                        
//                  
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//      
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_DirectIO_Card( IN     LPVOID  pReader,
                                  IN     LPCBYTE pbSendBuffer, 
                                  IN     DWORD   dwSendLength, 
                                  IN     DWORD   dwTimeout,
                                     OUT LPBYTE  pbRecvBuffer, 
                                  IN OUT LPDWORD pdwRecvLength );
//
//         
//     ,       
//    ISO/IEC 14443-4 (T=CL)
//
// pReader       -   - (.  CLSCRF_Create )
// pbSendBuffer  -  ,  
// dwSendLength  -     
// dwTimeout     -      (128 / 13,56)[]
// pbRecvBuffer  -     
// pdwRecvLength -     DWORD,   
//                      pbRecvBuffer, 
//                        
//                  
//
//  :  0   -  
//                        -   
//
//#if ADDRESS_RS_485
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//===========================================================================
//                                      R S 4 8 5
//===========================================================================
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//    RS485    
//  -    0  255
//         0
//     0      
//    0        
//         
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//    
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_GetIOAddress( IN     LPVOID pReader,
                                    OUT LPBYTE pbIOAddr );
//
//   ,     
//
// pReader  -   - (.  CLSCRF_Create )
// pbIOAddr -    unsigned char,    
//              ,     
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//    
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_SetIOAddress( IN LPVOID pReader,
                                 IN BYTE   bIOAddr );
//
//   ,      
//   0    ,    RS485
//    
//
// pReader -   - (.  CLSCRF_Create )
// bIOAddr  -  ,      
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//    
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_ReadDeviceAddress( IN     LPVOID pReader,
                                         OUT LPBYTE pbDevAddr );
//
//   .
//    ,     
// RS485 ,    0 (. CLSCRF_SetIOAddress())
//    .
//
// pReader   -   - (.  CLSCRF_Create )
// pbDevAddr -    unsigned char,    
//               
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//---------------------------------------------------------------------------
//    
//---------------------------------------------------------------------------
//
CLSCRFL_API LONG __stdcall 
            CLSCRF_WriteDeviceAddress( IN LPVOID pReader,
                                       IN BYTE   bDevAddr );
//
//          
//
// pReader -   - (.  CLSCRF_Create )
// bDevAddr -   
//
//  :  0   -  
//                        -   
//
//#endif  // ADDRESS_RS_485
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CLSCRFL_H__CE290562_87D9_41F4_A1CD_3B80EFEBA737__INCLUDED_)
