
procedure LinkReader;
var
  i: Integer;
  err: Integer;
begin

  if (0 = CLSCRF_OpenUSB(Form1.m_pReader, 0, 0)) then
  begin
    if (RunQuery()) then
    begin
			if m_fLost then
      begin
        //CLSCRF_Sound(Form1.m_pReader, 1);
        m_fLost := False;
      end;
    end
    else
      m_fLost := True;

    CLSCRF_Close(Form1.m_pReader);

    Sleep(m_GeneralWait);

    if (not m_fLost) then Exit;
  end;

  if (0 = CLSCRF_OpenRS(Form1.m_pReader, Form1.cmbComPort.ItemIndex, StrToInt(Form1.cbBaudrate.Text), 0)) then
  begin
    if (RunQuery()) then
    begin
      //m_lblPortCaption := 'COM' + IntToStr(Form1.cmbComPort.ItemIndex + 1);

 			//if m_fLost then CLSCRF_Sound(Form1.m_pReader, 1);
      m_fLost := False;
    end
    else
      m_fLost := True;

    CLSCRF_Close(Form1.m_pReader);

    Sleep(m_GeneralWait);

    if not m_fLost then Exit;
  end;

end;

function RunQuery :Boolean;
var
  pUID: array [0..7] of Byte;
  UID_Len: Integer;
  ATQ, SAK: Byte;
  HolderSAM: Byte;
  SW1, SW2: Byte;
  UID: String;
	Buf: array [0..555] of Byte;
  Buf_size: Integer;
  i: Integer;
  fFoundSAM: Boolean;
  fFoundMifare: Boolean;
  ATS: array [0..1023] of Byte;
  Data: array [0..15] of Byte;
  Res: Integer;
  State: Integer;
const
  DataZero: array [0..15] of Byte = ($00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00);
  DataTest: array [0..15] of Byte = ($00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $0B);
  Trailer: array [0..15] of Byte = ($FF, $FF, $FF, $FF, $FF, $FF,  $FF, $07, $80, $00,  $FF, $FF, $FF, $FF, $FF, $FF);
  Key: array [0..5] of Byte = ($FF, $FF, $FF, $FF, $FF, $FF);
  CodedKey: array [0..11] of Byte = ($00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00);
begin
  fFoundMifare := False;
  Res := 0;

  if CLSCRF_GetState(Form1.m_pReader, State) <> 0 then
  begin
    Sleep(m_GeneralWait);
    Result := False;
    Exit;
  end;

  if (State And $8000) = $0000 then
  begin
    if CLSCRF_Mfrc_On(Form1.m_pReader) <> 0 then
    begin
      Sleep(m_GeneralWait);
      Result := False;
      Exit;
    end;
  end;

    if CLSCRF_WriteFlashValue(Form1.m_pReader, $00, @DataZero) <> 0 then
    begin
      Sleep(m_GeneralWait);
      Result := False;
      Exit;
    end;

      if CLSCRF_Mfrc_Rf_Off_On(Form1.m_pReader, 5) <> 0 then
      begin
        Sleep(m_GeneralWait);

        Result := False;

        Exit;
      end;

      Sleep(m_GeneralWait);

      if Form1.chkSAM.Checked then
      begin
        fFoundSAM := False;
        m_lblSAM := 'SAM:';
        for i := 1 to 4 do
        begin
          if CLSCRF_SAM_SetCurrentHolder( Form1.m_pReader, i ) = 0 then
          begin

          end
          else
            Sleep(m_GeneralWait);
        end;
        if not fFoundSAM then
        begin
          Sleep(m_GeneralWait);

          m_lblSAM := 'SAM: NO';
        end;
      end;

      UID_Len := sizeof(pUID);

        SetUEM_RF_Mode(Form1.m_pReader, $00);

        Sleep(m_GeneralWait);

        if (CLSCRF_Activate_Idle_A(Form1.m_pReader, ATQ, SAK, @pUID, UID_Len) = 0) then
        begin
          Sleep(m_GeneralWait);

          Inc(m_Cycles);

          UID := DataToHexStr(pUID, UID_Len, 0, False);

          if m_UseSAM then
          begin
            Res := CLSCRF_SAM_Reset(Form1.m_pReader);
            if Res <> 0 then
            begin
              Sleep(m_GeneralWait);
              CLSCRF_GetLastInternalError(Form1.m_pReader, m_ucLastError);
              Result := False;
              Exit;
            end;
          end;

            if m_Authenticate then
            begin
              if m_UseSAM then
              begin
                if UID_Len = 4 then
                  Res := CLSCRF_SAM_MifareAuthenticate(Form1.m_pReader, $00, $01, @pUID, m_ucKeyNoSAM, m_ucKeyVerSAM, $0A, $01, m_ucSW1, m_ucSW2)
                else
                  Res := CLSCRF_SAM_MifareAuthenticate(Form1.m_pReader, $00, $01, @pUID[3], m_ucKeyNoSAM, m_ucKeyVerSAM, $0A, $01, m_ucSW1, m_ucSW2);
              end
              else
              begin
                Res := CLSCRF_MifareStandard_HostCodeKey(Form1.m_pReader, @Key, @CodedKey);
                if UID_Len = 4 then
     				      Res := CLSCRF_MifareStandard_AuthKey(Form1.m_pReader, $60, @pUID, $01, @CodedKey)
                else
     				      Res := CLSCRF_MifareStandard_AuthKey(Form1.m_pReader, $60, @pUID[3], $01, @CodedKey);
              end;
              if Res <> 0 then
              begin
                Sleep(m_GeneralWait);
                CLSCRF_GetLastInternalError(Form1.m_pReader, m_ucLastError);
                Result := False;
                Inc(m_AuthenticateErrors);
                Exit;
              end;
              Inc(m_AuthenticateSuccess);
            end;


            if m_Write then
            begin
              if m_UseSAM then
              begin
                Res := CLSCRF_SAM_MifareWrite(Form1.m_pReader, $00, $01, $00, @DataTest, m_ucSW1, m_ucSW2);
              end
              else
              begin
   				      Res := CLSCRF_MifareStandard_Write(Form1.m_pReader, $01, $00, @DataTest);
              end;
              if Res <> 0 then
              begin
                Sleep(m_GeneralWait);
                CLSCRF_GetLastInternalError(Form1.m_pReader, m_ucLastError);
                Result := False;
                Inc(m_WriteErrors);
                Exit;
              end;
              Inc(m_WriteSuccess);
            end;


            if m_Read then
            begin
              if m_UseSAM then
              begin
                Res := CLSCRF_SAM_MifareRead(Form1.m_pReader, $00, $01, $00, @Data, m_ucSW1, m_ucSW2);
              end
              else
              begin
   				      Res := CLSCRF_MifareStandard_Read(Form1.m_pReader, $01, $00, @Data);
              end;
              if Res <> 0 then
              begin
                Sleep(m_GeneralWait);
                CLSCRF_GetLastInternalError(Form1.m_pReader, m_ucLastError);
                Result := False;
                Inc(m_ReadErrors);
                Exit;
              end;
              Inc(m_ReadSuccess);
            end;


            if m_ChangeKey then
            begin
              if m_UseSAM then
              begin
                if UID_Len = 4 then
                  Res := CLSCRF_SAM_MifareChangeKey(Form1.m_pReader, $00, $00, m_ucKeyNoSAM, m_ucKeyVerSAM, m_ucKeyVerSAM, $01, @Trailer[6], @pUID, m_ucSW1, m_ucSW2)
                else
                  Res := CLSCRF_SAM_MifareChangeKey(Form1.m_pReader, $00, $00, m_ucKeyNoSAM, m_ucKeyVerSAM, m_ucKeyVerSAM, $01, @Trailer[6], @pUID[3], m_ucSW1, m_ucSW2);
              end
              else
              begin
   				      Res := CLSCRF_MifareStandard_Write(Form1.m_pReader, $01, $03, @Trailer)
              end;
              if Res <> 0 then
              begin
                Sleep(m_GeneralWait);
                CLSCRF_GetLastInternalError(Form1.m_pReader, m_ucLastError);
                Result := False;
                Inc(m_ChangeKeyErrors);
                Exit;
              end;
              Inc(m_ChangeKeySuccess);
            end;



          Sleep(m_GeneralWait);
        end
        else
        begin
          Sleep(m_GeneralWait);
        end;


      CLSCRF_Mfrc_Rf_Off_On(Form1.m_pReader, 0);

      Sleep(m_GeneralWait);

      Result := True;
end;
