#ifndef AES_128_H
#define AES_128_H

unsigned long AES128HostEncrypt( unsigned char* Inp, int InpLen, unsigned char* Key, unsigned char* InV, unsigned char* Out );

unsigned long AES128HostDecrypt( unsigned char* Inp, int InpLen, unsigned char* Key, unsigned char* InV, unsigned char* Out );

//  input[]   inputLength  key[16]   bc    iv[16],
//   ISO 10126,    output[],     
unsigned int aes_128_encrypt_cbc(unsigned char input[], unsigned int inputLength, unsigned char key[], unsigned char iv[], 
                                 unsigned char output[]);

//  input[]   inputLength  key[16]   cbc    iv[16],
//   ISO 10126,    output[],     
unsigned int aes_128_decrypt_cbc(unsigned char input[], unsigned int inputLength, unsigned char key[], unsigned char iv[], 
                                 unsigned char output[]);

//  input[16]  key[16],
//   output[16]
void aes_128_encrypt16(unsigned char input[], unsigned char key[], unsigned char output[]);

//  input[16]  key[16],
//   output[16]
void aes_128_decrypt16(unsigned char input[], unsigned char key[], unsigned char output[]);

void AES_128_CBC_En( unsigned char* Inp, int BlockQty, unsigned char* Key, unsigned char* InV, unsigned char* Out );
void AES_128_CBC_De( unsigned char* Inp, int BlockQty, unsigned char* Key, unsigned char* InV, unsigned char* Out );

void generate_subkey( unsigned char* key, unsigned char* K1, unsigned char* K2 );
void AES_128_CBC_En_MAC( unsigned char* pInp, int ByteSize, unsigned char* pKey, unsigned char* pOut );
/*
//  input[32]  key[16]   cbc    iv[16],
//   output[32]
void aes_128_encrypt32_cbc(unsigned char input[], unsigned char key[], unsigned char iv[], unsigned char output[]);

//  input[32]  key[16]   cbc    iv[16],
//   output[32]
void aes_128_decrypt32_cbc(unsigned char input[], unsigned char key[], unsigned char iv[], unsigned char output[]);
*/
#endif