﻿using System;

namespace UEM_COM
{
    class Program
    {
        const uint COM_PORT = 4;
        const uint BAUDRATE = 9600;
        const uint LOG_FILE = 1;

        static void Main(string[] args)
        {
            Console.WriteLine("MicroEM Reader COM-port example");

            int status = -1;

            status = Clscrfl.Instance.Create();

            if (status == 0)
                status = Clscrfl.Instance.OpenCOM(COM_PORT, BAUDRATE, LOG_FILE);

            if (status == 0)
                Console.WriteLine("Port COM{0:d} is opened successfully", COM_PORT);
            else
                Console.WriteLine("Port COM{0:d} is not opened", COM_PORT);

            if (status == 0)
                status = Clscrfl.Instance.Led(1, 3, 2);

            if (status == 0)
                status = Clscrfl.Instance.Sound(2);

            byte[] Version = new byte[6];

            if (status == 0)
                status = Clscrfl.Instance.GetVersion(ref Version);

            if (status == 0)
            {
                Console.Write("Version:");
                for (int i = 0; i < 6; i++)
                    Console.Write(" {0:X2}", Version[i]);
                Console.WriteLine();
            }

            if( status != 0 )
                Console.WriteLine("status = 0x{0:X8}", status);

            status = Clscrfl.Instance.Destroy();

            Console.Write("Press any key ...");
            Console.ReadLine();
        }
    }
}
