
//==============================================================================
//             SAM-ÌÎÄÓËÈ: ÐÀÑØÈÐÅÍÈÅ ÁÈÁËÈÎÒÅÊÈ ÔÓÍÊÖÈÉ RFID-Ñ×ÈÒÛÂÀÒÅËß
//==============================================================================

// Clscrfl_SAM.h : main header file for the SAM CLSCRFL DLL EXTENSION

// Áèáëèîòåêà ôóíêöèé RFID-ñ÷èòûâàòåëÿ âêëþ÷àåò â ñåáÿ ñëåäóþùèå ôóíêöèè:
//==============================================================================
//      ÐÀÁÎÒÀ Ñ SAM-ÌÎÄÓËÅÌ
//------------------------------------------------------------------------------
//  Ñìåíèòü òåêóùèé SAM
//  Çàïðîñèòü íîìåð òåêóùåãî SAM-ìîäóëÿ
//  Âûïîëíèòü êîìàíäó â ôîðìàòå APDU
//  Ïåðåâåñòè íîâûé SAM èç ðåæèìà AV1 â ðåæèì AV2
//  Âûïîëíèòü ñáðîñ (ðåñòàðò) SAM
//  Âûïîëíèòü àóòåíòèôèêàöèþ êàðòû Mifare Classic
//  Ïðî÷èòàòü áëîê êàðòû Mifare Classic
//  Çàïèñàòü áëîê êàðòû Mifare Classic
//  Ðàáîòà ñ áëîêîì Value êàðòû Mifare Classic
//  Ñìåíà êëþ÷åé êàðòû Mifare Classic
//==============================================================================

// Íàèáîëåå ÷àñòî âñòðå÷àþùèåñÿ êîäû âîçâðàòà ôóíêöèé:
//          0 - óñïåøíîå âûïîëíåíèå
// 0x80100001 - âíóòðåííÿÿ îøèáêà ñ÷èòûâàòåëÿ, êîä êîòîðîé ìîæíî ïîëó÷èòü 
//              ïóòåì âûçîâà ôóíêöèè CLSCRF_GetLastInternalError



#if !defined(AFX_CLSCRF_H__DE290562_87D9_41F4_A1CD_3B80EFEBA737__INCLUDED_)
#define AFX_CLSCRF_H__DE290562_87D9_41F4_A1CD_3B80EFEBA737__INCLUDED_

#if _MSC_VER > 1000
	#pragma once
#endif // _MSC_VER > 1000



/*#ifndef STATIC_LIB
	#ifdef CLSCRF_EXPORTS
		#define CLSCRF_API __declspec(dllexport)
	#else
		#define CLSCRF_API __declspec(dllimport)
	#endif
#else
	#define CLSCRF_API
#endif*/


#ifndef _LPCBYTE_DEFINED
	#define _LPCBYTE_DEFINED
	typedef const BYTE *LPCBYTE;
#endif

/*#define CLSCRF_CDECL

#ifdef CLSCRF_CDECL
	#define CLSCRF_DECL __cdecl
#else
	#define CLSCRF_DECL __stdcall
#endif*/

#define CLSCRF_DECL

#if defined(_MSC_VER)
    //  Microsoft 
    #define EXPORT __declspec(dllexport)
    #define IMPORT __declspec(dllimport)
#elif defined(__GNUC__)
    //  GCC
    #define EXPORT __attribute__((visibility("default")))
    #define IMPORT __attribute__((visibility("default")))
#else
    //  do nothing and hope for the best?
    #define EXPORT
    #define IMPORT
    #pragma warning Unknown dynamic link import/export semantics.
#endif

#if CLSCRF_COMPILING
#   define CLSCRF_API extern "C" EXPORT
#else
#   define CLSCRF_API extern "C" IMPORT
#endif

#include "types_def.h"
#include "SCardErr.h"

#undef STRING_VERSION
#define STRING_VERSION      "S8.10"

#pragma pack(push, 1)

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//------------------------------------------------------------------------------
//  SAM: Ïîëó÷èòü òåêñòîâîå îïèñàíèå îøèáêè ïî áàéòàì ñòàòóñà
//------------------------------------------------------------------------------
//
// Ïîëó÷èòü òåêñòîâîå îïèñàíèå îøèáêè ïî áàéòàì ñòàòóñà
//
// pucSW1  áàéò 1 ñòàòóñà;
// pucSW2  áàéò 2 ñòàòóñà.
// pError - óêàçàòåëü íà ìàññèâ ñèìâîëîâ (256 áàéò), 
//          êóäà áóäåò çàïèñàíî îïèñàíèå îøèáêè
//
// Âîçâðàùàåìîå çíà÷åíèå:  0    óñïåøíîå âûïîëíåíèå,
//   èíà÷å  îøèáêà ïðè âûïîëíåíèè.
//
CLSCRF_API LONG CLSCRF_DECL 
            CLSCRF_SAM_GetStatusDescription(	IN BYTE ucSW1,
												IN BYTE ucSW2,
												OUT LPSTR pError);

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Ñìåíèòü òåêóùèé SAM
//------------------------------------------------------------------------------
//
// Ñìåíèòü òåêóùèé SAM
// Âñå ïîñëåäóþùèå êîìàíäû áóäóò âîñïðèíèìàòüñÿ èìåííî ýòèì ìîäóëåì
// Ñîñòîÿíèå ïðåäûäóùåãî òåêóùåãî ìîäóëÿ ïðè ýòîì íå èçìåíÿåòñÿ
//
// pReader  ññûëêà íà îáúåêò-èíòåðôåéñ (ñì. ôóíêöèþ CLSCRF_Create);
// ucNumHolder  íîìåð õîëäåðà îò 1 äî 4.
//
// Âîçâðàùàåìîå çíà÷åíèå:  0    óñïåøíîå âûïîëíåíèå,
//   èíà÷å  îøèáêà ïðè âûïîëíåíèè.
//
CLSCRF_API LONG CLSCRF_DECL 
            CLSCRF_SAM_SetCurrentHolder(	IN LPVOID pReader,
											IN BYTE ucNumHolder );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Ñìåíèòü òåêóùèé SAM è âû÷èòàòü ATR
//------------------------------------------------------------------------------
//
// Ñìåíèòü òåêóùèé SAM
// Âñå ïîñëåäóþùèå êîìàíäû áóäóò âîñïðèíèìàòüñÿ èìåííî ýòèì ìîäóëåì
// Ñîñòîÿíèå ïðåäûäóùåãî òåêóùåãî ìîäóëÿ ïðè ýòîì íå èçìåíÿåòñÿ
//
// pReader  ññûëêà íà îáúåêò-èíòåðôåéñ (ñì. ôóíêöèþ CLSCRF_Create);
// ucNumHolder  íîìåð õîëäåðà îò 1 äî 4.
// dwATRBufSize  ðàçìåð ìàññèâà, âûäåëåííîãî çàïðàøèâàþùèì äëÿ çàïèñè ATR.
// pATR  óêàçàòåëü íà îáúÿâëåííûé çàïðàøèâàþùèì ìàññèâ, êóäà äîëæåí áûòü çàïèñàí ATR.
// pdwATRSize  ðàçìåð ATR, ñîõðàí¸ííîãî â ìàññèâå.
//
// Âîçâðàùàåìîå çíà÷åíèå:  0    óñïåøíîå âûïîëíåíèå,
//   èíà÷å  îøèáêà ïðè âûïîëíåíèè.
//
CLSCRF_API LONG CLSCRF_DECL 
            CLSCRF_SAM_SetCurrentHolderGetATR(	IN  LPVOID pReader,
												IN  BYTE ucNumHolder,
												IN  DWORD dwATRBufSize,
												OUT PBYTE  pATR,
												OUT PDWORD pdwATRSize
											);

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Ñìåíèòü òåêóùèé SAM ñ ðàñøèðåííûìè îïöèÿìè
//------------------------------------------------------------------------------
//
// Ñìåíèòü òåêóùèé SAM ñ ðàñøèðåííûìè îïöèÿìè
//
// pReader  ññûëêà íà îáúåêò-èíòåðôåéñ (ñì. ôóíêöèþ CLSCRF_Create);
// ucNumHolder  íîìåð õîëäåðà îò 1 äî 4 (åñëè 0, òî âñå ìîäóëè âûêëþ÷àþòñÿ).
// ucWT10 - åñëè íå ðàâíî 0xFF, òî çàäàòü íåñòàíäàðòíîå âðåìÿ îæèäàíèÿ ATR â äåñÿòêàõ ìèëëèñåêóíä (ISO 7816-3, ï.8.1).
// ucPPS1 - åñëè íå ðàâíî 0xFF, òî çàäàòü íîâîå çíà÷åíèå PPS1, îòëè÷íîå îò ãëîáàëüíîãî áàéòà TA1 (ISO 7816-3, ï.9.2, ï.8.3).
// ucDeactivate - åñëè > 0, òî âûêëþ÷èòü ïðåäûäóùóþ ðàáî÷óþ êîíòàêòíóþ êàðòó;
// dwATRBufSize  ðàçìåð ìàññèâà, âûäåëåííîãî çàïðàøèâàþùèì äëÿ çàïèñè ATR, åñëè 0, òî ATR íå çàïðàøèâàòü;
// pATR  óêàçàòåëü íà îáúÿâëåííûé çàïðàøèâàþùèì ìàññèâ, êóäà äîëæåí áûòü çàïèñàí ATR (ìîæíî NULL, åñëè íå çàïðàøèâàòü).
// pdwATRSize  ðàçìåð ATR, ñîõðàí¸ííîãî â ìàññèâå (ìîæíî NULL, åñëè íå çàïðàøèâàòü).
//
// Ïðè ïîäà÷å ïèòàíèÿ âñå êîíòàêòíûå êàðòû àêòèâèðóþòñÿ, è îäíà èç íèõ ÿâëÿåòñÿ ðàáî÷åé.
//
// Åñëè çíà÷åíèå ucNumHolder ïðåâûøàåò êîëè÷åñòâî èìåþùèõñÿ õîëäåðîâ, 
//
//		âûäàåòñÿ îøèáêà.
//
// Èíà÷å, Åñëè ucNumHolder > 0
//
//		Êîíòàêòíàÿ êàðòà â õîëäåðå NumHolder ñòàíîâèòñÿ ðàáî÷åé.
//		Âñå ïîñëåäóþùèå êîìàíäû áóäóò âîñïðèíèìàòüñÿ èìåííî ýòîé êàðòîé.
//		Ïåðåêëþ÷åíèå íà õîëäåð ñ âûêëþ÷åííîé êàðòîé çàíèìàåò íå ìåíåå 50 ìñ.
//		Ïåðåêëþ÷åíèå ìåæäó àêòèâèðîâàííûìè êîíòàêòíûìè êàðòàìè çàíèìàåò ìåíåå 1 ìñ.
//		Ïîïûòêà ïåðåêëþ÷èòüñÿ íà õîëäåð ñ îòñóòñòâóþùåé èëè íåèñïðàâíîé êîíòàêòíîé êàðòîé çàíèìàåò âðåìÿ WT(îæèäàíèå ATR îò êàðòû) ñîãëàñíî ISO 7816 - 3, ï.8.1.
//		Äëÿ âûáîðà íåñòàíäàðòíîãî WT ñëóæàò ucWT10 è FlashParam[20]:
//		Åñëè ucWT10 != 0xFF
//			WT = ucWT10 * 10 ìñ(äî 2540 ìñ).
//		èíà÷å(ïðè ucWT10 == 0xFF)
//			Åñëè FlashParam[20] = 0xFF
//				WT ñîîòâåòñòâóåò ñòàíäàðòó(ISO 7816 - 3, ï.8.1)(îêîëî 750 ìñ).
//			èíà÷å(ïðè FlashParam[20] < 0xFF)
//				WT = FlashParam[20] * 10 ìñ(äî 2540 ìñ).
// 
//		Ïðîèçâîäèòåëè íåêîòîðûõ êîíòàêòíûõ êàðò äëÿ ïîâûøåíèÿ ñêîðîñòè îáìåíà äîïóñêàþò âûáîð íåñòàíäàðòíûõ ïàðàìåòðîâ, íå ñîâïàäàþùèõ ñ óêàçàííûìè â ATR.
//		Íàïðèìåð, äëÿ SAM AV2 îò NXP ïðè ñëåäîâàíèè ñòàíäàðòó
//			PPS1 = 0x18 (fKHz = 4800, Baudrate = 154838 áîä),
//		Îäíàêî, â íàðóøåíèå ñòàíäàðòà, äîïóñòèìû ñëåäóþùèå çíà÷åíèÿ :
//			PPS1 = 0x96 (fKHz = 4800, Baudrate = 300000 áîä),
//			PPS1 = 0xD7 (fKHz = 12000, Baudrate = 375000 áîä).
//		Äëÿ âûáîðà íåñòàíäàðòíûõ ïàðàìåòðîâ ñëóæàò ucPPS1 è FlashParam[21].
//		Åñëè ucPPS1 != 0xFF
//			PPS1 = ucPPS1;
//		èíà÷å(ïðè Opt_PPS1 = 0)
//			Åñëè FlashParam[21] = 0xFF
//				PPS1 = TA1
//				(äëÿ SAM AV2 TA1 = 0x18 (fKHz = 4800, Baudrate = 154838));
//			èíà÷å(ïðè FlashParam[21] < 0xFF)
//				PPS1 = FlashParam[21].
// 
// 		Åñëè ucDeactivate > 0
// 			Ïðåäûäóùàÿ ðàáî÷àÿ êîíòàêòíàÿ êàðòà(ïðè íàëè÷èè) âûêëþ÷àåòñÿ.
// 		èíà÷å(ïðè ucDeactivate == 0)
//			Ïðåäûäóùàÿ ðàáî÷àÿ êîíòàêòíàÿ êàðòà(ïðè íàëè÷èè) îñòàåòñÿ àêòèâèðîâàííîé.
// 
// èíà÷å (ïðè ucNumHolder = 0)
// 
// 		Ðàáî÷åé êîíòàêòíîé êàðòû íå áóäåò(âñå àêòèâèðîâàííûå êîíòàêòíûå êàðòû âûêëþ÷àþòñÿ), çíà÷åíèÿ áèòîâ 7..4 èãíîðèðóþòñÿ.
//
// Âîçâðàùàåìîå çíà÷åíèå:  0    óñïåøíîå âûïîëíåíèå,
//   èíà÷å  îøèáêà ïðè âûïîëíåíèè.
//
CLSCRF_API LONG CLSCRF_DECL 
            CLSCRF_SAM_SetCurrentHolderEx(	IN  LPVOID pReader,
											IN  BYTE ucNumHolder,
											IN  BYTE ucWT10,
											IN  BYTE ucPPS1,
											IN  BYTE ucDeactivate,
											IN  DWORD dwATRBufSize,
											OUT PBYTE  pATR,
											OUT PDWORD pdwATRSize
											);

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Çàïðîñèòü íîìåð òåêóùåãî SAM-ìîäóëÿ
//------------------------------------------------------------------------------
//
// Çàïðîñèòü íîìåð òåêóùåãî SAM-ìîäóëÿ
//
// pReader  ññûëêà íà îáúåêò-èíòåðôåéñ (ñì. ôóíêöèþ CLSCRF_Create);
// pucNumSAM  íîìåð ìîäóëÿ îò 1 äî 4.
//
// Âîçâðàùàåìîå çíà÷åíèå:  0    óñïåøíîå âûïîëíåíèå,
//   èíà÷å  îøèáêà ïðè âûïîëíåíèè.
//
CLSCRF_API LONG CLSCRF_DECL 
            CLSCRF_SAM_GetCurrentHolder(	IN LPVOID pReader,
											OUT LPBYTE pucNumSAM );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Âûïîëíèòü êîìàíäó â ôîðìàòå APDU
//------------------------------------------------------------------------------
//
// Âûïîëíèòü êîìàíäó â ôîðìàòå APDU
//
// pReader  ññûëêà íà îáúåêò-èíòåðôåéñ (ñì. ôóíêöèþ CLSCRF_Create);
// pbSendBuffer  êîìàíäà;
// dwSendLength  äëèíà êîìàíäû;
// pbRecvBuffer  îòâåò, â òîì ÷èñëå SW1 è SW2;
// pdwRecvLength  äëèíà îòâåòà.
//
// Âîçâðàùàåìîå çíà÷åíèå:  0    óñïåøíîå âûïîëíåíèå,
//   èíà÷å  îøèáêà ïðè âûïîëíåíèè.
//
CLSCRF_API LONG CLSCRF_DECL 
            CLSCRF_SAM_APDU(  IN     LPVOID  pReader,
                              IN     LPCBYTE pbSendBuffer, 
                              IN     DWORD   dwSendLength, 
                                 OUT LPBYTE  pbRecvBuffer, 
                              IN OUT LPDWORD pdwRecvLength );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Áëîêèðîâàòü SAM-ìîäóëü
//------------------------------------------------------------------------------
//
// Áëîêèðîâàòü SAM-ìîäóëü
//
// pReader  ññûëêà íà îáúåêò-èíòåðôåéñ (ñì. ôóíêöèþ CLSCRF_Create);
// ucLC  ëîãè÷åñêèé êàíàë îò 0 äî 3;
// ucKeyKind[1] - ðîä êëþ÷à:
//					0: TDEA - DESFire;
//					1: TDEA - ISO 10116(CRC16);
//					2: MIFARE;
//					3: 3 Key TDEA - ISO 10116;
//					4: AES 128;
//					5: AES 192;
//					6: TDEA - ISO 10116(CRC32);
// ucKeyNo[1] - íîìåð êëþ÷à äëÿ âûïîëíåíèÿ îïåðàöèè;
// ucKeyVer[1] - âåðñèÿ êëþ÷à äëÿ âûïîëíåíèÿ îïåðàöèè;
// pUnlockKey[24] - êëþ÷ äëÿ ðàçáëîêèðîâêè
// ucUnlockKeyNo[1] - íîìåð êëþ÷à äëÿ ðàçáëîêèðîâàíèÿ;
// ucUnlockKeyVer[1] - âåðñèÿ êëþ÷à äëÿ ðàçáëîêèðîâàíèÿ;
//                  (Åñëè NULL, òî ìîäóëü áëîêèðóåòñÿ áåç êëþ÷à);
// dwMaxChainBlocks - ìàêñèìàëüíîå êîëè÷åñòâî áëîêîâ â öåïî÷êå
// pucSW1  áàéò ñòàòóñà;
// pucSW2  áàéò ñòàòóñà.
//
// Âîçâðàùàåìîå çíà÷åíèå:  0    óñïåøíîå âûïîëíåíèå,
//   èíà÷å  îøèáêà ïðè âûïîëíåíèè.
//
CLSCRF_API LONG CLSCRF_DECL 
            CLSCRF_SAM_Lock(IN LPVOID pReader,
							IN BYTE ucLC,
							IN BYTE ucKeyKind,
							IN BYTE ucKeyNo, 
							IN BYTE ucKeyVer, 
							IN PBYTE pUnlockKey, 
							IN BYTE ucUnlockKeyNo,
							IN BYTE ucUnlockKeyVer,
							//IN DWORD dwMaxChainBlocks,
							OUT LPBYTE pucSW1,
							OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Ðàçáëîêèðîâàòü SAM-ìîäóëü
//------------------------------------------------------------------------------
//
// Ðàçáëîêèðîâàòü SAM-ìîäóëü
//
// pReader  ññûëêà íà îáúåêò-èíòåðôåéñ (ñì. ôóíêöèþ CLSCRF_Create);
// ucLC  ëîãè÷åñêèé êàíàë îò 0 äî 3;
// ucKeyKind[1] - ðîä êëþ÷à:
//					0: TDEA - DESFire;
//					1: TDEA - ISO 10116(CRC16);
//					2: MIFARE;
//					3: 3 Key TDEA - ISO 10116;
//					4: AES 128;
//					5: AES 192;
//					6: TDEA - ISO 10116(CRC32);
// ucKeyNo[1] - íîìåð êëþ÷à äëÿ ðàçáëîêèðîâàíèÿ;
// ucKeyVer[1] - âåðñèÿ êëþ÷à äëÿ ðàçáëîêèðîâàíèÿ;
// pUnlockKey[24] - êëþ÷ äëÿ ðàçáëîêèðîâàíèÿ
//                  (Åñëè NULL, òî ìîäóëü áëîêèðóåòñÿ áåç êëþ÷à);
// pucSW1  áàéò ñòàòóñà;
// pucSW2  áàéò ñòàòóñà.
//
// Âîçâðàùàåìîå çíà÷åíèå:  0    óñïåøíîå âûïîëíåíèå,
//   èíà÷å  îøèáêà ïðè âûïîëíåíèè.
//
CLSCRF_API LONG CLSCRF_DECL 
            CLSCRF_SAM_Unlock(	IN LPVOID pReader,
								IN BYTE ucLC,
								IN BYTE ucKeyKind,
								IN BYTE ucKeyNo, 
								IN BYTE ucKeyVer, 
								IN PBYTE pUnlockKey, 
								OUT LPBYTE pucSW1,
								OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: ×òåíèå èíôîðìàöèè î âåðñèè SAM-ìîäóëÿ
//------------------------------------------------------------------------------
//
typedef struct _CLSCRF_SAM_VERSION
{
	struct
	{
		BYTE ucVendorID;
		BYTE ucType;
		BYTE ucSubType;
		BYTE ucMajorVersion;
		BYTE ucMinorVersion;
		BYTE ucStorageSize;
		BYTE ucProtocolType;
	} HardwareVersionInfo;
	struct
	{
		BYTE ucVendorID;
		BYTE ucType;
		BYTE ucSubType;
		BYTE ucMajorVersion;
		BYTE ucMinorVersion;
		BYTE ucStorageSize;
		BYTE ucProtocolType;
	} SoftwareVersionInfo;
	struct
	{
		BYTE UID[7];
		BYTE BatchNumber[5];
		BYTE ucProductionDay;
		BYTE ucProductionMonth;
		BYTE ucProductionYear;
		union
		{
			struct
			{
				BYTE RFU:3;
				BYTE fDisable_DESFirePICCKeyChange:1;
				BYTE fDisable_Decryption:1;
				BYTE fDisable_Encryption:1;
				BYTE fDisable_MAC_Verification:1;
				BYTE fDisable_MAC_Generation:1;
			};
			BYTE ucBits;
		} CryptoSettings;
	} ManufacturerData;
	BYTE ucMode;
} CLSCRF_SAM_VERSION;

// ×òåíèå èíôîðìàöèè î âåðíñèè SAM-ìîäóëÿ
//
// pReader  ññûëêà íà îáúåêò-èíòåðôåéñ (ñì. ôóíêöèþ CLSCRF_Create);
// ucLC  ëîãè÷åñêèé êàíàë îò 0 äî 3;
// pVersion - èíôîðìàöèÿ î âåðñèè SAM-ìîäóëÿ;
// pucSW1  áàéò ñòàòóñà;
// pucSW2  áàéò ñòàòóñà.
//
// Âîçâðàùàåìîå çíà÷åíèå:  0    óñïåøíîå âûïîëíåíèå,
//   èíà÷å  îøèáêà ïðè âûïîëíåíèè.
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_GetVersion(	IN LPVOID pReader,
									IN BYTE ucLC,
									OUT CLSCRF_SAM_VERSION* pVersion,
									OUT LPBYTE pucSW1,
									OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Àóòåíòèôèêàöèÿ SAM-ìîäóëÿ
//------------------------------------------------------------------------------
//
typedef union _CLSCRF_SAM_AUTH_MODE_AV1
{
	struct
	{
		BYTE fKeyDiversifiedWith8Or16BytesDivInp:1;
		BYTE fUseLogicalChannelForCMACCalculation:1;
		BYTE fUseSecretKeyForCrypto:1;
		BYTE fDiversifyUsingOneEncryptionRound:1;
		BYTE fUseMIFARE_SAM_AV2_ModeKeyDiversificationMethods:1;
		BYTE RFU:3;
	};
	BYTE ucBitMask;
} CLSCRF_SAM_AUTH_MODE_AV1;
//
// Àóòåíòèôèêàöèÿ SAM-ìîäóëÿ è õîñòà
//
// pReader  ññûëêà íà îáúåêò-èíòåðôåéñ (ñì. ôóíêöèþ CLSCRF_Create);
// ucLC  ëîãè÷åñêèé êàíàë îò 0 äî 3;
// ucHostMode[1] - ðåæèì àóòåíòèôèêàöèè:
//					0: Plain;
//					1: MAC Protection;
//					2: Full Protection;
//					3: RFU;
// ucKeyKind[1] - ðîä êëþ÷à:
//					0: TDEA - DESFire;
//					1: TDEA - ISO 10116(CRC16);
//					2: MIFARE;
//					3: 3 Key TDEA - ISO 10116;
//					4: AES 128;
//					5: AES 192;
//					6: TDEA - ISO 10116(CRC32);
// ucKeyNo[1] - íîìåð êëþ÷à äëÿ àóòåíòèôèêàöèè;
// ucKeyVer[1] - âåðñèÿ êëþ÷à äëÿ àóòåíòèôèêàöèè;
// pKey[24] - êëþ÷ äëÿ àóòåíòèôèêàöèè;
// pucSW1  áàéò ñòàòóñà;
// pucSW2  áàéò ñòàòóñà.
//
// Âîçâðàùàåìîå çíà÷åíèå:  0    óñïåøíîå âûïîëíåíèå,
//   èíà÷å  îøèáêà ïðè âûïîëíåíèè.
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_AuthenticateHost(IN LPVOID pReader,
										IN BYTE ucLC,
										IN BYTE ucHostMode,
										IN BYTE ucKeyKind,
										IN BYTE ucKeyNo, 
										IN BYTE ucKeyVer, 
										IN PBYTE pKey, 
										//IN BYTE ucDivLength, 
										//IN LPBYTE pbDivInp, 
										OUT LPBYTE pucSW1,
										OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Àêòèâàöèÿ Offline-êëþ÷à SAM-ìîäóëÿ
//------------------------------------------------------------------------------
//
// Àêòèâàöèÿ Offline-êëþ÷à SAM-ìîäóëÿ
//
// pReader  ññûëêà íà îáúåêò-èíòåðôåéñ (ñì. ôóíêöèþ CLSCRF_Create);
// ucLC  ëîãè÷åñêèé êàíàë îò 0 äî 3;
// ucKeyNo[1] - íîìåð êëþ÷à äëÿ àóòåíòèôèêàöèè;
// ucKeyVer[1] - âåðñèÿ êëþ÷à äëÿ àóòåíòèôèêàöèè;
// ucDivLength[1] - äëèíà âõîäíûõ äàííûõ (8-áàéòîâûé êëþ÷ DES, 
//                  16-áàéòîâûé êëþ÷ AES èëè 1-31-áàéòîâûé âåêòîð äèâåðñèôèêàöèè);
// pbDivInp[1-31] - âõîäíûå äàííûå (êëþ÷è DES, AES èëè âåêòîð äèâåðñèôèêàöèè);
// pucSW1  áàéò ñòàòóñà;
// pucSW2  áàéò ñòàòóñà.
//
// Âîçâðàùàåìîå çíà÷åíèå:  0    óñïåøíîå âûïîëíåíèå,
//   èíà÷å  îøèáêà ïðè âûïîëíåíèè.
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_ActivateOfflineKey(	IN LPVOID pReader,
											IN BYTE ucLC,
											IN BYTE ucKeyNo, 
											IN BYTE ucKeyVer, 
											IN BYTE ucDivLength, 
											IN LPBYTE pbDivInp, 
											OUT LPBYTE pucSW1,
											OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Ïåðåâåñòè íîâûé SAM èç ðåæèìà AV1 â ðåæèì AV2
//------------------------------------------------------------------------------
//
// Ïåðåâåñòè íîâûé SAM èç ðåæèìà AV1 â ðåæèì AV2
//
// pReader  ññûëêà íà îáúåêò-èíòåðôåéñ (ñì. ôóíêöèþ CLSCRF_Create);
// ucLC  ëîãè÷åñêèé êàíàë îò 0 äî 3;
// pbNewPosAkey[16] - íîâîå çíà÷åíèå ìàñòåð-êëþ÷à AES-128 â ïîçèöèè A;
// ucNewPosAkeyVer[1] - íîâîå çíà÷åíèå âåðñèè êëþ÷à AES-128 â ïîçèöèè A îò 0 äî 255;
// pbNewPosBkey[16] - íîâîå çíà÷åíèå ìàñòåð-êëþ÷à AES-128 â ïîçèöèè B;
// ucNewPosBkeyVer[1] - íîâîå çíà÷åíèå âåðñèè êëþ÷à AES-128 â ïîçèöèè B îò 0 äî 255;
// pbNewPosCkey[16] - íîâîå çíà÷åíèå ìàñòåð-êëþ÷à AES-128 â ïîçèöèè C;
// ucNewPosCkeyVer[1] - íîâîå çíà÷åíèå âåðñèè êëþ÷à AES-128 â ïîçèöèè C îò 0 äî 255;
// dwMaxChainBlocks - ìàêñèìàëüíîå êîëè÷åñòâî áëîêîâ â öåïî÷êå
// pucSW1  áàéò ñòàòóñà;
// pucSW2  áàéò ñòàòóñà.
//
// Âîçâðàùàåìîå çíà÷åíèå:  0    óñïåøíîå âûïîëíåíèå,
//   èíà÷å  îøèáêà ïðè âûïîëíåíèè.
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_SwitchToAV2Mode(	IN LPVOID pReader,
										IN BYTE ucLC,
										IN LPBYTE pbNewPosAkey, 
										IN BYTE ucNewPosAkeyVer, 
										IN LPBYTE pbNewPosBkey, 
										IN BYTE ucNewPosBkeyVer, 
										IN LPBYTE pbNewPosCkey, 
										IN BYTE ucNewPosCkeyVer, 
										IN DWORD dwMaxChainBlocks,
										OUT LPBYTE pucSW1,
										OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Âûïîëíèòü ñáðîñ (ðåñòàðò) SAM
//------------------------------------------------------------------------------
//
// Âûïîëíèòü ñáðîñ (ðåñòàðò) SAM
//
// pReader  ññûëêà íà îáúåêò-èíòåðôåéñ (ñì. ôóíêöèþ CLSCRF_Create).
//
// Âîçâðàùàåìîå çíà÷åíèå:  0    óñïåøíîå âûïîëíåíèå,
//   èíà÷å  îøèáêà ïðè âûïîëíåíèè.
//
CLSCRF_API LONG CLSCRF_DECL
CLSCRF_SAM_Reset(IN LPVOID pReader);

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Âûïîëíèòü ñáðîñ (ðåñòàðò) SAM
//------------------------------------------------------------------------------
//
// Âûïîëíèòü ñáðîñ àóòåíòèôèêàöèè SAM
//
// pReader  ññûëêà íà îáúåêò-èíòåðôåéñ (ñì. ôóíêöèþ CLSCRF_Create).
// ucType  0x01 - ñáðîñ àóòåíòèôèêàöèè êàðòû, 0x00 - ñáðîñ àóòåíòèôèêàöèè SAM è êàðòû
// Âîçâðàùàåìîå çíà÷åíèå:  0    óñïåøíîå âûïîëíåíèå,
//   èíà÷å  îøèáêà ïðè âûïîëíåíèè.
//
CLSCRF_API LONG CLSCRF_DECL
CLSCRF_SAM_KillAuth(IN LPVOID pReader,
IN BYTE ucType);

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Âûïîëíèòü êîìàíäó Halt äëÿ êàðòû ISO14443A ïîä óïðàâëåíèåì SAM
//------------------------------------------------------------------------------
//
// Âûïîëíèòü êîìàíäó Halt äëÿ êàðòû ISO14443A ïîä óïðàâëåíèåì SAM
//
// pReader  ññûëêà íà îáúåêò-èíòåðôåéñ (ñì. ôóíêöèþ CLSCRF_Create).
// ucLC  ëîãè÷åñêèé êàíàë SAM-ìîäóëÿ: îò 0 äî 3;
// Âîçâðàùàåìîå çíà÷åíèå:  0    óñïåøíîå âûïîëíåíèå,
//   èíà÷å  îøèáêà ïðè âûïîëíåíèè.
//
CLSCRF_API LONG CLSCRF_DECL
CLSCRF_SAM_Halt_A(IN LPVOID pReader,
IN BYTE ucLC);

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: ×òåíèå èç SAM-ìîäóëÿ çàïèñè î êëþ÷å
//------------------------------------------------------------------------------
//
typedef union _CLSCRF_SAM_SETTINGS
{
	struct
	{
		WORD bAllowDumpSessionKey:1;
		WORD bAllowCryptoWithSecretKey:1;
		WORD bfKeepInitVector:1;
		WORD wKeyKind:3;
		WORD RFU:2;
		WORD bAV1HigherCmdSecLevel:1;
		WORD bDisableKeyEntry:1;
		WORD bAV1EnableHostAuth:1;
		WORD bDisableChangeKey:1;
		WORD bDisableDecryption:1;
		WORD bDisableEncryption:1;
		WORD bDisableVerifyMAC:1;
		WORD bDisableGenerateMAC:1;
	};
	struct
	{
		WORD :8;
		WORD bAV2EnableHostAuthKey:1;
		WORD :1;
		WORD bAV1AV2AllowLockUnlock:1;
		WORD :5;
	};
	WORD wSettings;
} CLSCRF_SAM_SETTINGS;

typedef union _CLSCRF_SAM_EXT_SETTINGS
{
	struct
	{
		BYTE iKeyClass:3;
		BYTE bAllowDumpSecretKey:1;
		BYTE bRestrictToDiversifiedUse:1;
		BYTE RFU:3;
	};
	BYTE ucExtSettings;
} CLSCRF_SAM_EXT_SETTINGS;

typedef union _CLSCRF_SAM_NV_PROGRAMMING_MASK
{
	struct
	{
		BYTE fUpdateKeyA:1;
		BYTE fUpdateKeyB:1;
		BYTE fUpdateKeyC:1;
		BYTE fUpdateDFKeyNoAndAID:1;
		BYTE fUpdateKeyCEK_NumberAndVersion:1;
		BYTE fUpdateRefNoKUC:1;
		BYTE fUpdateSettings:1;
		BYTE fSendKeyVersionsSeparately:1;
	};
	BYTE ucNVProgramingMask;
} CLSCRF_SAM_NV_PROGRAMMING_MASK;

// ×òåíèå èç SAM-ìîäóëÿ çàïèñè î êëþ÷å
//
// pReader  ññûëêà íà îáúåêò-èíòåðôåéñ (ñì. ôóíêöèþ CLSCRF_Create);
// ucLC  ëîãè÷åñêèé êàíàë îò 0 äî 3;
// ucKeyKind - ðîä êëþ÷à:
//					0: TDEA - DESFire;
//					1: TDEA - ISO 10116(CRC16);
//					2: MIFARE;
//					3: 3 Key TDEA - ISO 10116;
//					4: AES 128;
//					5: AES 192;
//					6: TDEA - ISO 10116(CRC32);
// ucKeyNo - íîìåð Mifare-êëþ÷à â SAM-ìîäóëå îò 1 äî 127;
// pucKeyAVersion - ñ÷èòàííàÿ âåðñèÿ êëþ÷à A;
// pucKeyBVersion - ñ÷èòàííàÿ âåðñèÿ êëþ÷à B;
// pucKeyCVersion - ñ÷èòàííàÿ âåðñèÿ êëþ÷à C;
// pdwDESFireAID - 3 áàéòà ñîîòâåòñòâóþùèåãî AID äëÿ êàðò DESFire;
// pucDESFireKeyNo - ñîîòâåòñòâóþùèé AID, íîìåð êëþ÷à DESFire;
// pucKeyNoCEK - íîìåð ññûëêè íà êëþ÷ ñìåíû çàïèñè;
// pucKeyVCEK - âåðñèÿ êëþ÷à ñìåíû çàïèñè;
// pucRefNoKUC - íîìåð ññûëêè íà ñ÷¸ò÷èê èñïîëüçîâàíèÿ êëþ÷à;
// pSettings - íàñòðîéêè êîíôèãóðàöèè äëÿ çàïèñè êëþ÷à;
// pExtSettings - äîïîëíèòåëüíûå íàñòðîéêè êîíôèãóðàöèè äëÿ çàïèñè êëþ÷à;
// pucSW1  áàéò ñòàòóñà;
// pucSW2  áàéò ñòàòóñà.
//
// Âîçâðàùàåìîå çíà÷åíèå:  0    óñïåøíîå âûïîëíåíèå,
//   èíà÷å  îøèáêà ïðè âûïîëíåíèè.
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_GetKeyEntry(	IN LPVOID pReader,
									IN BYTE ucLC,
									IN BYTE ucKeyKind,
									IN BYTE ucKeyNo,
									OUT LPBYTE pucKeyAVersion,
									OUT LPBYTE pucKeyBVersion,
									OUT LPBYTE pucKeyCVersion,
									OUT LPDWORD pdwDESFireAID,
									OUT LPBYTE pucDESFireKeyNo,
									OUT LPBYTE pucKeyNoCEK,
									OUT LPBYTE pucKeyVCEK,
									OUT LPBYTE pucRefNoKUC,
									OUT CLSCRF_SAM_SETTINGS* pSettings,
									OUT CLSCRF_SAM_EXT_SETTINGS* pExtSettings,
									OUT LPBYTE pucSW1,
									OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Èçìåíåíèå â SAM-ìîäóëå çàïèñè î êëþ÷å
//------------------------------------------------------------------------------
//
// Èçìåíåíèå â SAM-ìîäóëå çàïèñè î êëþ÷å
//
// pReader  ññûëêà íà îáúåêò-èíòåðôåéñ (ñì. ôóíêöèþ CLSCRF_Create);
// ucLC  ëîãè÷åñêèé êàíàë îò 0 äî 3;
// ucKeyNo - íîìåð Mifare-êëþ÷à â SAM-ìîäóëå îò 1 äî 127;
// ucKeyKind - ðîä êëþ÷à:
//					0: TDEA - DESFire;
//					1: TDEA - ISO 10116(CRC16);
//					2: MIFARE;
//					3: 3 Key TDEA - ISO 10116;
//					4: AES 128;
//					5: AES 192;
//					6: TDEA - ISO 10116(CRC32);
// pbKeyA  - êëþ÷ A;
// pbKeyB  - êëþ÷ B;
// pbKeyC  - êëþ÷ C;
// pbDF_AID  - 3 áàéòà ñîîòâåòñòâóþùèåãî AID äëÿ êàðò DESFire;
// ucDF_KeyNr  - ñîîòâåòñòâóþùèé AID, íîìåð êëþ÷à DESFire;
// ucCEKNo - íîìåð ññûëêè íà êëþ÷ ñìåíû çàïèñè;
// ucCEKV  - âåðñèÿ êëþ÷à ñìåíû çàïèñè;
// ucKUC   - íîìåð ññûëêè íà ñ÷¸ò÷èê èñïîëüçîâàíèÿ êëþ÷à;
// pSettings - íàñòðîéêè êîíôèãóðàöèè äëÿ çàïèñè êëþ÷à;
// ucKeyVerA - âåðñèÿ êëþ÷à A;
// ucKeyVerB - âåðñèÿ êëþ÷à B;
// ucKeyVerC - âåðñèÿ êëþ÷à C;
// pExtSettings - äîïîëíèòåëüíûå íàñòðîéêè êîíôèãóðàöèè äëÿ çàïèñè êëþ÷à;
// fPlainKeyUpdate  óñòàíàâëèâàåò, â îòêðûòîì ëè âèäå îáíîâëÿåòñÿ êëþ÷;
// fOfflineKeyChange  ïðèçíàê òîãî, â êàêîì ðåæèìå ìåíÿåòñÿ êëþ÷ (Online/Offline);
// pbSAM_UID  UID SAM-ìîäóëÿ;
// pNVProgrammingMask  ìàñêà ïðîãðàììèðîâàíèÿ èç flash-ïàìÿòè;
// pucSW1  áàéò ñòàòóñà;
// pucSW2  áàéò ñòàòóñà.
//
// Âîçâðàùàåìîå çíà÷åíèå:  0    óñïåøíîå âûïîëíåíèå,
//   èíà÷å  îøèáêà ïðè âûïîëíåíèè.
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_ChangeKeyEntry(	IN LPVOID pReader,
										IN BYTE ucLC,
										IN BYTE ucKeyNo,
										IN BYTE ucKeyKind,
										IN LPBYTE pbKeyA,
										IN LPBYTE pbKeyB,
										IN LPBYTE pbKeyC,
										IN DWORD dwDF_AID,
										IN BYTE ucDF_KeyNr,
										IN BYTE ucCEKNo,
										IN BYTE ucCEKV,
										IN BYTE ucKUC,
										IN CLSCRF_SAM_SETTINGS* pSettings,
										IN BYTE ucKeyVerA,
										IN BYTE ucKeyVerB,
										IN BYTE ucKeyVerC,
										IN CLSCRF_SAM_EXT_SETTINGS* pExtSettings,
										IN BOOL fPlainKeyUpdate,
										IN BOOL fOfflineKeyChange,
										IN LPBYTE pbSAM_UID,
										IN CLSCRF_SAM_NV_PROGRAMMING_MASK* pNVProgrammingMask,
										OUT LPBYTE pucSW1,
										OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Îòêëþ÷åíèå â SAM-ìîäóëå çàïèñè î êëþ÷å
//------------------------------------------------------------------------------
//
// Îòêëþ÷åíèå â SAM-ìîäóëå çàïèñè î êëþ÷å
//
// pReader  ññûëêà íà îáúåêò-èíòåðôåéñ (ñì. ôóíêöèþ CLSCRF_Create);
// ucLC  ëîãè÷åñêèé êàíàë îò 0 äî 3;
// ucKeyNo - íîìåð Mifare-êëþ÷à â SAM-ìîäóëå îò 1 äî 127;
// ucKeyKind - ðîä êëþ÷à:
//					0: TDEA - DESFire;
//					1: TDEA - ISO 10116(CRC16);
//					2: MIFARE;
//					3: 3 Key TDEA - ISO 10116;
//					4: AES 128;
//					5: AES 192;
//					6: TDEA - ISO 10116(CRC32);
// pbSAM_UID  UID SAM-ìîäóëÿ;
// pucSW1  áàéò ñòàòóñà;
// pucSW2  áàéò ñòàòóñà.
//
// Âîçâðàùàåìîå çíà÷åíèå:  0    óñïåøíîå âûïîëíåíèå,
//   èíà÷å  îøèáêà ïðè âûïîëíåíèè.
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_DisableKeyEntry(	IN LPVOID pReader,
										IN BYTE ucLC,
										IN BYTE ucKeyNo,
										IN BYTE ucKeyKind,
										IN LPBYTE pbSAM_UID,
										OUT LPBYTE pucSW1,
										OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Âûïîëíèòü àóòåíòèôèêàöèþ êàðòû Mifare Classic
//------------------------------------------------------------------------------
//
// Âûïîëíèòü àóòåíòèôèêàöèþ êàðòû Mifare Classic
//
// pReader  ññûëêà íà îáúåêò-èíòåðôåéñ (ñì. ôóíêöèþ CLSCRF_Create);
// ucLC  ëîãè÷åñêèé êàíàë îò 0 äî 3;
// ucAuthType - òèï àóòåíòèôèêàöèè: 1 - First Authenticate, èíà÷å - Following Authenticate;
// pbUID[4] - óíèêàëüíûé íîìåð êàðòû;
// ucKeyNo - íîìåð Mifare-êëþ÷à â SAM-ìîäóëå îò 1 äî 127;
// ucKeyVer - âåðñèÿ Mifare-êëþ÷à â SAM-ìîäóëå îò 0 äî 255;
// ucKeyType - òèï Mifare-êëþ÷à: 0x0A - KeyA, èíà÷å KeyB;
// dwSector - íîìåð àóòåíòèôèöèðóåìîãî ñåêòîðà;
// pucSW1  áàéò ñòàòóñà;
// pucSW2  áàéò ñòàòóñà.
//
// Âîçâðàùàåìîå çíà÷åíèå:  0    óñïåøíîå âûïîëíåíèå,
//   èíà÷å  îøèáêà ïðè âûïîëíåíèè.
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifareAuthenticate(	IN LPVOID pReader,
											IN BYTE ucLC,
											IN BYTE ucAuthType,
											IN LPBYTE pbUID,
											IN BYTE ucKeyNo,
											IN BYTE ucKeyVer,
											IN BYTE ucKeyType,
											IN DWORD  dwSector,
											OUT LPBYTE pucSW1,
											OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Ïðî÷èòàòü áëîê êàðòû Mifare Classic
//------------------------------------------------------------------------------
//
// Ïðî÷èòàòü áëîê êàðòû Mifare Classic
//
// pReader  ññûëêà íà îáúåêò-èíòåðôåéñ (ñì. ôóíêöèþ CLSCRF_Create);
// ucLC  ëîãè÷åñêèé êàíàë îò 0 äî 3;
// dwSector     - íîìåð ñåêòîðà, ñîäåðæàùåãî ÷èòàåìûé áëîê;
// dwBlock      - íîìåð ÷èòàåìîãî áëîêà;
// pbRecvBuffer - ìàññèâ (íå ìåíåå 16 áàéòîâ) äëÿ ïðî÷èòàííîãî áëîêà;
// pucSW1  áàéò ñòàòóñà;
// pucSW2  áàéò ñòàòóñà.
//
// Âîçâðàùàåìîå çíà÷åíèå:  0    óñïåøíîå âûïîëíåíèå,
//   èíà÷å  îøèáêà ïðè âûïîëíåíèè.
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifareRead(	IN LPVOID pReader,
									IN BYTE ucLC,
									IN DWORD  dwSector,
									IN DWORD  dwBlock,
									OUT LPBYTE pbRecvBuffer,
									OUT LPBYTE pucSW1,
									OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Çàïèñàòü áëîê êàðòû Mifare Classic
//------------------------------------------------------------------------------
//
// Çàïèñàòü áëîê êàðòû Mifare Classic
//
// pReader  ññûëêà íà îáúåêò-èíòåðôåéñ (ñì. ôóíêöèþ CLSCRF_Create);
// ucLC  ëîãè÷åñêèé êàíàë îò 0 äî 3;
// dwSector     - íîìåð ñåêòîðà, ñîäåðæàùåãî çàïèñûâàåìûé áëîê;
// dwBlock      - íîìåð çàïèñûâàåìîãî áëîêà;
// pbSendBuffer - ìàññèâ (íå ìåíåå 16 áàéòîâ) äàííûõ çàïèñûâàåìîãî áëîêà;
// pucSW1  áàéò ñòàòóñà;
// pucSW2  áàéò ñòàòóñà.
//
// Âîçâðàùàåìîå çíà÷åíèå:  0    óñïåøíîå âûïîëíåíèå,
//   èíà÷å  îøèáêà ïðè âûïîëíåíèè.
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifareWrite( IN LPVOID pReader,
									IN BYTE ucLC,
									IN DWORD  dwSector,
									IN DWORD  dwBlock,
                                    IN LPBYTE pbSendBuffer,
									OUT LPBYTE pucSW1,
									OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Óâåëè÷èòü çíà÷åíèå - Ðàáîòà ñ áëîêîì Value êàðòû Mifare Classic
//------------------------------------------------------------------------------
//
// Óâåëè÷èâàåò çíà÷åíèå áëîêà òèïà Value
//
// pReader  ññûëêà íà îáúåêò-èíòåðôåéñ (ñì. ôóíêöèþ CLSCRF_Create);
// ucLC  ëîãè÷åñêèé êàíàë îò 0 äî 3;
// dwSector      - íîìåð ñåêòîðà, ñîäåðæàùåãî ÷èòàåìûé áëîê;
// dwSourceBlock - íîìåð èñõîäíîãî áëîêà;
// dwValue       - ñëàãàåìîå, íà êîòîðîå óâåëè÷èâàåòñÿ çíà÷åíèå;
// dwTargetBlock - íîìåð áëîêà-ðåçóëüòàòà, ìîæåò áûòü ðàâåí dwSourceBlock;
// pucSW1  áàéò ñòàòóñà;
// pucSW2  áàéò ñòàòóñà.
//
// Âîçâðàùàåìîå çíà÷åíèå:  0    óñïåøíîå âûïîëíåíèå,
//   èíà÷å  îøèáêà ïðè âûïîëíåíèè.
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifareIncrement(	IN LPVOID pReader,
										IN BYTE ucLC,
                                        IN DWORD  dwSector,
                                        IN DWORD  dwSourceBlock,
                                        IN DWORD  dwValue,
                                        IN DWORD  dwTargetBlock,
										OUT LPBYTE pucSW1,
										OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Óìåíüøèòü çíà÷åíèå - Ðàáîòà ñ áëîêîì Value êàðòû Mifare Classic
//------------------------------------------------------------------------------
//
// Óìåíüøàåò çíà÷åíèå áëîêà òèïà Value
//
// pReader  ññûëêà íà îáúåêò-èíòåðôåéñ (ñì. ôóíêöèþ CLSCRF_Create);
// ucLC  ëîãè÷åñêèé êàíàë îò 0 äî 3;
// dwSector     - íîìåð ñåêòîðà, ñîäåðæàùåãî çàïèñûâàåìûé áëîê;
// dwSourceBlock - íîìåð èñõîäíîãî áëîêà;
// dwValue       - âû÷èòàåìîå, íà êîòîðîå óìåíüøàåòñÿ çíà÷åíèå;
// dwTargetBlock - íîìåð áëîêà-ðåçóëüòàòà, ìîæåò áûòü ðàâåí dwSourceBlock;
// pucSW1  áàéò ñòàòóñà;
// pucSW2  áàéò ñòàòóñà.
//
// Âîçâðàùàåìîå çíà÷åíèå:  0    óñïåøíîå âûïîëíåíèå,
//   èíà÷å  îøèáêà ïðè âûïîëíåíèè.
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifareDecrement(	IN LPVOID pReader,
										IN BYTE ucLC,
                                        IN DWORD  dwSector,
                                        IN DWORD  dwSourceBlock,
                                        IN DWORD  dwValue,
                                        IN DWORD  dwTargetBlock,
										OUT LPBYTE pucSW1,
										OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Êîïèðîâàòü çíà÷åíèå - Ðàáîòà ñ áëîêîì Value êàðòû Mifare Classic
//------------------------------------------------------------------------------
//
// Êîïèðóåò çíà÷åíèå èç îäíîãî áëîêà òèïà Value â äðóãîé â çàäàííîì ñåêòîðå
//
// pReader  ññûëêà íà îáúåêò-èíòåðôåéñ (ñì. ôóíêöèþ CLSCRF_Create);
// ucLC  ëîãè÷åñêèé êàíàë îò 0 äî 3;
// dwSector      - íîìåð ñåêòîðà, ñîäåðæàùåãî îáà áëîêà;
// dwSourceBlock - íîìåð èñõîäíîãî áëîêà;
// dwTargetBlock - íîìåð áëîêà-ðåçóëüòàòà;
// pucSW1  áàéò ñòàòóñà;
// pucSW2  áàéò ñòàòóñà.
//
// Âîçâðàùàåìîå çíà÷åíèå:  0    óñïåøíîå âûïîëíåíèå,
//   èíà÷å  îøèáêà ïðè âûïîëíåíèè.
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifareRestore(	IN LPVOID pReader,
										IN BYTE ucLC,
                                        IN DWORD  dwSector,
                                        IN DWORD  dwSourceBlock,
                                        IN DWORD  dwTargetBlock,
										OUT LPBYTE pucSW1,
										OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Ñìåíà êëþ÷åé êàðòû Mifare Classic
//------------------------------------------------------------------------------
//
typedef union _CLSCRF_SAM_CK_PARAM_MASK
{
	struct
	{
		BYTE bEncrypt:1;
		BYTE bDiversifyKeyA:1;
		BYTE bDiversifyKeyB:1;
		BYTE RFU:5;
	};
	BYTE ucBits;
} CLSCRF_SAM_CK_PARAM_MASK;

//
// Ñìåíà êëþ÷åé êàðòû Mifare Classic
//
// pReader  ññûëêà íà îáúåêò-èíòåðôåéñ (ñì. ôóíêöèþ CLSCRF_Create);
// ucLC  ëîãè÷åñêèé êàíàë îò 0 äî 3;
// ucParamMask - ìàñêà ìåòîäà êîìïèëÿöèè êëþ÷åé è ìåòîä øèôðîâàíèÿ;
// ucKeyNo - íîìåð íîâîãî Mifare-êëþ÷à â SAM-ìîäóëå îò 1 äî 127;
// ucKeyVerA - âåðñèÿ íîâîãî Mifare-êëþ÷à KeyA â SAM-ìîäóëå îò 0 äî 255;
// ucKeyVerB - âåðñèÿ íîâîãî Mifare-êëþ÷à KeyB â SAM-ìîäóëå îò 0 äî 255;
// dwSector     - íîìåð ñåêòîðà, ñîäåðæàùåãî áëîê;
// pbAccess[4] - íîâûå áèòû äîñòóïà â òðåéëåðå;
// pbUID[4] - óíèêàëüíûé íîìåð êàðòû (íå òðåáóåòñÿ, åñëè Crypto ðàâåí 0);
// pucSW1  áàéò ñòàòóñà;
// pucSW2  áàéò ñòàòóñà.
//
// Âîçâðàùàåìîå çíà÷åíèå:  0    óñïåøíîå âûïîëíåíèå,
//   èíà÷å  îøèáêà ïðè âûïîëíåíèè.
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifareChangeKey(	IN LPVOID pReader,
										IN BYTE ucLC,
										IN CLSCRF_SAM_CK_PARAM_MASK ParamMask,
										IN BYTE ucKeyNo,
										IN BYTE ucKeyVerA,
										IN BYTE ucKeyVerB,
										IN DWORD  dwSector,
										IN LPBYTE pbAccess,
										IN LPBYTE pbUID,
										OUT LPBYTE pucSW1,
										OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Êîìïëåêñíàÿ ðàáîòà ñ êàðòîé Mifare Classic
//------------------------------------------------------------------------------
//
// Âûïîëíÿåò ñåðèþ îïåðàöèé íàä êàðòîé Mifare Classic (èëè Mifare Plus â ðåæèìå SL1).
//
// pReader  ññûëêà íà îáúåêò-èíòåðôåéñ (ñì. ôóíêöèþ CLSCRF_Create);
// ucSAMLC  ëîãè÷åñêèé êàíàë SAM-ìîäóëÿ: îò 0 äî 3;
// ucSAMHolder  íîìåð èñïîëüçóåìîãî äåðæàòåëÿ ìîäóëÿ: îò 0 äî 4, 0 - íå èçìåíÿòü;
// ucSAMKeyNo - íîìåð Mifare-êëþ÷à â SAM-ìîäóëå îò 1 äî 127 (åñëè 0, òî íå âûïîëíÿòü àóòåíòèôèêàöèþ);
// ucSAMKeyVer - âåðñèÿ Mifare-êëþ÷à â SAM-ìîäóëå îò 0 äî 255;
// ucSAMResetType - âèä îïåðàöèè ñáðîñà SAM-ìîäóëÿ:
//              0x00 - Don't SAM Reset (íå ïðîèçâîäèòü ñáðîñ SAM-ìîäóëÿ)
//              0x01 - Card Authentication Reset (ñáðîñ àóòåíòèôèêàöèè êàðòû, ðåêîìåíäóåòñÿ)
//              0x02 - All Authentication Reset (ñáðîñ âñåé àóòåíòèôèêàöèè)
//              0x03 - Hard Reset (õîëîäíûé ñáðîñ)
// ucRfOffTime - èíòåðâàë âðåìåíè [ìñ], â òå÷åíèå êîòîðîãî ÝÌÏ âûêëþ÷åíî. 
//               Åñëè ýòîò ïàðàìåòð ïëþñ ucRfOnPauseTime ðàâíî 0, òî ÝÌÏ íå âûêëþ÷àåòñÿ, 
//               è êîìàíäà Activate Idle íå ïîäàåòñÿ, è åñëè ucSAMKeyNo > 0, òî âûïîëíÿåòñÿ
//               âòîðè÷íàÿ àóòåíòèôèêàöèÿ êàðòû;
//               Åñëè ýòîò ïàðàìåòð ïëþñ ucRfOnPauseTime íå ðàâíî 0, òî êîìàíäà Activate Idle ïîäàåòñÿ, 
//               è åñëè ucSAMKeyNo > 0, òî âûïîëíÿåòñÿ ïåðâè÷íàÿ àóòåíòèôèêàöèÿ êàðòû;
// ucRfOnPauseTime - èíòåðâàë âðåìåíè [ìñ], â òå÷åíèå êîòîðîãî (+5 ìñ) ïîñëå âêëþ÷åíèÿ ÝÌÏ êàðòà 
//                  íàêàïëèâàåò ýíåðãèþ äëÿ îáåñïå÷åíèÿ âûïîëíåíèÿ äàëüíåéøèõ îïåðàöèé;
// ucMifareKeyType - òèï Mifare-êëþ÷à: 0x0A - KeyA, 0x0B - KeyB;
// ucMifareOperation - òèï îïåðàöèè:
//              0x01 - ×òåíèå
//              0x02 - Çàïèñü
//              0x03 - Çàïèñü è ïîñëåäóþùåå ÷òåíèå;
// ucMifareSector - íîìåð àóòåíòèôèöèðóåìîãî ñåêòîðà;
// ucMifareBlock  - íîìåð íà÷àëüíîãî áëîêà â ýòîì ñåêòîðå;
// ucMifareBlocksCount - êîëè÷åñòâî îáðàáàòûâàåìûõ áëîêîâ â âåêòîðå;
// pucATQ   - ññûëêà íà ìàññèâ (2 áàéòà), â êîòîðûå áóäåò ïîìåùåí ATQ êàðòû
// pucSAK   - ññûëêà íà ìàññèâ (1 áàéò), â êîòîðûé áóäåò ïîìåùåí SAK êàðòû
// pucUID   - ññûëêà íà ìàññèâ (íå ìåíåå 10 áàéòîâ), â êîòîðûé áóäåò
//           ïîìåùåí óíèêàëüíûé èäåíòèôèêàòîð êàðòû (UID);
// pucUIDLength - ññûëêà íà ïåðåìåííóþ òèïà BYTE, êîòîðàÿ ïåðåä âûçîâîì
//                ôóíêöèè äîëæíà ñîäåðæàòü ðàçìåð ìàññèâà pucUID, à íà âûõîäå
//                áóäåò ñîäåðæàòü äåéñòâèòåëüíóþ äëèíó óíèêàëüíîãî
//                èäåíòèôèêàòîðà êàðòû, ïîìåùåííîãî â ìàññèâ pucUID
//                (âîçìîæíûå çíà÷åíèÿ - 0, 4, 7 èëè 10)
// pucWriteData - ìàññèâ äàííûõ çàïèñûâàåìûõ áëîêîâ (äîïóñòèì NULL, åñëè íåò çàïèñè);
// pucReadData - ìàññèâ (íå ìåíåå ucMifareBlocksCount*16 áàéòîâ) äëÿ ïðî÷èòàííûõ áëîêîâ (äîïóñòèì NULL, åñëè íåò ÷òåíèÿ);
// pucLastTask - ññûëêà íà áàéòîâóþ ïåðåìåííóþ, â êîòîðóþ áóäåò ïîìåùåí êîä ïîñëåäíåé îïåðàöèè:
//              0x01 - RF Reset,
//              0x02 - ActivateIdleA,
//              0x03 - SAM SetHolder,
//              0x04 - SAM Reset,
//              0x05 - RFU,
//              0x06 - SAM_MifareAuthenticate,
//              0x07 - SAM_MifareWrite,
//              0x08 - SAM_MifareRead,
//              0x09 - Íåèçâåñòíàÿ îïåðàöèÿ;
// pucResBlkCnt - ññûëêà íà áàéòîâóþ ïåðåìåííóþ, â êîòîðóþ áóäåò ïîìåùåíî êîëè÷åñòâî 
//                îáðàáîòàííûõ áëîêîâ;
// pucSW1  áàéò ñòàòóñà;
// pucSW2  áàéò ñòàòóñà.
//
// Âîçâðàùàåìîå çíà÷åíèå:  0    óñïåøíîå âûïîëíåíèå,
//   èíà÷å  îøèáêà ïðè âûïîëíåíèè.
//
CLSCRF_API LONG CLSCRF_DECL
CLSCRF_SAM_Mifare_Complex(IN LPVOID pReader,
IN BYTE ucSAMLC,
IN BYTE ucSAMHolder,
IN BYTE ucSAMKeyNo,
IN BYTE ucSAMKeyVer,
IN BYTE ucSAMResetType,
IN BYTE ucRfOffTime,
IN BYTE ucRfOnPauseTime,
IN BYTE ucMifareKeyType,
IN BYTE ucMifareOperation,
IN BYTE ucMifareSector,
IN BYTE ucMifareBlock,
IN BYTE ucMifareBlocksCount,
OUT LPBYTE pucATQ,
OUT LPBYTE pucSAK,
OUT LPBYTE pucUID,
IN OUT LPBYTE pucUIDLength,
IN LPBYTE pucWriteData,
OUT LPBYTE pucReadData,
OUT LPBYTE pucLastTask,
OUT LPBYTE pucResBlkCnt,
OUT LPBYTE pucSW1,
OUT LPBYTE pucSW2);


//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//==============================================================================
//   Ð À Á Î Ò À    Ñ    Ê À Ð Ò À Ì È    M I F A R E    U L T R A L I G H T (C)
//==============================================================================
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  Äëÿ êàðò Ultra Light C: Çàïèñü êëþ÷à
//------------------------------------------------------------------------------
//
// Ïðîèçâîäèò çàïèñü â êàðòó êëþ÷à èç SAM-ìîäóëÿ 
//
// pReader      - ññûëêà íà îáúåêò-èíòåðôåéñ (ñì. ôóíêöèþ CLSCRF_Create )
// ucLC  ëîãè÷åñêèé êàíàë îò 0 äî 3;
// pbUID[7] - óíèêàëüíûé íîìåð êàðòû;
// ucKeyNo - íîìåð Mifare-êëþ÷à â SAM-ìîäóëå îò 1 äî 127;
// ucKeyVer - âåðñèÿ Mifare-êëþ÷à â SAM-ìîäóëå îò 0 äî 255;
// pucSW1  áàéò ñòàòóñà;
// pucSW2  áàéò ñòàòóñà.
//
// Âîçâðàùàåìîå çíà÷åíèå:  0   - óñïåøíîå âûïîëíåíèå
//                       èíà÷å - îøèáêà ïðè âûïîëíåíèè
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifareUltralightC_WriteKey(	IN LPVOID pReader,
													IN BYTE ucLC,
													IN LPBYTE pbUID,
													IN BYTE ucKeyNo,
													IN BYTE ucKeyVer,
													OUT LPBYTE pucSW1,
													OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  Äëÿ êàðò Ultra Light C: Àóòåíòèôèêàöèÿ
//------------------------------------------------------------------------------
//
// Ïðîèçâîäèò àóòåíòèôèêàöèþ ïî êëþ÷ó â SAM-ìîäóëå
//
// pReader      - ññûëêà íà îáúåêò-èíòåðôåéñ (ñì. ôóíêöèþ CLSCRF_Create )
// ucLC  ëîãè÷åñêèé êàíàë îò 0 äî 3;
// pbUID[7] - óíèêàëüíûé íîìåð êàðòû;
// ucKeyNo - íîìåð Mifare-êëþ÷à â SAM-ìîäóëå îò 1 äî 127;
// ucKeyVer - âåðñèÿ Mifare-êëþ÷à â SAM-ìîäóëå îò 0 äî 255;
// pucSW1  áàéò ñòàòóñà;
// pucSW2  áàéò ñòàòóñà.
//
// Âîçâðàùàåìîå çíà÷åíèå:  0   - óñïåøíîå âûïîëíåíèå
//                       èíà÷å - îøèáêà ïðè âûïîëíåíèè
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifareUltralightC_Authenticate(	IN LPVOID pReader,
														IN BYTE ucLC,
														IN LPBYTE pbUID,
														IN BYTE ucKeyNo,
														IN BYTE ucKeyVer,
														OUT LPBYTE pucSW1,
														OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Mifare Plus: Çàïèñü èíôîðìàöèè ïåðñîíàëèçàöèè
//------------------------------------------------------------------------------
//
// Çàïèñûâàåò äàííûå ïåðñîíàëèçàöèè â êàðòó
//
// pReader       - ññûëêà íà îáúåêò-èíòåðôåéñ (ñì. ôóíêöèþ CLSCRF_Create )
// ucLC			  ëîãè÷åñêèé êàíàë îò 0 äî 3;
// ucValueType   - òèï çàïèñûâàåìîãî çíà÷åíèÿ (ñì. òàáëèöó)
// ucSectorNumber- íîìåð ñåêòîðà (èñïîëüçóåòñÿ ïðè çàïèñè áëîêà äàííûõ èëè êëþ÷à, 
//                 îòíîñÿùåãîñÿ ê îïðåäåëåííîìó ñåêòîðó)
// ucBlockNumber - íîìåð áëîêà (èñïîëüçóåòñÿ ïðè çàïèñè áëîêà äàííûõ èëè êëþ÷à, 
//                 îòíîñÿùåãîñÿ ê îïðåäåëåííîìó áëîêó â ñåêòîðå)
// ucKeyNumber   - íîìåð Mifare-êëþ÷à â SAM-ìîäóëå îò 1 äî 127;
// ucKeyVersion  - âåðñèÿ Mifare-êëþ÷à â SAM-ìîäóëå îò 0 äî 255;
// ucLenDiv      - äëèíà âõîäíîãî âåêòîðà äèâåðñèôèêàöèè êëþ÷à;
// pbDiv		 - âõîäíîé âåêòîð äèâåðñèôèêàöèè êëþ÷à;
// pucSW1		  áàéò ñòàòóñà;
// pucSW2		  áàéò ñòàòóñà.
//
// Âîçâðàùàåìîå çíà÷åíèå:  0   - óñïåøíîå âûïîëíåíèå
//                       èíà÷å - îøèáêà ïðè âûïîëíåíèè
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifarePlus_WritePerso(	IN LPVOID pReader,
												IN BYTE  ucLC,
												IN BYTE  ucValueType,
												IN BYTE  ucSectorNumber,
												IN BYTE  ucBlockNumber,
												IN BYTE  ucKeyNumber,
												IN BYTE  ucKeyVersion,
												IN BYTE  ucLenDiv,
												IN LPBYTE pbDiv,
												OUT LPBYTE pucSW1,
												OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Mifare Plus: Çàâåðøåíèå ïåðñîíàëèçàöèè
//------------------------------------------------------------------------------
//
// Çàâåðøàåò ïåðñîíàëèçàöèþ êàðòû
//
// pReader       - ññûëêà íà îáúåêò-èíòåðôåéñ (ñì. ôóíêöèþ CLSCRF_Create )
// ucLC			  ëîãè÷åñêèé êàíàë îò 0 äî 3;
// pucSW1		  áàéò ñòàòóñà;
// pucSW2		  áàéò ñòàòóñà.
//
// Âîçâðàùàåìîå çíà÷åíèå:  0   - óñïåøíîå âûïîëíåíèå
//                       èíà÷å - îøèáêà ïðè âûïîëíåíèè
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifarePlus_CommitPerso(	IN LPVOID pReader,
												IN BYTE  ucLC,
												OUT LPBYTE pucSW1,
												OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: MifarePlus: Àóòåíòèôèêàöèÿ êàðòû
//------------------------------------------------------------------------------
//
// Àóòåíòèôèêàöèÿ êàðòû Mifare Plus
//
// pReader       - ññûëêà íà îáúåêò-èíòåðôåéñ (ñì. ôóíêöèþ CLSCRF_Create );
// ucLC			  ëîãè÷åñêèé êàíàë îò 0 äî 3;
// ucAuthType	 - òèï àóòåíòèôèêàöèè ïî ñïåöèôèêàöèè (ñì. òàáëèöó);
// ucSecLevel	 - óðîâåíü çàùèòû êàðòû (0x00 - äëÿ SL0, SL1; 0x01 - äëÿ SL2; 0x03 - äëÿ SL3);
// ucKeyType     - òèï êëþ÷à äëÿ àóòåíòèôèêàöèè (ñì. òàáëèöó);
// ucSectorNumber- íîìåð ñåêòîðà äëÿ àóòåíòèôèêàöèè;
// ucKeyNumber   - íîìåð Mifare-êëþ÷à â SAM-ìîäóëå îò 1 äî 127;
// ucKeyVersion  - âåðñèÿ Mifare-êëþ÷à â SAM-ìîäóëå îò 0 äî 255;
// ucLenCap      - äëèíà áëîêà õàðàêòåðèñòèê ñ÷èòûâàòåëÿ (0..6, óñòàíîâèòü â 0);
// pbPcdCap      - áëîê õàðàêòåðèñòèê ñ÷èòûâàòåëÿ (ïîêà îòñóòñòâóåò);
// ucLenDiv      - äëèíà âõîäíîãî âåêòîðà äèâåðñèôèêàöèè êëþ÷à;
// pbDiv		 - âõîäíîé âåêòîð äèâåðñèôèêàöèè êëþ÷à;
// pucSW1		  áàéò ñòàòóñà;
// pucSW2		  áàéò ñòàòóñà.
//
// Âîçâðàùàåìîå çíà÷åíèå:  0    óñïåøíîå âûïîëíåíèå,
//   èíà÷å  îøèáêà ïðè âûïîëíåíèè.
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifarePlus_Authenticate(	IN LPVOID pReader,
												IN BYTE ucLC,
												IN BYTE  ucAuthType,
												IN BYTE  ucSecLevel,
												IN BYTE  ucKeyType,
												IN BYTE  ucSectorNumber,
												IN BYTE  ucKeyNumber,
												IN BYTE  ucKeyVersion,
												IN BYTE  ucLenCap,
												IN LPBYTE pbPcdCap,
												IN BYTE  ucLenDiv,
												IN LPBYTE pbDiv,
												OUT LPBYTE pucSW1,
												OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Mifare Plus: ×òåíèå íåñêîëüêèõ áëîêîâ SL2
//------------------------------------------------------------------------------
//
// Äëÿ êàðòû â ðåæèìå SL2, ïðîèçâîäèò ìíîæåñòâåííîå ÷òåíèå áëîêîâ
//
// pReader       - ññûëêà íà îáúåêò-èíòåðôåéñ (ñì. ôóíêöèþ CLSCRF_Create )
// ucLC			  ëîãè÷åñêèé êàíàë îò 0 äî 3;
// ucSectorNumber - íîìåð ñåêòîðà
// ucBlockNumber - íîìåð áëîêà, ñ êîòîðîãî íóæíî íà÷èíàòü ÷òåíèå
// ucBlocksCount - êîëè÷åñòâî ÷èòàåìûõ áëîêîâ
// pbData		 - óêàçàòåëü íà áàéòîâûé ìàññèâ, â êîòîðûé áóäóò çàïèñàíû äàííûå
// pucSW1		  áàéò ñòàòóñà;
// pucSW2		  áàéò ñòàòóñà.
//
// Âîçâðàùàåìîå çíà÷åíèå:  0   - óñïåøíîå âûïîëíåíèå
//                       èíà÷å - îøèáêà ïðè âûïîëíåíèè
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifarePlus_MultiBlockRead(	IN LPVOID pReader,
													IN BYTE ucLC,
													IN BYTE ucSectorNumber,
													IN BYTE ucBlockNumber,
													IN BYTE ucBlocksCount,
													OUT LPBYTE pbData,
													OUT LPBYTE pucSW1,
													OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Mifare Plus: Çàïèñü íåñêîëüêèõ áëîêîâ SL2
//------------------------------------------------------------------------------
//
// Äëÿ êàðòû â ðåæèìå SL2, ïðîèçâîäèò ìíîæåñòâåííóþ çàïèñü áëîêîâ
//
// pReader       - ññûëêà íà îáúåêò-èíòåðôåéñ (ñì. ôóíêöèþ CLSCRF_Create )
// ucLC			  ëîãè÷åñêèé êàíàë îò 0 äî 3;
// ucSectorNumber - íîìåð ñåêòîðà
// ucBlockNumber - íîìåð íà÷àëüíîãî áëîêà äëÿ çàïèñè
// ucBlocksCount - êîëè÷åñòâî çàïèñûâàåìûõ áëîêîâ
// pbData		 - óêàçàòåëü íà áàéòîâûé ìàññèâ ñ äàííûìè äëÿ çàïèñè
// pucSW1		  áàéò ñòàòóñà;
// pucSW2		  áàéò ñòàòóñà.
//
// Âîçâðàùàåìîå çíà÷åíèå:  0   - óñïåøíîå âûïîëíåíèå
//                       èíà÷å - îøèáêà ïðè âûïîëíåíèè
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifarePlus_MultiBlockWrite(	IN LPVOID pReader,
													IN BYTE ucLC,
													IN BYTE ucSectorNumber,
													IN BYTE ucBlockNumber,
													IN BYTE ucBlocksCount,
													IN LPBYTE pbData,
													OUT LPBYTE pucSW1,
													OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Mifare Plus: ×òåíèå äàííûõ
//------------------------------------------------------------------------------
//
// Äëÿ êàðòû â ðåæèìå SL3, ïðîèçâîäèò ÷òåíèå äàííûõ
//
// pReader       - ññûëêà íà îáúåêò-èíòåðôåéñ (ñì. ôóíêöèþ CLSCRF_Create )
// ucLC			  ëîãè÷åñêèé êàíàë îò 0 äî 3;
// ucReadMode    - ðåæèì çàùèòû äàííûõ (ñì. òàáëèöó);
// ucValueType   - òèï ÷èòàåìîãî çíà÷åíèÿ (ñì. òàáëèöó 117 â ðóêîâîäñòâå MifarePlus);
// ucSectorNumber - íîìåð ñåêòîðà ñ ÷èòàåìûì áëîêîì;
// ucBlockNumber - íîìåð íà÷àëüíîãî áëîêà äëÿ ÷òåíèÿ;
// ucBlocksCount - êîëè÷åñòâî ÷èòàåìûõ áëîêîâ;
// pbData		 - óêàçàòåëü íà áàéòîâûé ìàññèâ, â êîòîðûé áóäóò çàïèñàíû äàííûå;
// pucSW1		  áàéò ñòàòóñà;
// pucSW2		  áàéò ñòàòóñà.
//
// Âîçâðàùàåìîå çíà÷åíèå:  0   - óñïåøíîå âûïîëíåíèå,
//                       èíà÷å - îøèáêà ïðè âûïîëíåíèè.
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifarePlus_ReadData(	IN LPVOID pReader,
											IN BYTE ucLC,
											IN BYTE ucReadMode,
											IN BYTE ucValueType,
											IN BYTE ucSectorNumber,
											IN BYTE ucBlockNumber,
											IN BYTE ucBlocksCount,
											OUT LPBYTE pbData,
											OUT LPBYTE pucSW1,
											OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Mifare Plus: Çàïèñü äàííûõ
//------------------------------------------------------------------------------
//
// Äëÿ êàðòû â ðåæèìå SL3, ïðîèçâîäèò çàïèñü äàííûõ
//
// pReader       - ññûëêà íà îáúåêò-èíòåðôåéñ (ñì. ôóíêöèþ CLSCRF_Create );
// ucLC			  ëîãè÷åñêèé êàíàë îò 0 äî 3;
// ucWriteMode   - ðåæèì çàùèòû äàííûõ (ñì. òàáëèöó);
// ucValueType   - òèï çàïèñûâàåìîãî çíà÷åíèÿ (ñì. òàáëèöó 117 â ðóêîâîäñòâå MifarePlus);
// ucSectorNumber - íîìåð ñåêòîðà äëÿ çàïèñè áëîêà;
// ucBlockNumber - íîìåð íà÷àëüíîãî áëîêà äëÿ çàïèñè;
// ucBlocksCount - êîëè÷åñòâî çàïèñûâàåìûõ áëîêîâ;
// pbData		 - óêàçàòåëü íà áàéòîâûé ìàññèâ, èç êîòîðãî áóäóò áðàòüñÿ äàííûå äëÿ çàïèñè;
// pucSW1		  áàéò ñòàòóñà;
// pucSW2		  áàéò ñòàòóñà.
//
// Âîçâðàùàåìîå çíà÷åíèå:  0   - óñïåøíîå âûïîëíåíèå,
//                       èíà÷å - îøèáêà ïðè âûïîëíåíèè.
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifarePlus_WriteData(	IN LPVOID pReader,
												IN BYTE ucLC,
												IN BYTE ucWriteMode,
												IN BYTE ucValueType,
												IN BYTE ucSectorNumber,
												IN BYTE ucBlockNumber,
												IN BYTE ucBlocksCount,
												IN LPBYTE pbData,
												OUT LPBYTE pucSW1,
												OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Mifare Plus: Ñìåíà êëþ÷à
//------------------------------------------------------------------------------
//
// Äëÿ êàðòû â ðåæèìå SL3, ïðîèçâîäèò ñìåíó êëþ÷à
//
// pReader       - ññûëêà íà îáúåêò-èíòåðôåéñ (ñì. ôóíêöèþ CLSCRF_Create );
// ucLC			 - ëîãè÷åñêèé êàíàë îò 0 äî 3;
// ucEncryptionMode - ðåæèì çàùèòû äàííûõ (0x00 - øèôðàöèÿ, MAC â çàïðîñå; 0x01 - øèôðàöèÿ, MAC â çàïðîñå, MAC â îòâåòå);
// ucKeyType     - òèï êëþ÷à äëÿ àóòåíòèôèêàöèè (ñì. òàáëèöó);
// ucSectorNumber - íîìåð ñåêòîðà äëÿ çàïèñè áëîêà;
// ucKeyNumber   - íîìåð Mifare-êëþ÷à â SAM-ìîäóëå îò 1 äî 127;
// ucKeyVersion  - âåðñèÿ Mifare-êëþ÷à â SAM-ìîäóëå îò 0 äî 255;
// ucLenDiv		 - äëèíà âõîäíîãî âåêòîðà äèâåðñèôèêàöèè êëþ÷à;
// pbDiv		 - âõîäíîé âåêòîð äèâåðñèôèêàöèè êëþ÷à;
// pucSW1		  áàéò ñòàòóñà;
// pucSW2		  áàéò ñòàòóñà.
//
// Âîçâðàùàåìîå çíà÷åíèå:  0   - óñïåøíîå âûïîëíåíèå,
//                       èíà÷å - îøèáêà ïðè âûïîëíåíèè.
//
CLSCRF_API LONG CLSCRF_DECL
CLSCRF_SAM_MifarePlus_ChangeKey(IN LPVOID pReader,
IN BYTE ucLC,
IN BYTE ucEncryptionMode,
IN BYTE ucKeyType,
IN BYTE ucSectorNumber,
IN BYTE ucKeyNumber,
IN BYTE ucKeyVersion,
IN BYTE ucLenDiv,
IN LPBYTE pbDiv,
OUT LPBYTE pucSW1,
OUT LPBYTE pucSW2);

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Mifare Plus: Óâåëè÷åíèå ñ÷åò÷èêà
//------------------------------------------------------------------------------
//
// Äëÿ êàðòû â ðåæèìå SL3, ïðîèçâîäèò óâåëè÷åíèå çíà÷åíèÿ ñ÷åò÷èêà
// è ïîñëåäóþùóþ çàïèñü óâåëè÷åííîãî çíà÷åíèÿ â áóôåð ïåðåíîñà (Transfer Buffer) 
//
// pReader       - ññûëêà íà îáúåêò-èíòåðôåéñ (ñì. ôóíêöèþ CLSCRF_Create );
// ucLC			  ëîãè÷åñêèé êàíàë îò 0 äî 3;
// ucEncryptionMode - ðåæèì çàùèòû äàííûõ (ñì. òàáëèöó);
// ucSourceSectorNumber - íîìåð èñõîäíîãî ñåêòîðà;
// ucSourceBlockNumber - íîìåð èñõîäíîãî áëîêà;
// dwValue		 - ïðèáàâëÿåìîå ê ñ÷åò÷èêó çíà÷åíèå;
// pucSW1		  áàéò ñòàòóñà;
// pucSW2		  áàéò ñòàòóñà.
//
// Âîçâðàùàåìîå çíà÷åíèå:  0   - óñïåøíîå âûïîëíåíèå,
//                       èíà÷å - îøèáêà ïðè âûïîëíåíèè.
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifarePlus_Increment(	IN LPVOID pReader,
												IN BYTE ucLC,
												IN BYTE ucEncryptionMode,
												IN BYTE ucSourceSectorNumber,
												IN BYTE ucSourceBlockNumber,
												IN DWORD dwValue,
												OUT LPBYTE pucSW1,
												OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Mifare Plus: Óìåíüøåíèå ñ÷åò÷èêà
//------------------------------------------------------------------------------
//
// Äëÿ êàðòû â ðåæèìå SL3, ïðîèçâîäèò óìåíüøåíèå çíà÷åíèÿ ñ÷åò÷èêà
// è ïîñëåäóþùóþ çàïèñü óìåíüøåííîãî çíà÷åíèÿ â áóôåð ïåðåíîñà (Transfer Buffer) 
//
// pReader       - ññûëêà íà îáúåêò-èíòåðôåéñ (ñì. ôóíêöèþ CLSCRF_Create );
// ucLC			  ëîãè÷åñêèé êàíàë îò 0 äî 3;
// ucEncryptionMode - ðåæèì çàùèòû äàííûõ (ñì. òàáëèöó);
// ucSourceSectorNumber - íîìåð èñõîäíîãî ñåêòîðà;
// ucSourceBlockNumber - íîìåð èñõîäíîãî áëîêà;
// dwValue		 - âû÷èòàåìîå èç ñ÷åò÷èêà çíà÷åíèå;
// pucSW1		  áàéò ñòàòóñà;
// pucSW2		  áàéò ñòàòóñà.
//
// Âîçâðàùàåìîå çíà÷åíèå:  0   - óñïåøíîå âûïîëíåíèå,
//                       èíà÷å - îøèáêà ïðè âûïîëíåíèè.
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifarePlus_Decrement(	IN LPVOID pReader,
												IN BYTE ucLC,
												IN BYTE ucEncryptionMode,
												IN BYTE ucSourceSectorNumber,
												IN BYTE ucSourceBlockNumber,
												IN DWORD dwValue,
												OUT LPBYTE pucSW1,
												OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Mifare Plus: Çàïèñü äàííûõ áóôåðà ïåðåíîñà
//------------------------------------------------------------------------------
//
// Äëÿ êàðòû â ðåæèìå SL3, çàïèñûâàåò äàííûå áóôåðà ïåðåíîñà (Transfer Buffer) 
// â óêàçàííûé áëîê
//
// pReader       - ññûëêà íà îáúåêò-èíòåðôåéñ (ñì. ôóíêöèþ CLSCRF_Create );
// ucLC			  ëîãè÷åñêèé êàíàë îò 0 äî 3;
// ucEncryptionMode - ðåæèì çàùèòû äàííûõ (ñì. òàáëèöó);
// ucDestinationSectorNumber - íîìåð ñåêòîðà äëÿ çàïèñè;
// ucDestinationBlockNumber - íîìåð áëîêà äëÿ çàïèñè;
// pucSW1		  áàéò ñòàòóñà;
// pucSW2		  áàéò ñòàòóñà.
//
// Âîçâðàùàåìîå çíà÷åíèå:  0   - óñïåøíîå âûïîëíåíèå,
//                       èíà÷å - îøèáêà ïðè âûïîëíåíèè.
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifarePlus_Transfer(	IN LPVOID pReader,
											IN BYTE ucLC,
											IN BYTE ucEncryptionMode,
											IN BYTE ucDestinationSectorNumber,
											IN BYTE ucDestinationBlockNumber,
											OUT LPBYTE pucSW1,
											OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Mifare Plus: Óâåëè÷åíèå ñ÷åò÷èêà è çàïèñü äàííûõ áóôåðà ïåðåíîñà
//------------------------------------------------------------------------------
//
// Äëÿ êàðòû â ðåæèìå SL3, ïðîèçâîäèò óâåëè÷åíèå çíà÷åíèÿ ñ÷åò÷èêà,
// çàïèñü óâåëè÷åííîãî çíà÷åíèÿ â áóôåð ïåðåíîñà (Transfer Buffer) è çàòåì
// â óêàçàííûé áëîê
//
// pReader       - ññûëêà íà îáúåêò-èíòåðôåéñ (ñì. ôóíêöèþ CLSCRF_Create )
// ucLC			  ëîãè÷åñêèé êàíàë îò 0 äî 3;
// ucEncryptionMode - ðåæèì çàùèòû äàííûõ (ñì. òàáëèöó);
// ucSourceSectorNumber - íîìåð èñõîäíîãî ñåêòîðà;
// ucSourceBlockNumber - íîìåð èñõîäíîãî áëîêà;
// ucDestinationSectorNumber - íîìåð ñåêòîðà äëÿ çàïèñè;
// ucDestinationBlockNumber - íîìåð áëîêà äëÿ çàïèñè;
// dwValue		 - ïðèáàâëÿåìîå ê ñ÷åò÷èêó çíà÷åíèå;
// pucSW1		  áàéò ñòàòóñà;
// pucSW2		  áàéò ñòàòóñà.
//
// Âîçâðàùàåìîå çíà÷åíèå:  0   - óñïåøíîå âûïîëíåíèå,
//                       èíà÷å - îøèáêà ïðè âûïîëíåíèè.
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifarePlus_IncrementTransfer(	IN LPVOID pReader,
														IN BYTE ucLC,
														IN BYTE ucEncryptionMode,
														IN BYTE ucSourceSectorNumber,
														IN BYTE ucSourceBlockNumber,
														IN BYTE ucDestinationSectorNumber,
														IN BYTE ucDestinationBlockNumber,
														IN DWORD dwValue,
														OUT LPBYTE pucSW1,
														OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Mifare Plus: Óìåíüøåíèå ñ÷åò÷èêà è çàïèñü äàííûõ áóôåðà ïåðåíîñà
//------------------------------------------------------------------------------
//
// Äëÿ êàðòû â ðåæèìå SL3, ïðîèçâîäèò óìåíüøåíèå çíà÷åíèÿ ñ÷åò÷èêà,
// çàïèñü óìåíüøåííîãî çíà÷åíèÿ â áóôåð ïåðåíîñà (Transfer Buffer) è çàòåì
// â óêàçàííûé áëîê
//
// pReader       - ññûëêà íà îáúåêò-èíòåðôåéñ (ñì. ôóíêöèþ CLSCRF_Create );
// ucLC			  ëîãè÷åñêèé êàíàë îò 0 äî 3;
// ucEncryptionMode - ðåæèì çàùèòû äàííûõ (ñì. òàáëèöó);
// ucSourceSectorNumber - íîìåð èñõîäíîãî ñåêòîðà;
// ucSourceBlockNumber - íîìåð èñõîäíîãî áëîêà;
// ucDestinationSectorNumber - íîìåð ñåêòîðà äëÿ çàïèñè;
// ucDestinationBlockNumber - íîìåð áëîêà äëÿ çàïèñè;
// dwValue		 - âû÷èòàåìîå èç ñ÷åò÷èêà çíà÷åíèå;
// pucSW1		  áàéò ñòàòóñà;
// pucSW2		  áàéò ñòàòóñà.
//
// Âîçâðàùàåìîå çíà÷åíèå:  0   - óñïåøíîå âûïîëíåíèå,
//                       èíà÷å - îøèáêà ïðè âûïîëíåíèè.
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifarePlus_DecrementTransfer(	IN LPVOID pReader,
														IN BYTE ucLC,
														IN BYTE ucEncryptionMode,
														IN BYTE ucSourceSectorNumber,
														IN BYTE ucSourceBlockNumber,
														IN BYTE ucDestinationSectorNumber,
														IN BYTE ucDestinationBlockNumber,
														IN DWORD dwValue,
														OUT LPBYTE pucSW1,
														OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Mifare Plus: Çàïèñü äàííûõ áëîêà-çíà÷åíèÿ â áóôåð ïåðåíîñà (Transfer Buffer)
//------------------------------------------------------------------------------
//
// Äëÿ êàðòû â ðåæèìå SL3, ïðîèçâîäèò çàïèñü çíà÷åíèÿ óêàçàííîãî áëîêà-çíà÷åíèÿ
// â áóôåð ïåðåíîñà (Transfer Buffer) 
//
// pReader       - ññûëêà íà îáúåêò-èíòåðôåéñ (ñì. ôóíêöèþ CLSCRF_Create );
// ucLC			  ëîãè÷åñêèé êàíàë îò 0 äî 3;
// ucEncryptionMode - ðåæèì çàùèòû äàííûõ (ñì. òàáëèöó);
// ucSourceSectorNumber - íîìåð èñõîäíîãî ñåêòîðà;
// ucSourceBlockNumber - íîìåð èñõîäíîãî áëîêà;
// pucSW1		  áàéò ñòàòóñà;
// pucSW2		  áàéò ñòàòóñà.
//
// Âîçâðàùàåìîå çíà÷åíèå:  0   - óñïåøíîå âûïîëíåíèå,
//                       èíà÷å - îøèáêà ïðè âûïîëíåíèè.
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifarePlus_Restore(	IN LPVOID pReader,
											IN BYTE ucLC,
											IN BYTE ucEncryptionMode,
											IN BYTE ucSourceSectorNumber,
											IN BYTE ucSourceBlockNumber,
											OUT LPBYTE pucSW1,
											OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Mifare Plus: Ïðîèçâîäèò ïðîâåðêó áëèçîñòè êàðòû
//------------------------------------------------------------------------------
//
// Ïðîâåðÿåò, äîñòàòî÷íî ëè áëèçêî îò ñ÷èòûâàòåëÿ ðàñïîëîæåíà êàðòà - çàùèòà îò ðåëåéíûõ àòàê
//
// pReader       - ññûëêà íà îáúåêò-èíòåðôåéñ (ñì. ôóíêöèþ CLSCRF_Create )
// ucLC			  ëîãè÷åñêèé êàíàë îò 0 äî 3;
// ucKeyNumber   - íîìåð Mifare-êëþ÷à â SAM-ìîäóëå îò 1 äî 127;
// ucKeyVersion  - âåðñèÿ Mifare-êëþ÷à â SAM-ìîäóëå îò 0 äî 255;
// ucLenDiv      - äëèíà âõîäíîãî âåêòîðà äèâåðñèôèêàöèè êëþ÷à;
// pbDiv		 - âõîäíîé âåêòîð äèâåðñèôèêàöèè êëþ÷à;
// pucSW1		  áàéò ñòàòóñà;
// pucSW2		  áàéò ñòàòóñà.
//
// Âîçâðàùàåìîå çíà÷åíèå:  0   - óñïåøíîå âûïîëíåíèå
//                       èíà÷å - îøèáêà ïðè âûïîëíåíèè
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifarePlus_ProximityCheck(	IN LPVOID pReader,
													IN BYTE ucLC,
													IN BYTE  ucKeyNumber,
													IN BYTE  ucKeyVersion,
													IN BYTE  ucLenDiv,
													IN LPBYTE pbDiv,
													OUT LPBYTE pucSW1,
													OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Mifare Plus: Ïðîâåðêà ïîääåðæêè âèðòóàëüíûõ êàðò
//------------------------------------------------------------------------------
//
typedef union _CLSCRF_SAM_VC_DUO
{
	struct 
	{
		BYTE ucKeyEncNo;
		BYTE ucKeyEncVer;
		BYTE ucKeyMacNo;
		BYTE ucKeyMacVer;
	};
	DWORD dwBits;
} CLSCRF_SAM_VC_DUO;

//
// Ïðîèçâîäèò ïðîâåðêó ïîääåðæêè âèðòóàëüíûõ êàðò è ïðèíèìàåò õàðàêòèðèñòèêè êàðòû
//
// pReader       - ññûëêà íà îáúåêò-èíòåðôåéñ (ñì. ôóíêöèþ CLSCRF_Create )
// ucLC			  ëîãè÷åñêèé êàíàë îò 0 äî 3;
// ucIIDCount	 - êîëè÷åñòâî ïåðåáèðàåìûõ èäåíòèôèêàòîðîâ èíôðàñòðóêòóðû â ìàññèâå
// IIDs			 - ìàññèâ èäåíòèôèêàòîðîâ èíôðàñòðóêòóðû (16 áàéò * ucIIDCount)
// ucLenCap      - äëèíà áëîêà õàðàêòåðèñòèê ñ÷èòûâàòåëÿ (0..3, óñòàíîâèòü â 0)
// pbPcdCap      - áëîê õàðàêòåðèñòèê ñ÷èòûâàòåëÿ (ïîêà îòñóòñòâóåò)
// ucDuosCount	 - êîëè÷åñòâî ïåðåäàâàåìûõ äëÿ ïðîâåðêè êàðò ïàð êëþ÷åé
// Duos			 - ìàññèâ, ñîñòîÿùèé èç ïàð êëþ÷åé VC Polling ENC Key 
//				   è VC Polling MAC Key, ïðåäñòàâëåííûõ â âèäå íîìåðîâ è 
//				   âåðñèé êëþ÷åé â SAM ìîäóëå
// pbRndQ		 - óêàçàòåëü íà ìàññèâ èç 12 áàéò, â êîòîðûé áóäåò çàïèñàíî çíà÷åíèå
//				   RndQ, èäåíòèôèöèðóþùåå êàðòó â SAM-ìîäóëå
// pucInfo		 - óêàçàòåëü íà áàéòîâóþ ïåðåìåííóþ, â êîòîðóþ áóäåò çàïèñàíà
//				   èíôîðìàöèÿ î êàðòå (0x83 - 4-áàéòîâûé UID, 0x80 - 7-áàéòîâûé UID)
// bpPiccCap	 - óêàçàòåëü íà áóôåð (2 áàéòà), â êîòîðûé áóäóò çàïèñàíû
//				   õàðàêòåðèñòèêà êàðòû
// pbUID		 - óêàçàòåëü íà áóôåð (7 áàéò), â êîòîðûé áóäåò çàïèñàí UID êàðòû
// pucSW1		  áàéò ñòàòóñà;
// pucSW2		  áàéò ñòàòóñà.
//
// Âîçâðàùàåìîå çíà÷åíèå:  0   - óñïåøíîå âûïîëíåíèå
//                       èíà÷å - îøèáêà ïðè âûïîëíåíèè
//
CLSCRF_API LONG CLSCRF_DECL 
            CLSCRF_SAM_MifarePlus_VirtualCardSupport(	IN LPVOID pReader,
														IN BYTE ucLC,
														IN BYTE ucIIDCount,
														IN LPBYTE IIDs,
														IN BYTE ucLenCap,
														IN LPBYTE pbPcdCap,
														IN BYTE ucDuosCount,
														IN CLSCRF_SAM_VC_DUO* Duos,
														OUT LPBYTE pbRndQ,
														OUT LPBYTE pucInfo,
														OUT LPBYTE pbPiccCap,
														OUT LPBYTE pbUID,
														OUT LPBYTE pucSW1,
														OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Mifare Plus: Âûáèðàåò âèðòóàëüíóþ êàðòó
//------------------------------------------------------------------------------
//
// Âûáèðàåò âèðòóàëüíóþ êàðòó 
//
// pReader       - ññûëêà íà îáúåêò-èíòåðôåéñ (ñì. ôóíêöèþ CLSCRF_Create )
// ucLC			  ëîãè÷åñêèé êàíàë îò 0 äî 3;
// ucKeyNumber   - íîìåð Mifare-êëþ÷à â SAM-ìîäóëå îò 1 äî 127;
// ucKeyVersion  - âåðñèÿ Mifare-êëþ÷à â SAM-ìîäóëå îò 0 äî 255;
// pbRndQ		 - óêàçàòåëü íà ìàññèâ èç 12 áàéò, â êîòîðûé çàïèñàíî çíà÷åíèå
//				   RndQ, èäåíòèôèöèðóþùåå êàðòó â SAM-ìîäóëå
// ucLenDiv      - äëèíà âõîäíîãî âåêòîðà äèâåðñèôèêàöèè êëþ÷à;
// pbDiv		 - âõîäíîé âåêòîð äèâåðñèôèêàöèè êëþ÷à;
// pucSW1		  áàéò ñòàòóñà;
// pucSW2		  áàéò ñòàòóñà.
//
// Âîçâðàùàåìîå çíà÷åíèå:  0   - óñïåøíîå âûïîëíåíèå
//                       èíà÷å - îøèáêà ïðè âûïîëíåíèè
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifarePlus_VirtualCardSelect(	IN LPVOID pReader,
														IN BYTE ucLC,
														IN BYTE  ucKeyNumber,
														IN BYTE  ucKeyVersion,
														IN LPBYTE pbRndQ,
														IN BYTE  ucLenDiv,
														IN LPBYTE pbDiv,
														OUT LPBYTE pucSW1,
														OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Mifare Plus: Îòìåíÿåò âûáîð âèðòóàëüíîé êàðòû
//------------------------------------------------------------------------------
//
// Îòìåíÿåò âûáîð âèðòóàëüíîé êàðòû
//
// pReader       - ññûëêà íà îáúåêò-èíòåðôåéñ (ñì. ôóíêöèþ CLSCRF_Create )
// ucLC			  ëîãè÷åñêèé êàíàë îò 0 äî 3;
// pucSW1		  áàéò ñòàòóñà;
// pucSW2		  áàéò ñòàòóñà.
//
// Âîçâðàùàåìîå çíà÷åíèå:  0   - óñïåøíîå âûïîëíåíèå
//                       èíà÷å - îøèáêà ïðè âûïîëíåíèè
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifarePlus_VirtualCardDeselect(	IN LPVOID pReader,
														IN BYTE ucLC,
														OUT LPBYTE pucSW1,
														OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

#pragma pack(pop)

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CLSCRF_H__DE290562_87D9_41F4_A1CD_3B80EFEBA737__INCLUDED_)
