#include "StdAfx.h"

#include "Clscrfl.h"

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_EraseFlash(IN LPVOID pReader)
{
	LONG Status = SCARD_S_SUCCESS;

	DWORD dwPass = 0x87654321;

	if (pReader)
	{
		CTransfer* pTr = (CTransfer*)pReader;
		pTr->m_TrBuf.Clear();
		pTr->m_TrBuf.AddByte(0x70);
		pTr->m_TrBuf.AddBulk((PBYTE)&dwPass, 4);

		Status = pTr->SingleTransceive();

		if (Status == SCARD_S_SUCCESS)
		{
		}
	}
	else
	{
		Status = SCARD_E_READER_UNAVAILABLE;
	}

	return Status;
}

//=====================================================================

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_WriteFlashValue(IN LPVOID pReader,
IN DWORD  dwAddress,
IN LPBYTE  pbValue)
{
	LONG Status = SCARD_S_SUCCESS;

	if (pReader)
	{
		CTransfer* pTr = (CTransfer*)pReader;
		pTr->m_TrBuf.Clear();
		pTr->m_TrBuf.AddByte(0x79);
		pTr->m_TrBuf.AddBulk((PBYTE)&dwAddress, 2);
		pTr->m_TrBuf.AddBulk(pbValue, 16);

		Status = pTr->SingleTransceive();
	}
	else
	{
		Status = SCARD_E_READER_UNAVAILABLE;
	}

	return Status;
}

//=====================================================================

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_CheckFlashValueFilled(IN LPVOID pReader,
IN DWORD  dwFlashAddr,
OUT LPBYTE pbStatus)
{
	LONG Status = SCARD_S_SUCCESS;
	DWORD dwLen = 1;

	if (pReader)
	{
		CTransfer* pTr = (CTransfer*)pReader;
		pTr->m_TrBuf.Clear();
		pTr->m_TrBuf.AddByte(0x6e);
		pTr->m_TrBuf.AddBulk((PBYTE)&dwFlashAddr, 2);

		Status = pTr->SingleTransceive();

		*pbStatus = 1;
		if (Status == SCARD_S_SUCCESS)
		{
			*pbStatus = 0;
		}
		else if (Status == 0x80100001)
		{
			pTr->m_RcBuf.GetBulk(0, pbStatus, &dwLen);

			if (*pbStatus == 0xFF)
				Status = SCARD_S_SUCCESS;
		}
	}
	else
	{
		Status = SCARD_E_READER_UNAVAILABLE;
	}

	return Status;
}

//=====================================================================
/*
CLSCRF_API LONG CLSCRF_DECL
CLSCRF_ReadFlashValue(IN LPVOID pReader,
IN DWORD  dwAddress,
OUT LPBYTE  pbValue)
{
	LONG Status = SCARD_S_SUCCESS;

	DWORD dwLen = 16;

	DWORD dwAddress_raw = (dwAddress + 16) << 4;

	if (pReader)
	{
		CTransfer* pTr = (CTransfer*)pReader;
		pTr->m_TrBuf.Clear();
		pTr->m_TrBuf.AddByte(0x78);
		pTr->m_TrBuf.AddByte(0x00);
		pTr->m_TrBuf.AddBulk((PBYTE)&dwAddress_raw, 2);
		pTr->m_TrBuf.AddBulk((PBYTE)&dwLen, 2);

		Status = pTr->SingleTransceive();

		if (Status == SCARD_S_SUCCESS)
		{
			pTr->m_RcBuf.GetBulk(1, pbValue, &dwLen);
		}
	}
	else
	{
		Status = SCARD_E_READER_UNAVAILABLE;
	}

	return Status;
}
*/

//=====================================================================

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_WriteReaderConfig(IN LPVOID pReader,
IN BYTE ucMemType,
IN BYTE ucAddress,
IN BYTE ucLength,
IN LPBYTE pbValue)
{
	LONG Status = SCARD_S_SUCCESS;

	if (pReader)
	{
		if (ucLength == 0x00)
			return SCARD_E_INVALID_PARAMETER;
		//if ((int)ucAddress + (int)ucLength > (int)0x08)//0x100)
		//	return SCARD_E_INVALID_PARAMETER;
		CTransfer* pTr = (CTransfer*)pReader;
		pTr->m_TrBuf.Clear();
		pTr->m_TrBuf.AddByte(0x68);
		pTr->m_TrBuf.AddByte(0x10 | 0x01 & ucMemType);
		pTr->m_TrBuf.AddByte(ucAddress);
		pTr->m_TrBuf.AddByte(ucLength);
		pTr->m_TrBuf.AddBulk(pbValue, ucLength);

		Status = pTr->SingleTransceive();
	}
	else
	{
		Status = SCARD_E_READER_UNAVAILABLE;
	}

	return Status;
}

//=====================================================================

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_ResetReaderConfig(IN LPVOID pReader,
IN BYTE ucMemType,
IN BYTE ucAddress,
IN BYTE ucLength)
{
	LONG Status = SCARD_S_SUCCESS;

	if (pReader)
	{
		if (ucLength == 0x00)
			return SCARD_E_INVALID_PARAMETER;
		if ((int)ucAddress + (int)ucLength > (int)0x18)//0x100)
			return SCARD_E_INVALID_PARAMETER;
		CTransfer* pTr = (CTransfer*)pReader;
		pTr->m_TrBuf.Clear();
		pTr->m_TrBuf.AddByte(0x68);
		pTr->m_TrBuf.AddByte(0x80 | 0x01 & ucMemType);
		pTr->m_TrBuf.AddByte(ucAddress);
		pTr->m_TrBuf.AddByte(ucLength);

		Status = pTr->SingleTransceive();
	}
	else
	{
		Status = SCARD_E_READER_UNAVAILABLE;
	}

	return Status;
}

//=====================================================================

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_ReadReaderConfig(IN LPVOID pReader,
IN BYTE ucMemType,
IN BYTE ucAddress,
IN BYTE ucLength,
OUT LPBYTE pbValue)
{
	LONG Status = SCARD_S_SUCCESS;

	DWORD dwLen = ucLength;

	if (pReader)
	{
		if (ucLength == 0x00)
			return SCARD_E_INVALID_PARAMETER;
		//if ((int)ucAddress + (int)ucLength > (int)0x08)//0x100)
		//	return SCARD_E_INVALID_PARAMETER;
		CTransfer* pTr = (CTransfer*)pReader;
		pTr->m_TrBuf.Clear();
		pTr->m_TrBuf.AddByte(0x68);
		pTr->m_TrBuf.AddByte(0x01 & ucMemType);
		pTr->m_TrBuf.AddByte(ucAddress);
		pTr->m_TrBuf.AddByte(ucLength);

		Status = pTr->SingleTransceive();

		if (Status == SCARD_S_SUCCESS)
		{
			pTr->m_RcBuf.GetBulk(1, pbValue, &dwLen);
		}
	}
	else
	{
		Status = SCARD_E_READER_UNAVAILABLE;
	}

	return Status;
}


#ifdef CLSCRF_DES3

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_WriteFlash_DES1Keys(IN LPVOID pReader,
IN DWORD  dwKeyNumber,
IN DWORD  dwKeyQuantity,
IN LPBYTE pbKeys)
{
	LONG Status = SCARD_S_SUCCESS;

	if (pReader)
	{
		CTransfer* pTr = (CTransfer*)pReader;
		pTr->m_TrBuf.Clear();
		pTr->m_TrBuf.AddByte(0x6a);
		pTr->m_TrBuf.AddByte(BYTE(dwKeyNumber & 0xff));
		pTr->m_TrBuf.AddByte(BYTE(dwKeyQuantity & 0xff));
		pTr->m_TrBuf.AddBulk(pbKeys, 8 * dwKeyQuantity);

		Status = pTr->SingleTransceive();
	}
	else
	{
		Status = SCARD_E_READER_UNAVAILABLE;
	}

	return Status;
}

#endif //CLSCRF_DES3

/*
#ifdef CLSCRF_DES3
CLSCRF_API LONG CLSCRF_DECL
CLSCRF_WriteFlash_3DES3Key( IN LPVOID pReader,
IN DWORD  dwKeyNumber,
IN LPBYTE pbK24,
IN LPBYTE pbICV8 )
{
LONG Status = SCARD_S_SUCCESS;

if( pReader )
{
CTransfer* pTr = (CTransfer*)pReader;
pTr->m_TrBuf.Clear();
pTr->m_TrBuf.AddByte( 0x6a );
pTr->m_TrBuf.AddByte( BYTE((4*dwKeyNumber) & 0xff) );
pTr->m_TrBuf.AddByte( 4 );
pTr->m_TrBuf.AddBulk( pbK24, 24 );
pTr->m_TrBuf.AddBulk( pbICV8, 8 );

Status = pTr->SingleTransceive();
}
else
{
Status = SCARD_E_READER_UNAVAILABLE;
}

return Status;
}
#endif //CLSCRF_DES3
*/
