#include "StdAfx.h"

#include "Clscrfl.h"

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_MifarePlusEV1_Increment(IN LPVOID pReader,
IN BYTE ucMAConResponse,
IN BYTE ucSourceSectorNumber,
IN BYTE ucSourceBlockNumber,
IN DWORD dwValue)
{
	LONG Status = SCARD_S_SUCCESS;

	if (pReader)
	{
		CTransfer* pTr = (CTransfer*)pReader;
		pTr->m_TrBuf.Clear();
		pTr->m_TrBuf.AddByte(0xE8);
		pTr->m_TrBuf.AddByte(0xB0);
		pTr->m_TrBuf.AddByte(ucMAConResponse);
		pTr->m_TrBuf.AddByte(ucSourceSectorNumber);
		pTr->m_TrBuf.AddByte(ucSourceBlockNumber);
		pTr->m_TrBuf.AddBulk((PBYTE)&dwValue, 4);

		Status = pTr->SingleTransceive();

		if (Status == SCARD_S_SUCCESS)
		{
		}
	}
	else
	{
		Status = SCARD_E_READER_UNAVAILABLE;
	}

	return Status;
}

//=====================================================================

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_MifarePlusEV1_Decrement(IN LPVOID pReader,
IN BYTE ucMAConResponse,
IN BYTE ucSourceSectorNumber,
IN BYTE ucSourceBlockNumber,
IN DWORD dwValue)
{
	LONG Status = SCARD_S_SUCCESS;

	if (pReader)
	{
		CTransfer* pTr = (CTransfer*)pReader;
		pTr->m_TrBuf.Clear();
		pTr->m_TrBuf.AddByte(0xE8);
		pTr->m_TrBuf.AddByte(0xB2);
		pTr->m_TrBuf.AddByte(ucMAConResponse);
		pTr->m_TrBuf.AddByte(ucSourceSectorNumber);
		pTr->m_TrBuf.AddByte(ucSourceBlockNumber);
		pTr->m_TrBuf.AddBulk((PBYTE)&dwValue, 4);

		Status = pTr->SingleTransceive();

		if (Status == SCARD_S_SUCCESS)
		{
		}
	}
	else
	{
		Status = SCARD_E_READER_UNAVAILABLE;
	}

	return Status;
}

//=====================================================================

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_MifarePlusEV1_Transfer(IN LPVOID pReader,
IN BYTE ucMAConResponse,
IN BYTE ucDestinationSectorNumber,
IN BYTE ucDestinationBlockNumber,
OUT PDWORD pdwMACCounter,
OUT PBYTE pMACValue)
{
	LONG Status = SCARD_S_SUCCESS;

	if (pReader)
	{
		CTransfer* pTr = (CTransfer*)pReader;
		pTr->m_TrBuf.Clear();
		pTr->m_TrBuf.AddByte(0xE8);
		pTr->m_TrBuf.AddByte(0xB4);
		pTr->m_TrBuf.AddByte(ucMAConResponse);
		pTr->m_TrBuf.AddByte(ucDestinationSectorNumber);
		pTr->m_TrBuf.AddByte(ucDestinationBlockNumber);

		Status = pTr->SingleTransceive();

		if (Status == SCARD_S_SUCCESS)
		{
			DWORD Size = 1;

			BYTE bStatusCode = 0x00;

			if (pTr->m_RcBuf.GetBulk(0, &bStatusCode, &Size))
			{
				if (bStatusCode == 0x00)
				{
					Size = 4;

					if (!pTr->m_RcBuf.GetBulk(1, (PBYTE)pdwMACCounter, &Size))
						return SCARD_E_UNEXPECTED;

					Size = 8;

					if (!pTr->m_RcBuf.GetBulk(5, pMACValue, &Size))
						return SCARD_E_UNEXPECTED;
				}
			}

		}
	}
	else
	{
		Status = SCARD_E_READER_UNAVAILABLE;
	}

	return Status;
}

//=====================================================================

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_MifarePlusEV1_IncrementTransfer(IN LPVOID pReader,
IN BYTE ucMAConResponse,
IN BYTE ucSourceSectorNumber,
IN BYTE ucSourceBlockNumber,
IN BYTE ucDestinationSectorNumber,
IN BYTE ucDestinationBlockNumber,
IN DWORD dwValue,
OUT PDWORD pdwMACCounter,
OUT PBYTE pMACValue)
{
	LONG Status = SCARD_S_SUCCESS;

	if (pReader)
	{
		CTransfer* pTr = (CTransfer*)pReader;
		pTr->m_TrBuf.Clear();
		pTr->m_TrBuf.AddByte(0xE8);
		pTr->m_TrBuf.AddByte(0xB6);
		pTr->m_TrBuf.AddByte(ucMAConResponse);
		pTr->m_TrBuf.AddByte(ucSourceSectorNumber);
		pTr->m_TrBuf.AddByte(ucSourceBlockNumber);
		pTr->m_TrBuf.AddBulk((PBYTE)&dwValue, 4);
		pTr->m_TrBuf.AddByte(ucDestinationSectorNumber);
		pTr->m_TrBuf.AddByte(ucDestinationBlockNumber);

		Status = pTr->SingleTransceive();

		if (Status == SCARD_S_SUCCESS)
		{
			DWORD Size = 1;

			BYTE bStatusCode = 0x00;

			if (pTr->m_RcBuf.GetBulk(0, &bStatusCode, &Size))
			{
				if (bStatusCode == 0x00)
				{
					Size = 4;

					if (!pTr->m_RcBuf.GetBulk(1, (PBYTE)pdwMACCounter, &Size))
						return SCARD_E_UNEXPECTED;

					Size = 8;

					if (!pTr->m_RcBuf.GetBulk(5, pMACValue, &Size))
						return SCARD_E_UNEXPECTED;
				}
			}

		}
	}
	else
	{
		Status = SCARD_E_READER_UNAVAILABLE;
	}

	return Status;
}

//=====================================================================

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_MifarePlusEV1_DecrementTransfer(IN LPVOID pReader,
IN BYTE ucMAConResponse,
IN BYTE ucSourceSectorNumber,
IN BYTE ucSourceBlockNumber,
IN BYTE ucDestinationSectorNumber,
IN BYTE ucDestinationBlockNumber,
IN DWORD dwValue,
OUT PDWORD pdwMACCounter,
OUT PBYTE pMACValue)
{
	LONG Status = SCARD_S_SUCCESS;

	if (pReader)
	{
		CTransfer* pTr = (CTransfer*)pReader;
		pTr->m_TrBuf.Clear();
		pTr->m_TrBuf.AddByte(0xE8);
		pTr->m_TrBuf.AddByte(0xB8);
		pTr->m_TrBuf.AddByte(ucMAConResponse);
		pTr->m_TrBuf.AddByte(ucSourceSectorNumber);
		pTr->m_TrBuf.AddByte(ucSourceBlockNumber);
		pTr->m_TrBuf.AddBulk((PBYTE)&dwValue, 4);
		pTr->m_TrBuf.AddByte(ucDestinationSectorNumber);
		pTr->m_TrBuf.AddByte(ucDestinationBlockNumber);

		Status = pTr->SingleTransceive();

		if (Status == SCARD_S_SUCCESS)
		{
			DWORD Size = 1;

			BYTE bStatusCode = 0x00;

			if (pTr->m_RcBuf.GetBulk(0, &bStatusCode, &Size))
			{
				if (bStatusCode == 0x00)
				{
					Size = 4;

					if (!pTr->m_RcBuf.GetBulk(1, (PBYTE)pdwMACCounter, &Size))
						return SCARD_E_UNEXPECTED;

					Size = 8;

					if (!pTr->m_RcBuf.GetBulk(5, pMACValue, &Size))
						return SCARD_E_UNEXPECTED;
				}
			}

		}
	}
	else
	{
		Status = SCARD_E_READER_UNAVAILABLE;
	}

	return Status;
}

//=====================================================================

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_MifarePlusEV1_Restore(IN LPVOID pReader,
IN BYTE ucMAConResponse,
IN BYTE ucSourceSectorNumber,
IN BYTE ucSourceBlockNumber)
{
	LONG Status = SCARD_S_SUCCESS;

	if (pReader)
	{
		CTransfer* pTr = (CTransfer*)pReader;
		pTr->m_TrBuf.Clear();
		pTr->m_TrBuf.AddByte(0xE8);
		pTr->m_TrBuf.AddByte(0xC2);
		pTr->m_TrBuf.AddByte(ucMAConResponse);
		pTr->m_TrBuf.AddByte(ucSourceSectorNumber);
		pTr->m_TrBuf.AddByte(ucSourceBlockNumber);

		Status = pTr->SingleTransceive();

		if (Status == SCARD_S_SUCCESS)
		{
		}
	}
	else
	{
		Status = SCARD_E_READER_UNAVAILABLE;
	}

	return Status;
}

//=====================================================================

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_MifarePlusEV1_WriteData(IN LPVOID pReader,
IN BYTE ucEncryptionMode,
IN BYTE ucValueType,
IN BYTE ucSectorNumber,
IN BYTE ucBlockNumber,
IN BYTE ucBlocksCount,
IN LPBYTE pbData,
OUT PDWORD pdwMACCounter,
OUT PBYTE pMACValue)
{
	LONG Status = SCARD_S_SUCCESS;

	if (pReader)
	{
		if (ucBlocksCount < 1)
			ucBlocksCount = 1;

		CTransfer* pTr = (CTransfer*)pReader;
		pTr->m_TrBuf.Clear();
		pTr->m_TrBuf.AddByte(0xE8);
		pTr->m_TrBuf.AddByte(0xA0);
		pTr->m_TrBuf.AddByte(ucEncryptionMode);
		pTr->m_TrBuf.AddByte(ucValueType);
		pTr->m_TrBuf.AddByte(ucSectorNumber);
		pTr->m_TrBuf.AddByte(ucBlockNumber);
		pTr->m_TrBuf.AddByte(ucBlocksCount);
		pTr->m_TrBuf.AddBulk(pbData, (DWORD)ucBlocksCount * 16);

		Status = pTr->SingleTransceive();

		if (Status == SCARD_S_SUCCESS)
		{
			DWORD Size = 1;

			BYTE bStatusCode = 0x00;

			if (pTr->m_RcBuf.GetBulk(0, &bStatusCode, &Size))
			{
				if (bStatusCode == 0x00)
				{
					Size = 4;

					if (!pTr->m_RcBuf.GetBulk(1, (PBYTE)pdwMACCounter, &Size))
						return SCARD_E_UNEXPECTED;

					Size = 8;

					if (!pTr->m_RcBuf.GetBulk(5, pMACValue, &Size))
						return SCARD_E_UNEXPECTED;
				}
			}

		}
	}
	else
	{
		Status = SCARD_E_READER_UNAVAILABLE;
	}

	return Status;
}

//=====================================================================

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_MifarePlusEV1_ReadData(IN LPVOID pReader,
IN BYTE ucEncryptionMode,
IN BYTE ucValueType,
IN BYTE ucSectorNumber,
IN BYTE ucBlockNumber,
IN BYTE ucBlocksCount,
OUT LPBYTE pbData)
{
	LONG Status = SCARD_S_SUCCESS;

	if (pReader)
	{
		if (ucBlocksCount < 1)
			ucBlocksCount = 1;

		CTransfer* pTr = (CTransfer*)pReader;
		pTr->m_TrBuf.Clear();
		pTr->m_TrBuf.AddByte(0xE8);
		pTr->m_TrBuf.AddByte(0x30);
		pTr->m_TrBuf.AddByte(ucEncryptionMode);
		pTr->m_TrBuf.AddByte(ucValueType);
		pTr->m_TrBuf.AddByte(ucSectorNumber);
		pTr->m_TrBuf.AddByte(ucBlockNumber);
		pTr->m_TrBuf.AddByte(ucBlocksCount);

		Status = pTr->SingleTransceive();

		if (Status == SCARD_S_SUCCESS)
		{
			DWORD Size = 1;

			BYTE bStatusCode = 0x00;

			if (pTr->m_RcBuf.GetBulk(0, &bStatusCode, &Size))
			{
				if (bStatusCode == 0x00)
				{
					Size = ucBlocksCount * 16;

					pTr->m_RcBuf.GetBulk(1, pbData, &Size);
				}
			}

		}
	}
	else
	{
		Status = SCARD_E_READER_UNAVAILABLE;
	}

	return Status;
}

//=====================================================================

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_MifarePlusEV1_Authenticate(IN LPVOID pReader,
IN BYTE  ucSecLevel,
IN BYTE  ucTCL,
IN BYTE  ucAuthType,
IN BYTE  ucKeyType,
IN BYTE  ucSectorNumber,
IN DWORD  dwKeyFlashAddress,
IN BYTE  ucLenDIV,
IN LPBYTE pbDIV,
IN BYTE  ucLenCap,
IN OUT LPBYTE pbPcdCap,
OUT LPBYTE pbRetPiccCap)
{
	LONG Status = SCARD_S_SUCCESS;

	if (pReader)
	{
		CTransfer* pTr = (CTransfer*)pReader;
		pTr->m_TrBuf.Clear();
		pTr->m_TrBuf.AddByte(0xE8);
		pTr->m_TrBuf.AddByte(0x72);
		pTr->m_TrBuf.AddByte(ucSecLevel);
		pTr->m_TrBuf.AddByte(ucTCL);
		pTr->m_TrBuf.AddByte(ucAuthType);
		pTr->m_TrBuf.AddByte(ucKeyType);
		pTr->m_TrBuf.AddByte(ucSectorNumber);
		pTr->m_TrBuf.AddBulk((PBYTE)&dwKeyFlashAddress, 2);
		pTr->m_TrBuf.AddByte(ucLenDIV);
		if (ucLenDIV > 0)
			if (pbDIV)
				pTr->m_TrBuf.AddBulk(pbDIV, ucLenDIV);
		pTr->m_TrBuf.AddByte(ucLenCap);
		if (ucLenCap > 0)
			if (pbPcdCap)
				pTr->m_TrBuf.AddBulk(pbPcdCap, ucLenCap);

		Status = pTr->SingleTransceive();

		if (Status == SCARD_S_SUCCESS)
		{
			DWORD Size = 1;

			BYTE bStatusCode = 0x00;

			if (pTr->m_RcBuf.GetBulk(0, &bStatusCode, &Size))
			{
				if ((bStatusCode == 0x00) && (ucAuthType != 0x00))
				{
					Size = 6;

					if (!pTr->m_RcBuf.GetBulk(1, pbPcdCap, &Size))
						return SCARD_E_UNEXPECTED;

					Size = 6;

					if (!pTr->m_RcBuf.GetBulk(7, pbRetPiccCap, &Size))
						return SCARD_E_UNEXPECTED;
				}
			}
		}
	}
	else
	{
		Status = SCARD_E_READER_UNAVAILABLE;
	}

	return Status;
}

//=====================================================================

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_MifarePlusEV1_AuthenticateDirect(IN LPVOID pReader,
IN BYTE  ucSecLevel,
IN BYTE  ucTCL,
IN BYTE  ucAuthType,
IN BYTE  ucKeyType,
IN BYTE  ucSectorNumber,
IN LPBYTE  pbKey,
IN BYTE  ucLenDIV,
IN LPBYTE pbDIV,
IN BYTE  ucLenCap,
IN OUT LPBYTE pbPcdCap,
OUT LPBYTE pbRetPiccCap)
{
	LONG Status = SCARD_S_SUCCESS;

	if (pReader)
	{
		CTransfer* pTr = (CTransfer*)pReader;
		pTr->m_TrBuf.Clear();
		pTr->m_TrBuf.AddByte(0xE8);
		pTr->m_TrBuf.AddByte(0x2D);
		pTr->m_TrBuf.AddByte(ucSecLevel);
		pTr->m_TrBuf.AddByte(ucTCL);
		pTr->m_TrBuf.AddByte(ucAuthType);
		pTr->m_TrBuf.AddByte(ucKeyType);
		pTr->m_TrBuf.AddByte(ucSectorNumber);
		pTr->m_TrBuf.AddBulk(pbKey, 16);
		pTr->m_TrBuf.AddByte(ucLenDIV);
		if (ucLenDIV > 0)
			if (pbDIV)
				pTr->m_TrBuf.AddBulk(pbDIV, ucLenDIV);
		pTr->m_TrBuf.AddByte(ucLenCap);
		if (ucLenCap > 0)
			if (pbPcdCap)
				pTr->m_TrBuf.AddBulk(pbPcdCap, ucLenCap);

		Status = pTr->SingleTransceive();

		if (Status == SCARD_S_SUCCESS)
		{
			DWORD Size = 1;

			BYTE bStatusCode = 0x00;

			if (pTr->m_RcBuf.GetBulk(0, &bStatusCode, &Size))
			{
				if ((bStatusCode == 0x00) && (ucAuthType != 0x00))
				{
					Size = 6;

					if (!pTr->m_RcBuf.GetBulk(1, pbPcdCap, &Size))
						return SCARD_E_UNEXPECTED;

					Size = 6;

					if (!pTr->m_RcBuf.GetBulk(7, pbRetPiccCap, &Size))
						return SCARD_E_UNEXPECTED;
				}
			}
		}
	}
	else
	{
		Status = SCARD_E_READER_UNAVAILABLE;
	}

	return Status;
}

//=====================================================================

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_MifarePlusEV1_CommitReaderID(IN LPVOID pReader,
IN BYTE  ucSectorNumber,
IN BYTE  ucBlockNumber,
IN BYTE  ucTMACNumber,
IN DWORD  dwFlashKeyNumber,
OUT LPBYTE pbEncTMRI)
{
	LONG Status = SCARD_S_SUCCESS;

	if (pReader)
	{
		CTransfer* pTr = (CTransfer*)pReader;
		pTr->m_TrBuf.Clear();
		pTr->m_TrBuf.AddByte(0xE8);
		pTr->m_TrBuf.AddByte(0xC8);
		pTr->m_TrBuf.AddByte(ucSectorNumber);
		pTr->m_TrBuf.AddByte(ucBlockNumber);
		pTr->m_TrBuf.AddByte(ucTMACNumber);
		pTr->m_TrBuf.AddBulk((PBYTE)&dwFlashKeyNumber, 2);

		Status = pTr->SingleTransceive();

		if (Status == SCARD_S_SUCCESS)
		{
			DWORD Size = 1;

			BYTE bStatusCode = 0x00;

			if (pTr->m_RcBuf.GetBulk(0, &bStatusCode, &Size))
			{
				if (bStatusCode == 0x00)
				{
					Size = 16;

					if (!pTr->m_RcBuf.GetBulk(1, pbEncTMRI, &Size))
						return SCARD_E_UNEXPECTED;
				}
			}
		}
	}
	else
	{
		Status = SCARD_E_READER_UNAVAILABLE;
	}

	return Status;
}

//=====================================================================

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_MifarePlusEV1_ProximityCheck(IN LPVOID pReader,
IN BYTE ucSteps,
IN DWORD dwPcKeyNr,
IN BYTE ucGenRndC,
IN LPBYTE pbRndC)
{
	LONG Status = SCARD_S_SUCCESS;

	if (pReader)
	{
		CTransfer* pTr = (CTransfer*)pReader;
		pTr->m_TrBuf.Clear();
		pTr->m_TrBuf.AddByte(0xE8);
		pTr->m_TrBuf.AddByte(0xF2);
		pTr->m_TrBuf.AddByte(ucSteps);
		pTr->m_TrBuf.AddBulk((PBYTE)&dwPcKeyNr, 2);
		pTr->m_TrBuf.AddByte(ucGenRndC);
		if (ucGenRndC == 0)
			pTr->m_TrBuf.AddBulk(pbRndC, 8);

		Status = pTr->SingleTransceive();
	}
	else
	{
		Status = SCARD_E_READER_UNAVAILABLE;
	}

	return Status;
}

//=====================================================================

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_MifarePlusEV1_ISOSelectExternalAuthenticate(IN LPVOID pReader,
IN DWORD  dwEncKeyNr,
IN DWORD  dwMacKeyNr,
IN BYTE  ucLenIID,
IN LPBYTE pbIID,
IN OUT LPDWORD pdwVCDataLength,
OUT LPBYTE pbVCData)
{
	LONG Status = SCARD_S_SUCCESS;

	if (pdwVCDataLength == NULL)
		return SCARD_E_INVALID_PARAMETER;

	if (pbVCData == NULL)
	{
		*pdwVCDataLength = 0;

		return SCARD_E_INVALID_PARAMETER;
	}

	if ((ucLenIID > 0x00) && (pbIID == NULL))
	{
		*pdwVCDataLength = 0;

		return SCARD_E_INVALID_PARAMETER;
	}

	if (pReader == NULL)
	{
		*pdwVCDataLength = 0;

		return SCARD_E_READER_UNAVAILABLE;
	}

	CTransfer* pTr = (CTransfer*)pReader;
	pTr->m_TrBuf.Clear();
	pTr->m_TrBuf.AddByte(0xE8);
	pTr->m_TrBuf.AddByte(0x82);
	pTr->m_TrBuf.AddBulk((PBYTE)&dwEncKeyNr, 2);
	pTr->m_TrBuf.AddBulk((PBYTE)&dwMacKeyNr, 2);
	pTr->m_TrBuf.AddByte(ucLenIID);
	if (ucLenIID > 0)
		if (pbIID)
			pTr->m_TrBuf.AddBulk(pbIID, ucLenIID);

	Status = pTr->SingleTransceive();

	if (Status != SCARD_S_SUCCESS)
	{
		*pdwVCDataLength = 0;

		return Status;
	}

	DWORD Size = pTr->m_RcBuf.GetLength();

	DWORD BufSize = *pdwVCDataLength;

	if (Size < 3)  // Length is absent
	{
		*pdwVCDataLength = 0;

		return SCARD_E_COMM_DATA_LOST;    // 0x8010002F
	}

	Size = 2;

	*pdwVCDataLength = 0;

	if (!pTr->m_RcBuf.GetBulk(1, (LPBYTE)pdwVCDataLength, &Size))
	{
		*pdwVCDataLength = 0;

		return SCARD_E_COMM_DATA_LOST;
	}

	if (*pdwVCDataLength > BufSize)
	{
		*pdwVCDataLength = BufSize;

		return SCARD_E_INSUFFICIENT_BUFFER;
	}

	if (Size = *pdwVCDataLength)
		if (!pTr->m_RcBuf.GetBulk(3, pbVCData, pdwVCDataLength))
			return SCARD_E_COMM_DATA_LOST;

	return Status;
}

//=====================================================================

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_MifarePlusEV1_ISOSelect(IN LPVOID pReader,
IN DWORD  dwEncKeyNr,
IN BYTE  ucLenIID,
IN LPBYTE pbIID,
IN OUT LPDWORD pdwVCDataLength,
OUT LPBYTE pbVCData)
{
	LONG Status = SCARD_S_SUCCESS;

	if (pdwVCDataLength == NULL)
		return SCARD_E_INVALID_PARAMETER;

	if (pbVCData == NULL)
	{
		*pdwVCDataLength = 0;

		return SCARD_E_INVALID_PARAMETER;
	}

	if ((ucLenIID > 0x00) && (pbIID == NULL))
	{
		*pdwVCDataLength = 0;

		return SCARD_E_INVALID_PARAMETER;
	}

	if (pReader == NULL)
	{
		*pdwVCDataLength = 0;

		return SCARD_E_READER_UNAVAILABLE;
	}

	CTransfer* pTr = (CTransfer*)pReader;
	pTr->m_TrBuf.Clear();
	pTr->m_TrBuf.AddByte(0xE8);
	pTr->m_TrBuf.AddByte(0xA4);
	pTr->m_TrBuf.AddBulk((PBYTE)&dwEncKeyNr, 2);
	pTr->m_TrBuf.AddByte(ucLenIID);
	if (ucLenIID > 0)
		if (pbIID)
			pTr->m_TrBuf.AddBulk(pbIID, ucLenIID);

	Status = pTr->SingleTransceive();

	if (Status != SCARD_S_SUCCESS)
	{
		*pdwVCDataLength = 0;

		return Status;
	}

	DWORD Size = pTr->m_RcBuf.GetLength();

	DWORD BufSize = *pdwVCDataLength;

	if (Size < 3)  // Length is absent
	{
		*pdwVCDataLength = 0;

		return SCARD_E_COMM_DATA_LOST;    // 0x8010002F
	}

	Size = 2;

	*pdwVCDataLength = 0;

	if (!pTr->m_RcBuf.GetBulk(1, (LPBYTE)pdwVCDataLength, &Size))
	{
		*pdwVCDataLength = 0;

		return SCARD_E_COMM_DATA_LOST;
	}

	if (*pdwVCDataLength > BufSize)
	{
		*pdwVCDataLength = BufSize;

		return SCARD_E_INSUFFICIENT_BUFFER;
	}

	if (Size = *pdwVCDataLength)
		if (!pTr->m_RcBuf.GetBulk(3, pbVCData, pdwVCDataLength))
			return SCARD_E_COMM_DATA_LOST;

	return Status;
}

//=====================================================================

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_MifarePlusEV1_VirtualCardSupportLastISOL3(IN LPVOID pReader,
IN LPBYTE  pIID,
IN LPBYTE pbPcdCapL3,
OUT PBYTE pucInfo)
{
	LONG Status = SCARD_S_SUCCESS;

	if (pReader)
	{
		CTransfer* pTr = (CTransfer*)pReader;
		pTr->m_TrBuf.Clear();
		pTr->m_TrBuf.AddByte(0xE8);
		pTr->m_TrBuf.AddByte(0x4B);
		pTr->m_TrBuf.AddBulk(pIID, 16);
		pTr->m_TrBuf.AddBulk(pbPcdCapL3, 4);

		Status = pTr->SingleTransceive();

		if (Status == SCARD_S_SUCCESS)
		{
			DWORD dwSize = 1;

			BYTE bStatusCode = 0x00;

			if (pTr->m_RcBuf.GetBulk(0, &bStatusCode, &dwSize))
			{
				if (bStatusCode == 0x00)
				{
					dwSize = 1;

					if (!pTr->m_RcBuf.GetBulk(1, pucInfo, &dwSize))
						return SCARD_E_UNEXPECTED;
				}
			}
		}
	}
	else
	{
		Status = SCARD_E_READER_UNAVAILABLE;
	}

	return Status;
}

//=====================================================================

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_MifarePlusEV1_AuthenticateSectorSwitch(IN LPVOID pReader,
IN BYTE ucL1L3,
IN DWORD  dwSSKeyNr,
IN BYTE ucSector,
IN DWORD  dwSKeyBNr,
IN BYTE  ucLSS,
IN LPBYTE pbDISS,
IN BYTE  ucLSK,
IN LPBYTE pbDISK)
{
	LONG Status = SCARD_S_SUCCESS;

	if (pReader)
	{
		CTransfer* pTr = (CTransfer*)pReader;
		pTr->m_TrBuf.Clear();
		pTr->m_TrBuf.AddByte(0xE8);
		pTr->m_TrBuf.AddByte(0x7A);
		pTr->m_TrBuf.AddByte(ucL1L3);
		pTr->m_TrBuf.AddBulk((PBYTE)&dwSSKeyNr, 2);
		pTr->m_TrBuf.AddByte(ucSector);
		pTr->m_TrBuf.AddBulk((PBYTE)&dwSKeyBNr, 2);
		pTr->m_TrBuf.AddByte(ucLSS);
		pTr->m_TrBuf.AddBulk((PBYTE)&pbDISS, ucLSS);
		pTr->m_TrBuf.AddByte(ucLSK);
		pTr->m_TrBuf.AddBulk((PBYTE)&pbDISK, ucLSK);

		Status = pTr->SingleTransceive();

		if (Status == SCARD_S_SUCCESS)
		{
		}
	}
	else
	{
		Status = SCARD_E_READER_UNAVAILABLE;
	}

	return Status;
}

//=====================================================================

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_MifarePlusEV1_MF_PersonalizeUID(IN LPVOID pReader,
IN BYTE  ucUidType)
{
	LONG Status = SCARD_S_SUCCESS;

	if (pReader)
	{
		CTransfer* pTr = (CTransfer*)pReader;
		pTr->m_TrBuf.Clear();
		pTr->m_TrBuf.AddByte(0xE8);
		pTr->m_TrBuf.AddByte(0x40);
		pTr->m_TrBuf.AddByte(ucUidType);

		Status = pTr->SingleTransceive();

		if (Status == SCARD_S_SUCCESS)
		{
		}
	}
	else
	{
		Status = SCARD_E_READER_UNAVAILABLE;
	}

	return Status;
}

//=====================================================================

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_MifarePlusEV1_SetConfigSL1(IN LPVOID pReader,
IN BYTE  ucT_CL_Disable)
{
	LONG Status = SCARD_S_SUCCESS;

	if (pReader)
	{
		CTransfer* pTr = (CTransfer*)pReader;
		pTr->m_TrBuf.Clear();
		pTr->m_TrBuf.AddByte(0xE8);
		pTr->m_TrBuf.AddByte(0x44);
		pTr->m_TrBuf.AddByte(ucT_CL_Disable);

		Status = pTr->SingleTransceive();

		if (Status == SCARD_S_SUCCESS)
		{
		}
	}
	else
	{
		Status = SCARD_E_READER_UNAVAILABLE;
	}

	return Status;
}

//=====================================================================

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_MifarePlusEV1_WritePerso(IN LPVOID pReader,
IN BYTE  ucT_CL,
IN BYTE  ucValueType,
IN BYTE  ucSectorNumber,
IN BYTE  ucBlockNumber,
IN BYTE  ucBlocksCount,
IN LPBYTE pData)
{
	LONG Status = SCARD_S_SUCCESS;

	if (pReader)
	{
		CTransfer* pTr = (CTransfer*)pReader;
		pTr->m_TrBuf.Clear();
		pTr->m_TrBuf.AddByte(0xE8);
		pTr->m_TrBuf.AddByte(0xA8);
		pTr->m_TrBuf.AddByte(ucT_CL);
		pTr->m_TrBuf.AddByte(ucValueType);
		pTr->m_TrBuf.AddByte(ucSectorNumber);
		pTr->m_TrBuf.AddByte(ucBlockNumber);
		pTr->m_TrBuf.AddByte(ucBlocksCount);
		pTr->m_TrBuf.AddBulk(pData, ucBlocksCount * 16);

		Status = pTr->SingleTransceive();
	}
	else
	{
		Status = SCARD_E_READER_UNAVAILABLE;
	}

	return Status;
}

//=====================================================================

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_MifarePlusEV1_CommitPerso(IN LPVOID pReader,
IN BYTE  ucOption,
IN BYTE  ucT_CL)
{
	LONG Status = SCARD_S_SUCCESS;

	DWORD dwPass = 0x87654321;

	if (pReader)
	{
		CTransfer* pTr = (CTransfer*)pReader;
		pTr->m_TrBuf.Clear();
		pTr->m_TrBuf.AddByte(0xE8);
		pTr->m_TrBuf.AddByte(0xAA);
		pTr->m_TrBuf.AddByte(ucOption);
		pTr->m_TrBuf.AddByte(ucT_CL);
		pTr->m_TrBuf.AddBulk((PBYTE)&dwPass, 4);

		Status = pTr->SingleTransceive();
	}
	else
	{
		Status = SCARD_E_READER_UNAVAILABLE;
	}

	return Status;
}

//=====================================================================

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_MifarePlusEV1_GetVersion(IN LPVOID pReader,
OUT LPBYTE pbVerInfo)
{
	LONG Status = SCARD_S_SUCCESS;

	if (pReader)
	{
		CTransfer* pTr = (CTransfer*)pReader;
		pTr->m_TrBuf.Clear();
		pTr->m_TrBuf.AddByte(0xE8);
		pTr->m_TrBuf.AddByte(0x60);

		Status = pTr->SingleTransceive();

		if (Status == SCARD_S_SUCCESS)
		{
			DWORD Size = 1;

			BYTE bStatusCode = 0x00;

			if (pTr->m_RcBuf.GetBulk(0, &bStatusCode, &Size))
			{
				if (bStatusCode == 0x00)
				{
					Size = 28;

					if (!pTr->m_RcBuf.GetBulk(1, pbVerInfo, &Size))
						return SCARD_E_UNEXPECTED;
				}
			}
		}
	}
	else
	{
		Status = SCARD_E_READER_UNAVAILABLE;
	}

	return Status;
}

//=====================================================================

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_MifarePlusEV1_ReadSignature(IN LPVOID pReader,
IN BYTE  ucT_CL,
IN BYTE  ucAddr,
OUT LPBYTE pbSign)
{
	LONG Status = SCARD_S_SUCCESS;

	if (pReader)
	{
		ucAddr = 0x00; // RFU

		CTransfer* pTr = (CTransfer*)pReader;
		pTr->m_TrBuf.Clear();
		pTr->m_TrBuf.AddByte(0xE8);
		pTr->m_TrBuf.AddByte(0x3C);
		pTr->m_TrBuf.AddByte(ucT_CL);
		pTr->m_TrBuf.AddByte(ucAddr);

		Status = pTr->SingleTransceive();

		if (Status == SCARD_S_SUCCESS)
		{
			DWORD Size = 1;

			BYTE bStatusCode = 0x00;

			if (pTr->m_RcBuf.GetBulk(0, &bStatusCode, &Size))
			{
				if (bStatusCode == 0x00)
				{
					Size = 56;

					if (!pTr->m_RcBuf.GetBulk(1, pbSign, &Size))
						return SCARD_E_UNEXPECTED;
				}
			}
		}
	}
	else
	{
		Status = SCARD_E_READER_UNAVAILABLE;
	}

	return Status;
}

//=====================================================================

