#ifndef NdefMessage_h
#define NdefMessage_h

#include "Ndef.h"
#include "NdefRecord.h"

#define MAX_NDEF_RECORDS 4

class NdefMessage
{
    public:
        NdefMessage(void);
        NdefMessage(const byte *data, const int numBytes);
        NdefMessage(NdefMessage* rhs);
        ~NdefMessage();
        NdefMessage* operator=(NdefMessage* rhs);

        int getEncodedSize(); // need so we can pass array to encode
        void encode(byte *data);

        boolean addRecord(NdefRecord* record);
        //void addMimeMediaRecord(CString mimeType, CString payload);
        void addMimeMediaRecord(std::string mimeType, std::string payload);
        //void addMimeMediaRecord(CString mimeType, byte *payload, int payloadLength);
        void addMimeMediaRecord(std::string mimeType, byte *payload, int payloadLength);
        //void addTextRecord(CString text);
        void addTextRecord(std::string text);
        //void addTextRecord(CString text, CString encoding);
        void addTextRecord(std::string text, std::string encoding);
        //void addUriRecord(CString uri);
        void addUriRecord(std::string uri);
        void addEmptyRecord();

        unsigned int getRecordCount();
        NdefRecord* getRecord(int index);
        NdefRecord* operator[](int index);

        void print();
    private:
        NdefRecord* _records[MAX_NDEF_RECORDS];
        unsigned int _recordCount;
};

#endif
