#ifndef Tlv_h
#define Tlv_h

//#include "afxcoll.h"

//#define BYTE unsigned char

//#define UINT64 ULONG64

class Tlv;

typedef std::vector<Tlv*> TlvList;

class Tlv
{
public:
	enum TlvType
	{
		Null = 0x00,
		LockControl = 0x01,
		MemoryControl = 0x02,
		NDEF = 0x03,
		Proprietary = 0xFD,
		Terminator = 0xFE
	};

protected:
	BYTE m_type;
	//CByteArray* m_value;
	std::vector<BYTE>* m_value;

public:
	Tlv();
	//Tlv(BYTE type, CByteArray* value = new CByteArray());
	Tlv(BYTE type, std::vector<BYTE>* value = new std::vector<BYTE>());
	virtual ~Tlv();

	BYTE type() const;
	UINT64 length() const;
	//CByteArray* value();
	std::vector<BYTE>* value();

	//CByteArray* toByteArray();
	std::vector<BYTE>* toByteArray();

	//static TlvList* fromByteArray(CByteArray* data, UINT64 offset = 0);
	static TlvList* fromByteArray(std::vector<BYTE>* data, UINT64 offset = 0);

	static Tlv* createNullTlv();
	static Tlv* createTerminatorTlv();
	//static Tlv* createNDEFMessageTlv(CByteArray* msg);
	static Tlv* createNDEFMessageTlv(std::vector<BYTE>* msg);
	static Tlv* createLockControlTlv();
};

#endif
