#ifndef AES_128_H
#define AES_128_H

#include "types_def.h"

//  input[]   inputLength  key[16]   bc    iv[16],
//   ISO 10126,    output[],     
unsigned int aes_128_encrypt_cbc_mod(unsigned char input[], unsigned int inputLength, unsigned char key[], unsigned char iv[], 
                                 unsigned char output[]);

unsigned int aes_128_encrypt_cbc(unsigned char input[], unsigned int inputLength, unsigned char key[], unsigned char iv[], 
                                 unsigned char output[], unsigned char *iv_result = NULL, unsigned char *mac_key = NULL);

unsigned int aes_192_encrypt_cbc(unsigned char input[], unsigned int inputLength, unsigned char key[], unsigned char iv[], 
                                 unsigned char output[], unsigned char *iv_result = NULL, unsigned char *mac_key = NULL);

//  input[]   inputLength  key[16]   cbc    iv[16],
//   ISO 10126,    output[],     
unsigned int aes_128_decrypt_cbc_mod(unsigned char input[], unsigned int inputLength, unsigned char key[], unsigned char iv[], 
                                 unsigned char output[]);

unsigned int aes_128_decrypt_cbc(unsigned char input[], unsigned int inputLength, unsigned char key[], unsigned char iv[], 
                                 unsigned char output[], unsigned char *iv_result = NULL, unsigned char *mac_key = NULL);

//  input[16]  key[16],
//   output[16]
void aes_128_encrypt16(unsigned char input[], unsigned char key[], unsigned char output[]);

//  input[24]  key[24],
//   output[24]
void aes_192_encrypt24(unsigned char input[], unsigned char key[], unsigned char output[]);

//  input[16]  key[16],
//   output[16]
void aes_128_decrypt16(unsigned char input[], unsigned char key[], unsigned char output[]);

//  input[24]  key[24],
//   output[24]
void aes_192_decrypt24(unsigned char input[], unsigned char key[], unsigned char output[]);

//  input[32]  key[16]   cbc    iv[16],
//   output[32]
void aes_128_encrypt32_cbc(unsigned char input[], unsigned char key[], unsigned char iv[], unsigned char output[]);

//  input[32]  key[16]   cbc    iv[16],
//   output[32]
void aes_128_decrypt32_cbc(unsigned char input[], unsigned char key[], unsigned char iv[], unsigned char output[]);

//////////////// MAC ///////////////////////
void xor_128(BYTE *a, BYTE *b, BYTE *out);

void xor_192(BYTE *a, BYTE *b, BYTE *out);

void xor_size(BYTE *a, BYTE *b, BYTE *out, BYTE Size);

void leftshift_onebit(BYTE *input, BYTE *output, BYTE Size);

void generate_subkey(BYTE *key, BYTE *K1, BYTE *K2);

//void AES_128_CBC_En_MAC( BYTE* pInp, int BlockQty, BYTE* pKey, BYTE* pOut, BYTE* pIV = NULL );
void AES_128_CBC_En_MAC( unsigned char* pInp, int ByteSize, unsigned char* pKey, unsigned char* pOut );

void AES_192_CBC_En_MAC( BYTE* pInp, int BlockQty, BYTE* pKey, BYTE* pOut, BYTE* pIV = NULL );

#endif
