#if !defined(CRC32_H)
#define CRC32_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "types_def.h"

// calculate the value of 16-bit CRC, CRC-16 or CRC-CCITT 
 //unsigned short CRC_16 (unsigned char * aData, unsigned long aSize);

 // calculate the 32-bit CRC-32 value 
 //unsigned long CRC_32 (unsigned char * aData, unsigned long aSize);


/*
 #define POLY16 0x1021

class crc16 {

 public:
  crc16::crc16( void );
  crc16::~crc16();
  void crc16::init_crc16( void );
  int crc16::return_crc16( void );
  void crc16::calc_crc16( unsigned char byte_in );
  int crc16::return_byte_count( void );
 private:
  int crc16::crc_running;
  int crc16::byte_count;

};
*/
#define CRC_A 1
#define CRC_B 2
//#define BYTE unsigned char
unsigned short UpdateCrc(unsigned char ch, unsigned short *lpwCrc);

void ComputeCrc(int CRCType, char *Data, int Length,
BYTE *TransmitFirst, BYTE *TransmitSecond);

//unsigned long getCRC (char *pchBuf, int nBufLen);
/*
class CRC_32
{
public:
	ULONG Table[256];
	CRC_32();
	ULONG Reflect(ULONG ref, char ch);
	void Calculate(const LPBYTE buffer, UINT size, ULONG &CRC);
};
*/
/*
class CRC32
{
public:
	void Init_CRC32_Table();
	ULONG Reflect(ULONG ref, char ch);
	int Get_CRC(unsigned char* buffer, DWORD dwSize);
	ULONG crc32_table[256];  // Lookup table array 
};
*/

#define u32 ULONG
#define uint_t UINT
#define u8 BYTE

class CRC32 //: public HashBase
{
public:
    //=========================================
    //  ctors
    inline CRC32()                                  { Reset();                  }
    inline CRC32(const void* buf,uint_t siz)        { Reset(); Hash(buf,siz);   }

    //=========================================
    // implicit cast, so that you can do something like foo = CRC(dat,siz);
    inline operator u32 () const                    { return Get();             }

    //=========================================
    // getting the crc
	inline u32          Get() const                 { return mCrc;}//~mCrc;             }

    //=========================================
    // HashBase stuff
    virtual void        Reset()                     { mCrc = (ULONG)~0;                }
    virtual void        Hash(const void* buf,uint_t siz);

private:
    u32         mCrc;
    static bool mTableBuilt;
    static u32  mTable[0x100];

    static const u32        POLYNOMIAL = 0x04C11DB7;

private:
    //=========================================
    // internal support
    static void         BuildTable();
    static u32          Reflect(u32 v,int bits);
};

#endif // !defined(CRC32_H)
